require '_h2ph_pre.ph';

unless(defined(&_CAM_CAM_H)) {
    eval 'sub _CAM_CAM_H () {1;}' unless defined(&_CAM_CAM_H);
    if(defined(&KERNEL)) {
	require 'opt_cam.ph';
    }
    require 'sys/cdefs.ph';
    eval 'sub CAM_XPT_PATH_ID () {(( &path_id_t)~0);}' unless defined(&CAM_XPT_PATH_ID);
    eval 'sub CAM_BUS_WILDCARD () {(( &path_id_t)~0);}' unless defined(&CAM_BUS_WILDCARD);
    eval 'sub CAM_TARGET_WILDCARD () {(( &target_id_t)~0);}' unless defined(&CAM_TARGET_WILDCARD);
    eval 'sub CAM_LUN_WILDCARD () {(( &lun_id_t)~0);}' unless defined(&CAM_LUN_WILDCARD);
    eval 'sub CAM_MAX_CDBLEN () {16;}' unless defined(&CAM_MAX_CDBLEN);
    eval 'sub CAM_PRIORITY_NONE () {( &u_int32_t)-1;}' unless defined(&CAM_PRIORITY_NONE);
    eval 'sub CAM_UNQUEUED_INDEX () {-1;}' unless defined(&CAM_UNQUEUED_INDEX);
    eval 'sub CAM_ACTIVE_INDEX () {-2;}' unless defined(&CAM_ACTIVE_INDEX);
    eval 'sub CAM_DONEQ_INDEX () {-3;}' unless defined(&CAM_DONEQ_INDEX);
    eval 'sub GENERATIONCMP {
        local($x, $op, $y) = @_;
	    eval q(((($x) - ($y)) $op 0));
    }' unless defined(&GENERATIONCMP);
    eval("sub CAM_FLAG_NONE () { 0x00; }") unless defined(&CAM_FLAG_NONE);
    eval("sub CAM_EXPECT_INQ_CHANGE () { 0x01; }") unless defined(&CAM_EXPECT_INQ_CHANGE);
    eval("sub CAM_REQ_INPROG () { 0; }") unless defined(&CAM_REQ_INPROG);
    eval("sub CAM_REQ_CMP () { 1; }") unless defined(&CAM_REQ_CMP);
    eval("sub CAM_REQ_ABORTED () { 2; }") unless defined(&CAM_REQ_ABORTED);
    eval("sub CAM_UA_ABORT () { 3; }") unless defined(&CAM_UA_ABORT);
    eval("sub CAM_REQ_CMP_ERR () { 4; }") unless defined(&CAM_REQ_CMP_ERR);
    eval("sub CAM_BUSY () { 5; }") unless defined(&CAM_BUSY);
    eval("sub CAM_REQ_INVALID () { 6; }") unless defined(&CAM_REQ_INVALID);
    eval("sub CAM_PATH_INVALID () { 7; }") unless defined(&CAM_PATH_INVALID);
    eval("sub CAM_DEV_NOT_THERE () { 8; }") unless defined(&CAM_DEV_NOT_THERE);
    eval("sub CAM_UA_TERMIO () { 9; }") unless defined(&CAM_UA_TERMIO);
    eval("sub CAM_SEL_TIMEOUT () { 10; }") unless defined(&CAM_SEL_TIMEOUT);
    eval("sub CAM_CMD_TIMEOUT () { 11; }") unless defined(&CAM_CMD_TIMEOUT);
    eval("sub CAM_SCSI_STATUS_ERROR () { 12; }") unless defined(&CAM_SCSI_STATUS_ERROR);
    eval("sub CAM_MSG_REJECT_REC () { 13; }") unless defined(&CAM_MSG_REJECT_REC);
    eval("sub CAM_SCSI_BUS_RESET () { 14; }") unless defined(&CAM_SCSI_BUS_RESET);
    eval("sub CAM_UNCOR_PARITY () { 15; }") unless defined(&CAM_UNCOR_PARITY);
    eval("sub CAM_AUTOSENSE_FAIL () { 0x10; }") unless defined(&CAM_AUTOSENSE_FAIL);
    eval("sub CAM_NO_HBA () { 1; }") unless defined(&CAM_NO_HBA);
    eval("sub CAM_DATA_RUN_ERR () { 2; }") unless defined(&CAM_DATA_RUN_ERR);
    eval("sub CAM_UNEXP_BUSFREE () { 3; }") unless defined(&CAM_UNEXP_BUSFREE);
    eval("sub CAM_SEQUENCE_FAIL () { 4; }") unless defined(&CAM_SEQUENCE_FAIL);
    eval("sub CAM_CCB_LEN_ERR () { 5; }") unless defined(&CAM_CCB_LEN_ERR);
    eval("sub CAM_PROVIDE_FAIL () { 6; }") unless defined(&CAM_PROVIDE_FAIL);
    eval("sub CAM_BDR_SENT () { 7; }") unless defined(&CAM_BDR_SENT);
    eval("sub CAM_REQ_TERMIO () { 8; }") unless defined(&CAM_REQ_TERMIO);
    eval("sub CAM_UNREC_HBA_ERROR () { 9; }") unless defined(&CAM_UNREC_HBA_ERROR);
    eval("sub CAM_REQ_TOO_BIG () { 10; }") unless defined(&CAM_REQ_TOO_BIG);
    eval("sub CAM_REQUEUE_REQ () { 11; }") unless defined(&CAM_REQUEUE_REQ);
    eval("sub CAM_IDE () { 0x33; }") unless defined(&CAM_IDE);
    eval("sub CAM_RESRC_UNAVAIL () { 1; }") unless defined(&CAM_RESRC_UNAVAIL);
    eval("sub CAM_UNACKED_EVENT () { 2; }") unless defined(&CAM_UNACKED_EVENT);
    eval("sub CAM_MESSAGE_RECV () { 3; }") unless defined(&CAM_MESSAGE_RECV);
    eval("sub CAM_INVALID_CDB () { 4; }") unless defined(&CAM_INVALID_CDB);
    eval("sub CAM_LUN_INVALID () { 5; }") unless defined(&CAM_LUN_INVALID);
    eval("sub CAM_TID_INVALID () { 6; }") unless defined(&CAM_TID_INVALID);
    eval("sub CAM_FUNC_NOTAVAIL () { 7; }") unless defined(&CAM_FUNC_NOTAVAIL);
    eval("sub CAM_NO_NEXUS () { 8; }") unless defined(&CAM_NO_NEXUS);
    eval("sub CAM_IID_INVALID () { 9; }") unless defined(&CAM_IID_INVALID);
    eval("sub CAM_CDB_RECVD () { 10; }") unless defined(&CAM_CDB_RECVD);
    eval("sub CAM_LUN_ALRDY_ENA () { 11; }") unless defined(&CAM_LUN_ALRDY_ENA);
    eval("sub CAM_SCSI_BUSY () { 12; }") unless defined(&CAM_SCSI_BUSY);
    eval("sub CAM_DEV_QFRZN () { 0x40; }") unless defined(&CAM_DEV_QFRZN);
    eval("sub CAM_AUTOSNS_VALID () { 0x80; }") unless defined(&CAM_AUTOSNS_VALID);
    eval("sub CAM_RELEASE_SIMQ () { 0x100; }") unless defined(&CAM_RELEASE_SIMQ);
    eval("sub CAM_SIM_QUEUED () { 0x200; }") unless defined(&CAM_SIM_QUEUED);
    eval("sub CAM_STATUS_MASK () { 0x3F; }") unless defined(&CAM_STATUS_MASK);
    if(defined(&KERNEL)) {
    }
}
1;
