require '_h2ph_pre.ph';

require 'errno.ph';
unless(defined(&errno)) {
}
require 'iolibio.ph';
if(defined ( &__STDC__) || defined ( &_AIX) || (defined ( &__mips)  && defined ( &_SYSTYPE_SVR4)) || defined( &__cplusplus)) {
    eval 'sub AND () {,;}' unless defined(&AND);
    eval 'sub DEFUN {
        local($name, $arglist, $args) = @_;
	    eval q($name($args));
    }' unless defined(&DEFUN);
    eval 'sub DEFUN_VOID {
        local($name) = @_;
	    eval q($name( &void));
    }' unless defined(&DEFUN_VOID);
} else {
    eval 'sub AND () {;;}' unless defined(&AND);
    unless(defined(&const)) {
	eval 'sub const () {1;}' unless defined(&const);
    }
    eval 'sub DEFUN {
        local($name, $arglist, $args) = @_;
	    eval q($name $arglist $args;);
    }' unless defined(&DEFUN);
    eval 'sub DEFUN_VOID {
        local($name) = @_;
	    eval q($name());
    }' unless defined(&DEFUN_VOID);
}
if(defined(&__cplusplus)) {
}
unless(defined(&_IO_seek_set)) {
    sub _IO_seek_set () {	0;}
}
unless(defined(&_IO_seek_cur)) {
    sub _IO_seek_cur () {	1;}
}
unless(defined(&_IO_seek_end)) {
    sub _IO_seek_end () {	2;}
}
unless(defined(&_IO_JUMPS)) {
    sub _IO_JUMPS {
	local($THIS) = @_;
	eval q((($THIS))-> &vtable);
    }
}
if(defined(&_G_USING_THUNKS)) {
    eval 'sub JUMP_FIELD {
        local($TYPE, $NAME) = @_;
	    eval q($TYPE $NAME);
    }' unless defined(&JUMP_FIELD);
    eval 'sub JUMP0 {
        local($FUNC, $THIS) = @_;
	    eval q( &_IO_JUMPS($THIS)->$FUNC($THIS));
    }' unless defined(&JUMP0);
    eval 'sub JUMP1 {
        local($FUNC, $THIS, $X1) = @_;
	    eval q( &_IO_JUMPS($THIS)->$FUNC($THIS, $X1));
    }' unless defined(&JUMP1);
    eval 'sub JUMP2 {
        local($FUNC, $THIS, $X1, $X2) = @_;
	    eval q( &_IO_JUMPS($THIS)->$FUNC($THIS, $X1, $X2));
    }' unless defined(&JUMP2);
    eval 'sub JUMP3 {
        local($FUNC, $THIS, $X1,$X2,$X3) = @_;
	    eval q( &_IO_JUMPS($THIS)->$FUNC($THIS, $X1,$X2, $X3));
    }' unless defined(&JUMP3);
    eval 'sub JUMP_INIT {
        local($NAME, $VALUE) = @_;
	    eval q($VALUE);
    }' unless defined(&JUMP_INIT);
    eval 'sub JUMP_INIT_DUMMY () { &JUMP_INIT( &dummy, 0),  &JUMP_INIT( &dummy2, 0);}' unless defined(&JUMP_INIT_DUMMY);
} else {
    eval 'sub JUMP_FIELD {
        local($TYPE, $NAME) = @_;
	    eval q(\'struct struct\' { \'short delta1\',  &delta2; $TYPE  &pfn; } $NAME);
    }' unless defined(&JUMP_FIELD);
    eval 'sub JUMP0 {
        local($FUNC, $THIS) = @_;
	    eval q( &_IO_JUMPS($THIS)-> ($FUNC->{pfn})($THIS));
    }' unless defined(&JUMP0);
    eval 'sub JUMP1 {
        local($FUNC, $THIS, $X1) = @_;
	    eval q( &_IO_JUMPS($THIS)-> ($FUNC->{pfn})($THIS, $X1));
    }' unless defined(&JUMP1);
    eval 'sub JUMP2 {
        local($FUNC, $THIS, $X1, $X2) = @_;
	    eval q( &_IO_JUMPS($THIS)-> ($FUNC->{pfn})($THIS, $X1, $X2));
    }' unless defined(&JUMP2);
    eval 'sub JUMP3 {
        local($FUNC, $THIS, $X1,$X2,$X3) = @_;
	    eval q( &_IO_JUMPS($THIS)-> ($FUNC->{pfn})($THIS, $X1,$X2, $X3));
    }' unless defined(&JUMP3);
    eval 'sub JUMP_INIT {
        local($NAME, $VALUE) = @_;
	    eval q({0, 0, $VALUE});
    }' unless defined(&JUMP_INIT);
    eval 'sub JUMP_INIT_DUMMY () { &JUMP_INIT( &dummy, 0);}' unless defined(&JUMP_INIT_DUMMY);
}
unless(defined(&_IO_FINISH)) {
    sub _IO_FINISH {
	local($FP) = @_;
	eval q( &JUMP0( &__finish, $FP));
    }
}
unless(defined(&_IO_OVERFLOW)) {
    sub _IO_OVERFLOW {
	local($FP, $CH) = @_;
	eval q( &JUMP1( &__overflow, $FP, $CH));
    }
}
unless(defined(&_IO_UNDERFLOW)) {
    sub _IO_UNDERFLOW {
	local($FP) = @_;
	eval q( &JUMP0( &__underflow, $FP));
    }
}
unless(defined(&_IO_UFLOW)) {
    sub _IO_UFLOW {
	local($FP) = @_;
	eval q( &JUMP0( &__uflow, $FP));
    }
}
unless(defined(&_IO_PBACKFAIL)) {
    sub _IO_PBACKFAIL {
	local($FP, $CH) = @_;
	eval q( &JUMP1( &__pbackfail, $FP, $CH));
    }
}
unless(defined(&_IO_XSPUTN)) {
    sub _IO_XSPUTN {
	local($FP, $DATA, $N) = @_;
	eval q( &JUMP2( &__xsputn, $FP, $DATA, $N));
    }
}
unless(defined(&_IO_XSGETN)) {
    sub _IO_XSGETN {
	local($FP, $DATA, $N) = @_;
	eval q( &JUMP2( &__xsgetn, $FP, $DATA, $N));
    }
}
unless(defined(&_IO_SEEKOFF)) {
    sub _IO_SEEKOFF {
	local($FP, $OFF, $DIR, $MODE) = @_;
	eval q( &JUMP3( &__seekoff, $FP, $OFF, $DIR, $MODE));
    }
}
unless(defined(&_IO_SEEKPOS)) {
    sub _IO_SEEKPOS {
	local($FP, $POS, $FLAGS) = @_;
	eval q( &JUMP2( &__seekpos, $FP, $POS, $FLAGS));
    }
}
unless(defined(&_IO_SETBUF)) {
    sub _IO_SETBUF {
	local($FP, $BUFFER, $LENGTH) = @_;
	eval q( &JUMP2( &__setbuf, $FP, $BUFFER, $LENGTH));
    }
}
unless(defined(&_IO_SYNC)) {
    sub _IO_SYNC {
	local($FP) = @_;
	eval q( &JUMP0( &__sync, $FP));
    }
}
unless(defined(&_IO_DOALLOCATE)) {
    sub _IO_DOALLOCATE {
	local($FP) = @_;
	eval q( &JUMP0( &__doallocate, $FP));
    }
}
unless(defined(&_IO_SYSREAD)) {
    sub _IO_SYSREAD {
	local($FP, $DATA, $LEN) = @_;
	eval q( &JUMP2( &__read, $FP, $DATA, $LEN));
    }
}
unless(defined(&_IO_SYSWRITE)) {
    sub _IO_SYSWRITE {
	local($FP, $DATA, $LEN) = @_;
	eval q( &JUMP2( &__write, $FP, $DATA, $LEN));
    }
}
unless(defined(&_IO_SYSSEEK)) {
    sub _IO_SYSSEEK {
	local($FP, $OFFSET, $MODE) = @_;
	eval q( &JUMP2( &__seek, $FP, $OFFSET, $MODE));
    }
}
unless(defined(&_IO_SYSCLOSE)) {
    sub _IO_SYSCLOSE {
	local($FP) = @_;
	eval q( &JUMP0( &__close, $FP));
    }
}
unless(defined(&_IO_SYSSTAT)) {
    sub _IO_SYSSTAT {
	local($FP, $BUF) = @_;
	eval q( &JUMP1( &__stat, $FP, $BUF));
    }
}
unless(defined(&_IO_CHAR_TYPE)) {
    sub _IO_CHAR_TYPE () {	'char';}
}
unless(defined(&_IO_INT_TYPE)) {
    sub _IO_INT_TYPE () {	'int';}
}
if(defined(&_G_USING_THUNKS)) {
}
if(0) {
}
unless(defined(&_IO_sputn)) {
    sub _IO_sputn {
	local($__fp, $__s, $__n) = @_;
	eval q( &_IO_XSPUTN($__fp, $__s, $__n));
    }
}
unless(defined(&_IO_default_close)) {
    sub _IO_default_close () {	( &_IO_default_sync);}
}
unless(defined(&_IO_do_flush)) {
    sub _IO_do_flush {
	local($_f) = @_;
	eval q( &_IO_do_write($_f, ($_f)-> &_IO_write_base, ($_f)-> &_IO_write_ptr-($_f)-> &_IO_write_base));
    }
}
unless(defined(&_IO_in_put_mode)) {
    sub _IO_in_put_mode {
	local($_fp) = @_;
	eval q((($_fp)-> &_flags &  &_IO_CURRENTLY_PUTTING));
    }
}
unless(defined(&_IO_mask_flags)) {
    sub _IO_mask_flags {
	local($fp, $f, $mask) = @_;
	eval q((($fp)-> &_flags = (($fp)-> &_flags & ~($mask)) | (($f) & ($mask))));
    }
}
unless(defined(&_IO_setg)) {
    sub _IO_setg {
	local($fp, $eb, $g, $eg) = @_;
	eval q((($fp)-> &_IO_read_base = ($eb), ($fp)-> &_IO_read_ptr = ($g), ($fp)-> &_IO_read_end = ($eg)));
    }
}
unless(defined(&_IO_setp)) {
    sub _IO_setp {
	local($__fp, $__p, $__ep) = @_;
	eval q((($__fp)-> &_IO_write_base = ($__fp)-> &_IO_write_ptr = $__p, ($__fp)-> &_IO_write_end = ($__ep)));
    }
}
unless(defined(&_IO_have_backup)) {
    sub _IO_have_backup {
	local($fp) = @_;
	eval q((($fp)-> &_IO_save_base !=  &NULL));
    }
}
unless(defined(&_IO_in_backup)) {
    sub _IO_in_backup {
	local($fp) = @_;
	eval q((($fp)-> &_flags &  &_IO_IN_BACKUP));
    }
}
unless(defined(&_IO_have_markers)) {
    sub _IO_have_markers {
	local($fp) = @_;
	eval q((($fp)-> &_markers !=  &NULL));
    }
}
unless(defined(&_IO_blen)) {
    sub _IO_blen {
	local($fp) = @_;
	eval q((($fp)-> &_IO_buf_end - ($fp)-> &_IO_buf_base));
    }
}
unless(defined(&_IO_file_is_open)) {
    sub _IO_file_is_open {
	local($__fp) = @_;
	eval q((($__fp)-> &_fileno >= 0));
    }
}
unless(defined(&EOF)) {
    eval 'sub EOF () {(-1);}' unless defined(&EOF);
}
unless(defined(&NULL)) {
    if(!defined( &__cplusplus) || defined( &__GNUC__)) {
	eval 'sub NULL () {(0);}' unless defined(&NULL);
    } else {
	eval 'sub NULL () {(0);}' unless defined(&NULL);
    }
}
unless(defined(&FREE_BUF)) {
    sub FREE_BUF {
	local($_B) = @_;
	eval q( &free($_B));
    }
}
unless(defined(&ALLOC_BUF)) {
    sub ALLOC_BUF {
	local($_S) = @_;
	eval q( &malloc($_S));
    }
}
unless(defined(&OS_FSTAT)) {
    eval 'sub OS_FSTAT () { &fstat;}' unless defined(&OS_FSTAT);
}
unless(defined(&_IO_pos_BAD)) {
    eval 'sub _IO_pos_BAD () {((-1));}' unless defined(&_IO_pos_BAD);
}
unless(defined(&_IO_pos_as_off)) {
    eval 'sub _IO_pos_as_off {
        local($__pos) = @_;
	    eval q((($__pos)));
    }' unless defined(&_IO_pos_as_off);
}
unless(defined(&_IO_pos_adjust)) {
    eval 'sub _IO_pos_adjust {
        local($__pos, $__delta) = @_;
	    eval q((($__pos) += ($__delta)));
    }' unless defined(&_IO_pos_adjust);
}
unless(defined(&_IO_pos_0)) {
    eval 'sub _IO_pos_0 () {(0);}' unless defined(&_IO_pos_0);
}
if(defined(&__cplusplus)) {
}
unless(defined(&FILEBUF_LITERAL)) {
    sub FILEBUF_LITERAL {
	local($CHAIN, $FLAGS, $FD) = @_;
	eval q({  &_IO_MAGIC+ &_IO_LINKED+ &_IO_IS_FILEBUF+$FLAGS, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, $CHAIN, $FD});
    }
}
if(defined(&__GNUC__)) {
    if((defined(&_G_VTABLE_LABEL_HAS_LENGTH) ? &_G_VTABLE_LABEL_HAS_LENGTH : 0)) {
	eval 'sub VTABLE_LABEL {
	    local($NAME, $CLASS, $CNLENGTH) = @_;
    	    eval q( &extern \'char\' $NAME->[]  &asm ( &_G_VTABLE_LABEL_PREFIX $CNLENGTH $CLASS););
	}' unless defined(&VTABLE_LABEL);
    } else {
	eval 'sub VTABLE_LABEL {
	    local($NAME, $CLASS, $CNLENGTH) = @_;
    	    eval q( &extern \'char\' $NAME->[]  &asm ( &_G_VTABLE_LABEL_PREFIX $CLASS););
	}' unless defined(&VTABLE_LABEL);
    }
}
if(!defined( &builtinbuf_vtable)  && defined( &__cplusplus)) {
    if(defined(&__GNUC__)) {
    } else {
	if((defined(&_G_VTABLE_LABEL_HAS_LENGTH) ? &_G_VTABLE_LABEL_HAS_LENGTH : 0)) {
	    eval 'sub builtinbuf_vtable () { &_G_VTABLE_LABEL_PREFIX_ID10 &builtinbuf;}' unless defined(&builtinbuf_vtable);
	} else {
	    eval 'sub builtinbuf_vtable () { &_G_VTABLE_LABEL_PREFIX_ID &builtinbuf;}' unless defined(&builtinbuf_vtable);
	}
    }
}
if(defined( &__STDC__) || defined( &__cplusplus)) {
    eval 'sub _IO_va_start {
        local($args, $last) = @_;
	    eval q( &va_start($args, $last));
    }' unless defined(&_IO_va_start);
} else {
    eval 'sub _IO_va_start {
        local($args, $last) = @_;
	    eval q( &va_start($args));
    }' unless defined(&_IO_va_start);
}
if(1) {
    eval 'sub COERCE_FILE {
        local($FILE) = @_;
	    eval q();
    }' unless defined(&COERCE_FILE);
} else {
    eval 'sub COERCE_FILE {
        local($FILE) = @_;
	    eval q(((-> &_IO_file_flags &  &_IO_MAGIC_MASK) ==  &_OLD_MAGIC_MASK  && = *( &fp)[1]));
    }' unless defined(&COERCE_FILE);
}
if(defined(&EINVAL)) {
    eval 'sub MAYBE_SET_EINVAL () { &errno =  &EINVAL;}' unless defined(&MAYBE_SET_EINVAL);
} else {
    eval 'sub MAYBE_SET_EINVAL () {1;}' unless defined(&MAYBE_SET_EINVAL);
}
if(defined(&DEBUG)) {
    eval 'sub CHECK_FILE {
        local($FILE,$RET) = @_;
	    eval q( &if (($FILE) ==  &NULL) {  &MAYBE_SET_EINVAL;  &return $RET; }  &else {  &COERCE_FILE($FILE);  &if ((($FILE)-> &_IO_file_flags &  &_IO_MAGIC_MASK) !=  &_IO_MAGIC) {  &errno =  &EINVAL;  &return $RET; }});
    }' unless defined(&CHECK_FILE);
} else {
    eval 'sub CHECK_FILE {
        local($FILE,$RET) = @_;
	    eval q( &COERCE_FILE($FILE));
    }' unless defined(&CHECK_FILE);
}
1;
