require '_h2ph_pre.ph';

unless(defined(&_SYS_LINKER_SET_H_)) {
    eval 'sub _SYS_LINKER_SET_H_ () {1;}' unless defined(&_SYS_LINKER_SET_H_);
    if(defined(&__ELF__)) {
	if(defined(&__alpha__)) {
	    eval 'sub MAKE_SET {
	        local($set, $sym) = @_;
    		eval q( &static  &void  &const *  &const  &__set_$set &_sym_$sym = $sym;  &__asm(\\".align 3\\");  &__asm(\\".section .set.\\" $set \\",\\\\\\"aw\\\\\\"\\");  &__asm(\\".quad \\" $sym);  &__asm(\\".previous\\"));
	    }' unless defined(&MAKE_SET);
	} else {
	    eval 'sub MAKE_SET {
	        local($set, $sym) = @_;
    		eval q( &static  &void  &const *  &const  &__set_$set &_sym_$sym = $sym;  &__asm(\\".section .set.\\" $set \\",\\\\\\"aw\\\\\\"\\");  &__asm(\\".long \\" $sym);  &__asm(\\".previous\\"));
	    }' unless defined(&MAKE_SET);
	}
	eval 'sub TEXT_SET {
	    local($set, $sym) = @_;
    	    eval q( &MAKE_SET($set, $sym));
	}' unless defined(&TEXT_SET);
	eval 'sub DATA_SET {
	    local($set, $sym) = @_;
    	    eval q( &MAKE_SET($set, $sym));
	}' unless defined(&DATA_SET);
	eval 'sub BSS_SET {
	    local($set, $sym) = @_;
    	    eval q( &MAKE_SET($set, $sym));
	}' unless defined(&BSS_SET);
	eval 'sub ABS_SET {
	    local($set, $sym) = @_;
    	    eval q( &MAKE_SET($set, $sym));
	}' unless defined(&ABS_SET);
    } else {
	eval 'sub MAKE_SET {
	    local($set, $sym, $type) = @_;
    	    eval q( &static  &void  &const *  &const  &__set_$set &_sym_$sym = $sym;  &__asm(\\".stabs \\\\\\"_\\" $set \\"\\\\\\", \\" $type \\", 0, 0, _\\" $sym));
	}' unless defined(&MAKE_SET);
	eval 'sub TEXT_SET {
	    local($set, $sym) = @_;
    	    eval q( &MAKE_SET($set, $sym, 23));
	}' unless defined(&TEXT_SET);
	eval 'sub DATA_SET {
	    local($set, $sym) = @_;
    	    eval q( &MAKE_SET($set, $sym, 25));
	}' unless defined(&DATA_SET);
	eval 'sub BSS_SET {
	    local($set, $sym) = @_;
    	    eval q( &MAKE_SET($set, $sym, 27));
	}' unless defined(&BSS_SET);
	eval 'sub ABS_SET {
	    local($set, $sym) = @_;
    	    eval q( &MAKE_SET($set, $sym, 21));
	}' unless defined(&ABS_SET);
    }
}
1;
