require '_h2ph_pre.ph';

unless(defined(&_MACHINE_ATOMIC_H_)) {
    eval 'sub _MACHINE_ATOMIC_H_ () {1;}' unless defined(&_MACHINE_ATOMIC_H_);
    if(defined( &KLD_MODULE)) {
	eval 'sub ATOMIC_ASM {
	    local($NAME, $TYPE, $OP, $V) = @_;
    	    eval q( &extern  &void  &atomic_$NAME &_$TYPE( &volatile  &u_$TYPE * &p,  &u_$TYPE  &v););
	}' unless defined(&ATOMIC_ASM);
    } else {
	if(defined( &SMP)) {
	    eval 'sub MPLOCKED () {"lock ; ";}' unless defined(&MPLOCKED);
	} else {
	    eval 'sub MPLOCKED () {1;}' unless defined(&MPLOCKED);
	}
	eval 'sub ATOMIC_ASM {
	    local($NAME, $TYPE, $OP, $V) = @_;
    	    eval q( &static  &__inline  &void  &atomic_$NAME &_$TYPE( &volatile  &u_$TYPE * &p,  &u_$TYPE  &v){  &__asm  &__volatile( &MPLOCKED $OP : \\"=m\\" (* &p) : \\"ir\\" ($V)); });
	}' unless defined(&ATOMIC_ASM);
    }
}
1;
