require '_h2ph_pre.ph';

unless(defined(&_MACHINE_CPU_H_)) {
    eval 'sub _MACHINE_CPU_H_ () {1;}' unless defined(&_MACHINE_CPU_H_);
    require 'machine/psl.ph';
    require 'machine/frame.ph';
    require 'machine/segments.ph';
    undef(&COPY_SIGCODE) if defined(&COPY_SIGCODE);
    eval 'sub cpu_exec {
        local($p) = @_;
	    eval q();
    }' unless defined(&cpu_exec);
    eval 'sub cpu_swapin {
        local($p) = @_;
	    eval q();
    }' unless defined(&cpu_swapin);
    eval 'sub cpu_setstack {
        local($p, $ap) = @_;
	    eval q((($p)-> ($p_md->{md_regs[&SP]}) = ($ap)));
    }' unless defined(&cpu_setstack);
    eval 'sub cpu_set_init_frame {
        local($p, $fp) = @_;
	    eval q((($p)-> ($p_md->{md_regs}) = ($fp)));
    }' unless defined(&cpu_set_init_frame);
    eval 'sub CLKF_USERMODE {
        local($framep) = @_;
	    eval q((( &ISPL(($framep)-> &cf_cs) ==  &SEL_UPL) || ( ($framep->{cf_eflags}) &  &PSL_VM)));
    }' unless defined(&CLKF_USERMODE);
    eval 'sub CLKF_INTR {
        local($framep) = @_;
	    eval q(( &intr_nesting_level >= 2));
    }' unless defined(&CLKF_INTR);
    if(0) {
	eval 'sub CLKF_BASEPRI {
	    local($framep) = @_;
    	    eval q(((($framep)-> &cf_ppl & ~ &SWI_AST_MASK) == 0));
	}' unless defined(&CLKF_BASEPRI);
    } else {
	eval 'sub CLKF_BASEPRI {
	    local($framep) = @_;
    	    eval q((0));
	}' unless defined(&CLKF_BASEPRI);
    }
    eval 'sub CLKF_PC {
        local($framep) = @_;
	    eval q((($framep)-> &cf_eip));
    }' unless defined(&CLKF_PC);
    eval 'sub need_resched () {
        eval q({  &want_resched = 1;  &aston(); });
    }' unless defined(&need_resched);
    eval 'sub resched_wanted () {
        eval q( &want_resched);
    }' unless defined(&resched_wanted);
    eval 'sub need_proftick {
        local($p) = @_;
	    eval q({ ($p)-> &p_flag |=  &P_OWEUPC;  &aston(); });
    }' unless defined(&need_proftick);
    eval 'sub signotify {
        local($p) = @_;
	    eval q( &aston());
    }' unless defined(&signotify);
    eval 'sub aston () {
        eval q( &setsoftast());
    }' unless defined(&aston);
    eval 'sub astoff () {
        eval q();
    }' unless defined(&astoff);
    eval 'sub CPU_CONSDEV () {1;}' unless defined(&CPU_CONSDEV);
    eval 'sub CPU_ADJKERNTZ () {2;}' unless defined(&CPU_ADJKERNTZ);
    eval 'sub CPU_DISRTCSET () {3;}' unless defined(&CPU_DISRTCSET);
    eval 'sub CPU_BOOTINFO () {4;}' unless defined(&CPU_BOOTINFO);
    eval 'sub CPU_WALLCLOCK () {5;}' unless defined(&CPU_WALLCLOCK);
    eval 'sub CPU_MAXID () {6;}' unless defined(&CPU_MAXID);
    eval 'sub CTL_MACHDEP_NAMES () {{ { 0, 0}, { "console_device",  &CTLTYPE_STRUCT }, { "adjkerntz",  &CTLTYPE_INT }, { "disable_rtc_set",  &CTLTYPE_INT }, { "bootinfo",  &CTLTYPE_STRUCT }, { "wall_cmos_clock",  &CTLTYPE_INT }, };}' unless defined(&CTL_MACHDEP_NAMES);
    if(defined(&KERNEL)) {
    }
}
1;
