require '_h2ph_pre.ph';

unless(defined(&DO_I4B_DEBUG)) {
    sub DO_I4B_DEBUG () {	1;}
}
undef(&DO_I4B_MAXDEBUG) if defined(&DO_I4B_MAXDEBUG);
if(defined(&DO_I4B_DEBUG)) {
    eval 'sub DBGL1 {
        local($bits, $routine, $what) = @_;
	    eval q( &if($bits &  &i4b_l1_debug) {  &printf(\\"i4b-L1-%s: \\", $routine);  &printf $what ; });
    }' unless defined(&DBGL1);
    eval 'sub DBGL2 {
        local($bits, $routine, $what) = @_;
	    eval q( &if($bits &  &i4b_l2_debug) {  &printf(\\"i4b-L2-%s: \\", $routine);  &printf $what ; });
    }' unless defined(&DBGL2);
    eval 'sub DBGL3 {
        local($bits, $routine, $what) = @_;
	    eval q( &if($bits &  &i4b_l3_debug) {  &printf(\\"i4b-L3-%s: \\", $routine);  &printf $what ; });
    }' unless defined(&DBGL3);
    eval 'sub DBGL4 {
        local($bits, $routine, $what) = @_;
	    eval q( &if($bits &  &i4b_l4_debug) {  &printf(\\"i4b-L4-%s: \\", $routine);  &printf $what ; });
    }' unless defined(&DBGL4);
} else {
    eval 'sub DBGL1 {
        local($bits, $routine, $what) = @_;
	    eval q(;);
    }' unless defined(&DBGL1);
    eval 'sub DBGL2 {
        local($bits, $routine, $what) = @_;
	    eval q(;);
    }' unless defined(&DBGL2);
    eval 'sub DBGL3 {
        local($bits, $routine, $what) = @_;
	    eval q(;);
    }' unless defined(&DBGL3);
    eval 'sub DBGL4 {
        local($bits, $routine, $what) = @_;
	    eval q(;);
    }' unless defined(&DBGL4);
}
unless(defined(&L1_ERROR)) {
    sub L1_ERROR () {	0x0001;}
}
unless(defined(&L1_PRIM)) {
    sub L1_PRIM () {	0x0002;}
}
unless(defined(&L1_BCHAN)) {
    sub L1_BCHAN () {	0x0004;}
}
unless(defined(&L1_H_ERR)) {
    sub L1_H_ERR () {	0x0008;}
}
unless(defined(&L1_H_IRQ)) {
    sub L1_H_IRQ () {	0x0010;}
}
unless(defined(&L1_I_ERR)) {
    sub L1_I_ERR () {	0x0020;}
}
unless(defined(&L1_I_MSG)) {
    sub L1_I_MSG () {	0x0040;}
}
unless(defined(&L1_I_SETUP)) {
    sub L1_I_SETUP () {	0x0080;}
}
unless(defined(&L1_F_MSG)) {
    sub L1_F_MSG () {	0x0100;}
}
unless(defined(&L1_F_ERR)) {
    sub L1_F_ERR () {	0x0200;}
}
unless(defined(&L1_T_MSG)) {
    sub L1_T_MSG () {	0x0400;}
}
unless(defined(&L1_T_ERR)) {
    sub L1_T_ERR () {	0x0800;}
}
unless(defined(&L1_H_XFRERR)) {
    sub L1_H_XFRERR () {	0x1000;}
}
unless(defined(&L1_I_CICO)) {
    sub L1_I_CICO () {	0x2000;}
}
unless(defined(&L1_DEBUG_MAX)) {
    sub L1_DEBUG_MAX () {	0x3fef;}
}
unless(defined(&L1_DEBUG_ERR)) {
    sub L1_DEBUG_ERR () {	( &L1_H_ERR |  &L1_I_ERR |  &L1_F_ERR |  &L1_T_ERR |  &L1_ERROR);}
}
unless(defined(&L1_DEBUG_DEFAULT)) {
    if(defined(&DO_I4B_MAXDEBUG)) {
	eval 'sub L1_DEBUG_DEFAULT () { &L1_DEBUG_MAX;}' unless defined(&L1_DEBUG_DEFAULT);
    } else {
	eval 'sub L1_DEBUG_DEFAULT () { &L1_DEBUG_ERR;}' unless defined(&L1_DEBUG_DEFAULT);
    }
}
unless(defined(&L2_ERROR)) {
    sub L2_ERROR () {	0x0001;}
}
unless(defined(&L2_PRIM)) {
    sub L2_PRIM () {	0x0002;}
}
unless(defined(&L2_U_MSG)) {
    sub L2_U_MSG () {	0x0004;}
}
unless(defined(&L2_U_ERR)) {
    sub L2_U_ERR () {	0x0008;}
}
unless(defined(&L2_S_MSG)) {
    sub L2_S_MSG () {	0x0010;}
}
unless(defined(&L2_S_ERR)) {
    sub L2_S_ERR () {	0x0020;}
}
unless(defined(&L2_I_MSG)) {
    sub L2_I_MSG () {	0x0040;}
}
unless(defined(&L2_I_ERR)) {
    sub L2_I_ERR () {	0x0080;}
}
unless(defined(&L2_F_MSG)) {
    sub L2_F_MSG () {	0x0100;}
}
unless(defined(&L2_F_ERR)) {
    sub L2_F_ERR () {	0x0200;}
}
unless(defined(&L2_T_MSG)) {
    sub L2_T_MSG () {	0x0400;}
}
unless(defined(&L2_T_ERR)) {
    sub L2_T_ERR () {	0x0800;}
}
unless(defined(&L2_TEI_MSG)) {
    sub L2_TEI_MSG () {	0x1000;}
}
unless(defined(&L2_TEI_ERR)) {
    sub L2_TEI_ERR () {	0x2000;}
}
unless(defined(&L2_DEBUG_MAX)) {
    sub L2_DEBUG_MAX () {	0x3fff;}
}
unless(defined(&L2_DEBUG_ERR)) {
    sub L2_DEBUG_ERR () {	( &L2_ERROR |  &L2_I_ERR |  &L2_F_ERR |  &L2_T_ERR |  &L2_S_ERR |  &L2_TEI_ERR |  &L2_U_ERR );}
}
unless(defined(&L2_DEBUG_DEFAULT)) {
    if(defined(&DO_I4B_MAXDEBUG)) {
	eval 'sub L2_DEBUG_DEFAULT () { &L2_DEBUG_MAX;}' unless defined(&L2_DEBUG_DEFAULT);
    } else {
	eval 'sub L2_DEBUG_DEFAULT () { &L2_DEBUG_ERR;}' unless defined(&L2_DEBUG_DEFAULT);
    }
}
unless(defined(&L3_ERR)) {
    sub L3_ERR () {	0x0001;}
}
unless(defined(&L3_MSG)) {
    sub L3_MSG () {	0x0002;}
}
unless(defined(&L3_F_MSG)) {
    sub L3_F_MSG () {	0x0004;}
}
unless(defined(&L3_F_ERR)) {
    sub L3_F_ERR () {	0x0008;}
}
unless(defined(&L3_T_MSG)) {
    sub L3_T_MSG () {	0x0010;}
}
unless(defined(&L3_T_ERR)) {
    sub L3_T_ERR () {	0x0020;}
}
unless(defined(&L3_P_MSG)) {
    sub L3_P_MSG () {	0x0040;}
}
unless(defined(&L3_P_ERR)) {
    sub L3_P_ERR () {	0x0080;}
}
unless(defined(&L3_A_MSG)) {
    sub L3_A_MSG () {	0x0100;}
}
unless(defined(&L3_A_ERR)) {
    sub L3_A_ERR () {	0x0200;}
}
unless(defined(&L3_PRIM)) {
    sub L3_PRIM () {	0x0400;}
}
unless(defined(&L3_DEBUG_MAX)) {
    sub L3_DEBUG_MAX () {	0x07ff;}
}
unless(defined(&L3_DEBUG_ERR)) {
    sub L3_DEBUG_ERR () {	( &L3_ERR |  &L3_F_ERR |  &L3_T_ERR |  &L3_P_ERR |  &L3_A_ERR);}
}
unless(defined(&L3_DEBUG_DEFAULT)) {
    if(defined(&DO_I4B_MAXDEBUG)) {
	eval 'sub L3_DEBUG_DEFAULT () { &L3_DEBUG_MAX;}' unless defined(&L3_DEBUG_DEFAULT);
    } else {
	eval 'sub L3_DEBUG_DEFAULT () { &L3_DEBUG_ERR;}' unless defined(&L3_DEBUG_DEFAULT);
    }
}
unless(defined(&L4_ERR)) {
    sub L4_ERR () {	0x0001;}
}
unless(defined(&L4_MSG)) {
    sub L4_MSG () {	0x0002;}
}
unless(defined(&L4_TIMO)) {
    sub L4_TIMO () {	0x0004;}
}
unless(defined(&L4_DIALST)) {
    sub L4_DIALST () {	0x0008;}
}
unless(defined(&L4_IPRDBG)) {
    sub L4_IPRDBG () {	0x0010;}
}
unless(defined(&L4_RBCHDBG)) {
    sub L4_RBCHDBG () {	0x0020;}
}
unless(defined(&L4_ISPDBG)) {
    sub L4_ISPDBG () {	0x0040;}
}
unless(defined(&L4_TELDBG)) {
    sub L4_TELDBG () {	0x0080;}
}
unless(defined(&L4_TINADBG)) {
    sub L4_TINADBG () {	0x0100;}
}
unless(defined(&L4_TINAMSG)) {
    sub L4_TINAMSG () {	0x0200;}
}
unless(defined(&L4_TINAERR)) {
    sub L4_TINAERR () {	0x0400;}
}
unless(defined(&L4_DEBUG_MAX)) {
    sub L4_DEBUG_MAX () {	0x07ff;}
}
unless(defined(&L4_DEBUG_ERR)) {
    sub L4_DEBUG_ERR () {	( &L4_ERR |  &L4_TINADBG |  &L4_TINAMSG |  &L4_TINAERR);}
}
unless(defined(&L4_DEBUG_DEFAULT)) {
    if(defined(&DO_I4B_MAXDEBUG)) {
	eval 'sub L4_DEBUG_DEFAULT () { &L4_DEBUG_MAX;}' unless defined(&L4_DEBUG_DEFAULT);
    } else {
	eval 'sub L4_DEBUG_DEFAULT () { &L4_DEBUG_ERR;}' unless defined(&L4_DEBUG_DEFAULT);
    }
}
unless(defined(&I4B_CTL_GET_DEBUG)) {
    sub I4B_CTL_GET_DEBUG () {	 &_IOR(ord('C'), 0,  &ctl_debug_t);}
}
unless(defined(&I4B_CTL_SET_DEBUG)) {
    sub I4B_CTL_SET_DEBUG () {	 &_IOW(ord('C'), 1,  &ctl_debug_t);}
}
unless(defined(&I4B_CTL_GET_HSCXSTAT)) {
    sub I4B_CTL_GET_HSCXSTAT () {	 &_IOWR(ord('C'), 2,  &hscxstat_t);}
}
unless(defined(&I4B_CTL_CLR_HSCXSTAT)) {
    sub I4B_CTL_CLR_HSCXSTAT () {	 &_IOW(ord('C'), 3,  &hscxstat_t);}
}
unless(defined(&I4B_CTL_GET_LAPDSTAT)) {
    sub I4B_CTL_GET_LAPDSTAT () {	 &_IOWR(ord('C'), 4,  &l2stat_t);}
}
unless(defined(&I4B_CTL_CLR_LAPDSTAT)) {
    sub I4B_CTL_CLR_LAPDSTAT () {	 &_IOW(ord('C'), 5, 'int');}
}
1;
