require '_h2ph_pre.ph';

unless(defined(&_MACHINE_LIMITS_H_)) {
    eval 'sub _MACHINE_LIMITS_H_ () {1;}' unless defined(&_MACHINE_LIMITS_H_);
    eval 'sub CHAR_BIT () {8;}' unless defined(&CHAR_BIT);
    eval 'sub MB_LEN_MAX () {6;}' unless defined(&MB_LEN_MAX);
    eval 'sub SCHAR_MAX () {127;}' unless defined(&SCHAR_MAX);
    eval 'sub SCHAR_MIN () {(-128);}' unless defined(&SCHAR_MIN);
    eval 'sub UCHAR_MAX () {255;}' unless defined(&UCHAR_MAX);
    eval 'sub CHAR_MAX () {127;}' unless defined(&CHAR_MAX);
    eval 'sub CHAR_MIN () {(-128);}' unless defined(&CHAR_MIN);
    eval 'sub USHRT_MAX () {65535;}' unless defined(&USHRT_MAX);
    eval 'sub SHRT_MAX () {32767;}' unless defined(&SHRT_MAX);
    eval 'sub SHRT_MIN () {(-32768);}' unless defined(&SHRT_MIN);
    eval 'sub UINT_MAX () {0xffffffff;}' unless defined(&UINT_MAX);
    eval 'sub INT_MAX () {2147483647;}' unless defined(&INT_MAX);
    eval 'sub INT_MIN () {(-2147483647-1);}' unless defined(&INT_MIN);
    eval 'sub ULONG_MAX () {0xffffffff;}' unless defined(&ULONG_MAX);
    eval 'sub LONG_MAX () {2147483647;}' unless defined(&LONG_MAX);
    eval 'sub LONG_MIN () {(-2147483647-1);}' unless defined(&LONG_MIN);
    if(!defined( &_ANSI_SOURCE)) {
	eval 'sub SSIZE_MAX () { &INT_MAX;}' unless defined(&SSIZE_MAX);
	if(!defined( &_POSIX_SOURCE)) {
	    eval 'sub SIZE_T_MAX () { &UINT_MAX;}' unless defined(&SIZE_T_MAX);
	    eval 'sub UQUAD_MAX () {(0-1);}' unless defined(&UQUAD_MAX);
	    eval 'sub QUAD_MAX () {(( &UQUAD_MAX >> 1));}' unless defined(&QUAD_MAX);
	    eval 'sub QUAD_MIN () {(- &QUAD_MAX-1);}' unless defined(&QUAD_MIN);
	}
    }
}
1;
