require '_h2ph_pre.ph';

unless(defined(&_MACHINE_PROFILE_H_)) {
    eval 'sub _MACHINE_PROFILE_H_ () {1;}' unless defined(&_MACHINE_PROFILE_H_);
    if(defined(&KERNEL)) {
	eval 'sub FUNCTION_ALIGNMENT () {16;}' unless defined(&FUNCTION_ALIGNMENT);
	eval 'sub _MCOUNT_DECL () { &void  &mcount;}' unless defined(&_MCOUNT_DECL);
	eval 'sub MCOUNT () {1;}' unless defined(&MCOUNT);
	if(defined(&GUPROF)) {
	    eval 'sub CALIB_SCALE () {1000;}' unless defined(&CALIB_SCALE);
	    eval 'sub KCOUNT {
	        local($p,$index) = @_;
    		eval q((($p)-> $kcount[($index) / ( &HISTFRACTION * $sizeof{ &HISTCOUNTER})]));
	    }' unless defined(&KCOUNT);
	    eval 'sub MCOUNT_DECL {
	        local($s) = @_;
    		eval q();
	    }' unless defined(&MCOUNT_DECL);
	    eval 'sub MCOUNT_ENTER {
	        local($s) = @_;
    		eval q();
	    }' unless defined(&MCOUNT_ENTER);
	    eval 'sub MCOUNT_EXIT {
	        local($s) = @_;
    		eval q();
	    }' unless defined(&MCOUNT_EXIT);
	    eval 'sub PC_TO_I {
	        local($p, $pc) = @_;
    		eval q(( - ($p)-> &lowpc));
	    }' unless defined(&PC_TO_I);
	} else {
	    eval 'sub MCOUNT_DECL {
	        local($s) = @_;
    		eval q(\'u_long s\';);
	    }' unless defined(&MCOUNT_DECL);
	    if(defined(&SMP)) {
		eval 'sub MCOUNT_ENTER {
		    local($s) = @_;
    		    eval q({ $s =  &read_eflags();  &__asm  &__volatile(\\"cli\\" : : : \\"memory\\");  &s_lock_np( &mcount_lock); });
		}' unless defined(&MCOUNT_ENTER);
		eval 'sub MCOUNT_EXIT {
		    local($s) = @_;
    		    eval q({  &s_unlock_np( &mcount_lock);  &write_eflags($s); });
		}' unless defined(&MCOUNT_EXIT);
	    } else {
		eval 'sub MCOUNT_ENTER {
		    local($s) = @_;
    		    eval q({ $s =  &read_eflags();  &disable_intr(); });
		}' unless defined(&MCOUNT_ENTER);
		eval 'sub MCOUNT_EXIT {
		    local($s) = @_;
    		    eval q(( &write_eflags($s)));
		}' unless defined(&MCOUNT_EXIT);
	    }
	}
    } else {
	eval 'sub FUNCTION_ALIGNMENT () {4;}' unless defined(&FUNCTION_ALIGNMENT);
	eval 'sub _MCOUNT_DECL () { &static  &__inline  &void  &_mcount;}' unless defined(&_MCOUNT_DECL);
	eval 'sub MCOUNT () { &void  &mcount() {  &uintfptr_t  &selfpc,  &frompc;  &asm("movl 4(%%ebp),%0" : "=r" );  &asm("movl (%%ebp),%0" : "=r" );  &frompc = ( &frompc)[1];  &_mcount( &frompc,  &selfpc); };}' unless defined(&MCOUNT);
    }
    if(defined(&KERNEL)) {
	if(defined(&GUPROF)) {
	} else {
	    eval 'sub startguprof {
	        local($p) = @_;
    		eval q();
	    }' unless defined(&startguprof);
	    eval 'sub stopguprof {
	        local($p) = @_;
    		eval q();
	    }' unless defined(&stopguprof);
	}
    } else {
	require 'sys/cdefs.ph';
	if(defined(&__GNUC__)) {
	    if(defined(&__ELF__)) {
	    } else {
	    }
	}
    }
    if(defined(&GUPROF)) {
    }
}
1;
