require '_h2ph_pre.ph';

unless(defined(&MSDOSFSROOT_OFS)) {
    sub MSDOSFSROOT_OFS () {	0x1fffffff;}
}
unless(defined(&FC_SIZE)) {
    sub FC_SIZE () {	2;}
}
unless(defined(&FC_LASTMAP)) {
    sub FC_LASTMAP () {	0;}
}
unless(defined(&FC_LASTFC)) {
    sub FC_LASTFC () {	1;}
}
unless(defined(&FCE_EMPTY)) {
    sub FCE_EMPTY () {	0xffffffff;}
}
unless(defined(&fc_setcache)) {
    sub fc_setcache {
	local($dep, $slot, $frcn, $fsrcn) = @_;
	eval q(($dep)-> ($de_fc[$slot]->{fc_frcn}) = $frcn; ($dep)-> ($de_fc[$slot]->{fc_fsrcn}) = $fsrcn;);
    }
}
unless(defined(&DE_UPDATE)) {
    sub DE_UPDATE () {	0x0004;}
}
unless(defined(&DE_CREATE)) {
    sub DE_CREATE () {	0x0008;}
}
unless(defined(&DE_ACCESS)) {
    sub DE_ACCESS () {	0x0010;}
}
unless(defined(&DE_MODIFIED)) {
    sub DE_MODIFIED () {	0x0020;}
}
unless(defined(&DE_RENAME)) {
    sub DE_RENAME () {	0x0040;}
}
unless(defined(&DE_INTERNALIZE32)) {
    sub DE_INTERNALIZE32 {
	local($dep, $dp) = @_;
	eval q((($dep)-> &de_StartCluster |=  &getushort(($dp)-> &deHighClust) << 16));
    }
}
unless(defined(&DE_INTERNALIZE)) {
    sub DE_INTERNALIZE {
	local($dep, $dp) = @_;
	eval q(( &bcopy(($dp)-> &deName, ($dep)-> &de_Name, 11), ($dep)-> &de_Attributes = ($dp)-> &deAttributes, ($dep)-> &de_LowerCase = ($dp)-> &deLowerCase, ($dep)-> &de_CHun = ($dp)-> &deCHundredth, ($dep)-> &de_CTime =  &getushort(($dp)-> &deCTime), ($dep)-> &de_CDate =  &getushort(($dp)-> &deCDate), ($dep)-> &de_ADate =  &getushort(($dp)-> &deADate), ($dep)-> &de_MTime =  &getushort(($dp)-> &deMTime), ($dep)-> &de_MDate =  &getushort(($dp)-> &deMDate), ($dep)-> &de_StartCluster =  &getushort(($dp)-> &deStartCluster), ($dep)-> &de_FileSize =  &getulong(($dp)-> &deFileSize), ( &FAT32(($dep)-> &de_pmp) ?  &DE_INTERNALIZE32(($dep), ($dp)) : 0)));
    }
}
unless(defined(&DE_EXTERNALIZE)) {
    sub DE_EXTERNALIZE {
	local($dp, $dep) = @_;
	eval q(( &bcopy(($dep)-> &de_Name, ($dp)-> &deName, 11), ($dp)-> &deAttributes = ($dep)-> &de_Attributes, ($dp)-> &deLowerCase = ($dep)-> &de_LowerCase, ($dp)-> &deCHundredth = ($dep)-> &de_CHun,  &putushort(($dp)-> &deCTime, ($dep)-> &de_CTime),  &putushort(($dp)-> &deCDate, ($dep)-> &de_CDate),  &putushort(($dp)-> &deADate, ($dep)-> &de_ADate),  &putushort(($dp)-> &deMTime, ($dep)-> &de_MTime),  &putushort(($dp)-> &deMDate, ($dep)-> &de_MDate),  &putushort(($dp)-> &deStartCluster, ($dep)-> &de_StartCluster),  &putulong(($dp)-> &deFileSize, (($dep)-> &de_Attributes &  &ATTR_DIRECTORY) ? 0: ($dep)-> &de_FileSize),  &putushort(($dp)-> &deHighClust, ($dep)-> &de_StartCluster >> 16)));
    }
}
unless(defined(&de_forw)) {
    sub de_forw () {	 $de_chain[0];}
}
unless(defined(&de_back)) {
    sub de_back () {	 $de_chain[1];}
}
if(defined(&KERNEL)) {
    eval 'sub VTODE {
        local($vp) = @_;
	    eval q((($vp)-> &v_data));
    }' unless defined(&VTODE);
    eval 'sub DETOV {
        local($de) = @_;
	    eval q((($de)-> &de_vnode));
    }' unless defined(&DETOV);
    eval 'sub DETIMES {
        local($dep, $acc, $mod, $cre) = @_;
	    eval q( &do {  &if (($dep)-> &de_flag &  &DE_UPDATE) { ($dep)-> &de_flag |=  &DE_MODIFIED;  &unix2dostime(($mod), ($dep)-> &de_MDate, ($dep)-> &de_MTime,  &NULL); ($dep)-> &de_Attributes |=  &ATTR_ARCHIVE; }  &if (($dep)-> ($de_pmp->{pm_flags}) &  &MSDOSFSMNT_NOWIN95) { ($dep)-> &de_flag &= ~( &DE_UPDATE |  &DE_CREATE |  &DE_ACCESS);  &break; }  &if (($dep)-> &de_flag &  &DE_ACCESS) {  &u_int16_t  &adate;  &unix2dostime(($acc),  &adate,  &NULL,  &NULL);  &if ( &adate != ($dep)-> &de_ADate) { ($dep)-> &de_flag |=  &DE_MODIFIED; ($dep)-> &de_ADate =  &adate; } }  &if (($dep)-> &de_flag &  &DE_CREATE) {  &unix2dostime(($cre), ($dep)-> &de_CDate, ($dep)-> &de_CTime, ($dep)-> &de_CHun); ($dep)-> &de_flag |=  &DE_MODIFIED; } ($dep)-> &de_flag &= ~( &DE_UPDATE |  &DE_CREATE |  &DE_ACCESS); }  &while (0););
    }' unless defined(&DETIMES);
    if(0) {
    }
}
1;
