require '_h2ph_pre.ph';

unless(defined(&__NCURSES_H)) {
    eval 'sub __NCURSES_H () {1;}' unless defined(&__NCURSES_H);
    eval 'sub CURSES () {1;}' unless defined(&CURSES);
    eval 'sub CURSES_H () {1;}' unless defined(&CURSES_H);
    undef(&NCURSES_VERSION) if defined(&NCURSES_VERSION);
    eval 'sub NCURSES_VERSION () {"1.8.6/ache";}' unless defined(&NCURSES_VERSION);
    require 'stdio.ph';
    require 'stdarg.ph';
    unless(defined(&NOTERMIOS)) {
	require 'termios.ph';
	unless(defined(&TERMIOS)) {
	    eval 'sub TERMIOS () {1;}' unless defined(&TERMIOS);
	}
    } else {
	require 'sgtty.ph';
	require 'sys/ioctl.ph';
    }
    require 'unctrl.ph';
    eval 'sub bool () {\'char\';}' unless defined(&bool);
    eval 'sub A_ATTRIBUTES () {0xffffff00;}' unless defined(&A_ATTRIBUTES);
    eval 'sub A_NORMAL () {0x00000000;}' unless defined(&A_NORMAL);
    eval 'sub A_STANDOUT () {0x00010000;}' unless defined(&A_STANDOUT);
    eval 'sub A_UNDERLINE () {0x00020000;}' unless defined(&A_UNDERLINE);
    eval 'sub A_REVERSE () {0x00040000;}' unless defined(&A_REVERSE);
    eval 'sub A_BLINK () {0x00080000;}' unless defined(&A_BLINK);
    eval 'sub A_DIM () {0x00100000;}' unless defined(&A_DIM);
    eval 'sub A_BOLD () {0x00200000;}' unless defined(&A_BOLD);
    eval 'sub A_ALTCHARSET () {0x00400000;}' unless defined(&A_ALTCHARSET);
    eval 'sub A_INVIS () {0x00800000;}' unless defined(&A_INVIS);
    eval 'sub A_PROTECT () {0x01000000;}' unless defined(&A_PROTECT);
    eval 'sub A_CHARTEXT () {0x000000ff;}' unless defined(&A_CHARTEXT);
    eval 'sub A_COLOR () {0x0000ff00;}' unless defined(&A_COLOR);
    eval 'sub COLOR_PAIR {
        local($n) = @_;
	    eval q(($n << 8));
    }' unless defined(&COLOR_PAIR);
    eval 'sub PAIR_NUMBER {
        local($a) = @_;
	    eval q((($a &  &A_COLOR) >> 8));
    }' unless defined(&PAIR_NUMBER);
    eval 'sub COLOR_BLACK () {0;}' unless defined(&COLOR_BLACK);
    eval 'sub COLOR_RED () {1;}' unless defined(&COLOR_RED);
    eval 'sub COLOR_GREEN () {2;}' unless defined(&COLOR_GREEN);
    eval 'sub COLOR_YELLOW () {3;}' unless defined(&COLOR_YELLOW);
    eval 'sub COLOR_BLUE () {4;}' unless defined(&COLOR_BLUE);
    eval 'sub COLOR_MAGENTA () {5;}' unless defined(&COLOR_MAGENTA);
    eval 'sub COLOR_CYAN () {6;}' unless defined(&COLOR_CYAN);
    eval 'sub COLOR_WHITE () {7;}' unless defined(&COLOR_WHITE);
    eval 'sub ACS_ULCORNER () {( $acs_map[ord(\'l\')]);}' unless defined(&ACS_ULCORNER);
    eval 'sub ACS_LLCORNER () {( $acs_map[ord(\'m\')]);}' unless defined(&ACS_LLCORNER);
    eval 'sub ACS_URCORNER () {( $acs_map[ord(\'k\')]);}' unless defined(&ACS_URCORNER);
    eval 'sub ACS_LRCORNER () {( $acs_map[ord(\'j\')]);}' unless defined(&ACS_LRCORNER);
    eval 'sub ACS_RTEE () {( $acs_map[ord(\'u\')]);}' unless defined(&ACS_RTEE);
    eval 'sub ACS_LTEE () {( $acs_map[ord(\'t\')]);}' unless defined(&ACS_LTEE);
    eval 'sub ACS_BTEE () {( $acs_map[ord(\'v\')]);}' unless defined(&ACS_BTEE);
    eval 'sub ACS_TTEE () {( $acs_map[ord(\'w\')]);}' unless defined(&ACS_TTEE);
    eval 'sub ACS_HLINE () {( $acs_map[ord(\'q\')]);}' unless defined(&ACS_HLINE);
    eval 'sub ACS_VLINE () {( $acs_map[ord(\'x\')]);}' unless defined(&ACS_VLINE);
    eval 'sub ACS_PLUS () {( $acs_map[ord(\'n\')]);}' unless defined(&ACS_PLUS);
    eval 'sub ACS_S1 () {( $acs_map[ord(\'o\')]);}' unless defined(&ACS_S1);
    eval 'sub ACS_S9 () {( $acs_map[ord(\'s\')]);}' unless defined(&ACS_S9);
    eval 'sub ACS_DIAMOND () {( $acs_map[ord(\'`\')]);}' unless defined(&ACS_DIAMOND);
    eval 'sub ACS_CKBOARD () {( $acs_map[ord(\'a\')]);}' unless defined(&ACS_CKBOARD);
    eval 'sub ACS_DEGREE () {( $acs_map[ord(\'f\')]);}' unless defined(&ACS_DEGREE);
    eval 'sub ACS_PLMINUS () {( $acs_map[ord(\'g\')]);}' unless defined(&ACS_PLMINUS);
    eval 'sub ACS_BULLET () {( $acs_map[ord(\'~\')]);}' unless defined(&ACS_BULLET);
    eval 'sub ACS_LARROW () {( $acs_map[ord(\',\')]);}' unless defined(&ACS_LARROW);
    eval 'sub ACS_RARROW () {( $acs_map[ord(\'+\')]);}' unless defined(&ACS_RARROW);
    eval 'sub ACS_DARROW () {( $acs_map[ord(\'.\')]);}' unless defined(&ACS_DARROW);
    eval 'sub ACS_UARROW () {( $acs_map[ord(\'-\')]);}' unless defined(&ACS_UARROW);
    eval 'sub ACS_BOARD () {( $acs_map[ord(\'h\')]);}' unless defined(&ACS_BOARD);
    eval 'sub ACS_LANTERN () {( $acs_map[ord(\'I\')]);}' unless defined(&ACS_LANTERN);
    eval 'sub ACS_BLOCK () {( $acs_map[ord(\'0\')]);}' unless defined(&ACS_BLOCK);
    unless(defined(&TRUE)) {
	eval 'sub TRUE () {(1);}' unless defined(&TRUE);
	eval 'sub FALSE () {(0);}' unless defined(&FALSE);
    }
    eval 'sub ERR () {(-1);}' unless defined(&ERR);
    eval 'sub OK () {(0);}' unless defined(&OK);
    eval 'sub _SUBWIN () {0x01;}' unless defined(&_SUBWIN);
    eval 'sub _ENDLINE () {0x02;}' unless defined(&_ENDLINE);
    eval 'sub _FULLWIN () {0x04;}' unless defined(&_FULLWIN);
    eval 'sub _SCROLLWIN () {0x08;}' unless defined(&_SCROLLWIN);
    eval 'sub _ISPAD () {0x10;}' unless defined(&_ISPAD);
    eval 'sub _HASMOVED () {0x20;}' unless defined(&_HASMOVED);
    eval 'sub _NOCHANGE () {-1;}' unless defined(&_NOCHANGE);
    if(defined(&__cplusplus)) {
    }
    if(0) {
    }
    eval 'sub TRACE_DISABLE () {0x00;}' unless defined(&TRACE_DISABLE);
    eval 'sub TRACE_ORDINARY () {0x01;}' unless defined(&TRACE_ORDINARY);
    eval 'sub TRACE_CHARPUT () {0x02;}' unless defined(&TRACE_CHARPUT);
    eval 'sub TRACE_MAXIMUM () {0x0f;}' unless defined(&TRACE_MAXIMUM);
    if(defined(&__cplusplus)) {
    }
    eval 'sub wgetstr {
        local($w, $s) = @_;
	    eval q( &wgetnstr($w, $s, -1));
    }' unless defined(&wgetstr);
    eval 'sub napms {
        local($x) = @_;
	    eval q( &usleep(1000*$x));
    }' unless defined(&napms);
    eval 'sub setterm {
        local($term) = @_;
	    eval q( &setupterm($term, 1, 0));
    }' unless defined(&setterm);
    eval 'sub fixterm () {
        eval q( &reset_prog_mode());
    }' unless defined(&fixterm);
    eval 'sub resetterm () {
        eval q( &reset_shell_mode());
    }' unless defined(&resetterm);
    eval 'sub saveterm () {
        eval q( &def_prog_mode());
    }' unless defined(&saveterm);
    eval 'sub crmode () {
        eval q( &cbreak());
    }' unless defined(&crmode);
    eval 'sub nocrmode () {
        eval q( &nocbreak());
    }' unless defined(&nocrmode);
    eval 'sub gettmode () {
        eval q();
    }' unless defined(&gettmode);
    eval 'sub getyx {
        local($win,$y,$x) = @_;
	    eval q(($y = ($win)-> &_cury, $x = ($win)-> &_curx));
    }' unless defined(&getyx);
    eval 'sub getbegyx {
        local($win,$y,$x) = @_;
	    eval q(($y = ($win)-> &_begy, $x = ($win)-> &_begx));
    }' unless defined(&getbegyx);
    eval 'sub getmaxyx {
        local($win,$y,$x) = @_;
	    eval q(($y = ($win)-> &_maxy + 1, $x = ($win)-> &_maxx + 1));
    }' unless defined(&getmaxyx);
    eval 'sub getsyx {
        local($y,$x) = @_;
	    eval q( &getyx( &stdscr, $y, $x));
    }' unless defined(&getsyx);
    eval 'sub setsyx {
        local($y,$x) = @_;
	    eval q(( ($stdscr->{_cury}) = $y,  ($stdscr->{_curx}) = $x));
    }' unless defined(&setsyx);
    eval 'sub wbkgdset {
        local($win,$ch) = @_;
	    eval q((($win)-> &_bkgd = $ch));
    }' unless defined(&wbkgdset);
    eval 'sub getattrs {
        local($win) = @_;
	    eval q(( ($win->{_attrs})));
    }' unless defined(&getattrs);
    eval 'sub getmaxx {
        local($win) = @_;
	    eval q((($win)-> &_maxx + 1));
    }' unless defined(&getmaxx);
    eval 'sub getmaxy {
        local($win) = @_;
	    eval q((($win)-> &_maxy + 1));
    }' unless defined(&getmaxy);
    eval 'sub winch {
        local($win) = @_;
	    eval q((($win)-> $_line[($win)-> &_cury][($win)-> &_curx]));
    }' unless defined(&winch);
    eval 'sub wstandout {
        local($win) = @_;
	    eval q(( &wattrset($win, &A_STANDOUT)));
    }' unless defined(&wstandout);
    eval 'sub wstandend {
        local($win) = @_;
	    eval q(( &wattrset($win, &A_NORMAL)));
    }' unless defined(&wstandend);
    eval 'sub wattrset {
        local($win,$at) = @_;
	    eval q((($win)-> &_attrs = ($at)));
    }' unless defined(&wattrset);
    eval 'sub subpad {
        local($p,$l,$c,$y,$x) = @_;
	    eval q( &derwin($p,$l,$c,$y,$x));
    }' unless defined(&subpad);
    eval 'sub scroll {
        local($win) = @_;
	    eval q( &wscrl($win,1));
    }' unless defined(&scroll);
    eval 'sub touchwin {
        local($win) = @_;
	    eval q( &wtouchln(($win), 0, ($win)-> &_maxy + 1, 1));
    }' unless defined(&touchwin);
    eval 'sub touchline {
        local($win, $s, $c) = @_;
	    eval q( &wtouchln(($win), $s, $c, 1));
    }' unless defined(&touchline);
    eval 'sub untouchwin {
        local($win) = @_;
	    eval q( &wtouchln(($win), 0, ($win)-> &_maxy + 1, 0));
    }' unless defined(&untouchwin);
    eval 'sub box {
        local($win, $v, $h) = @_;
	    eval q( &wborder($win, $v, $v, $h, $h, 0, 0, 0, 0));
    }' unless defined(&box);
    eval 'sub border {
        local($ls, $rs, $ts, $bs, $tl, $tr, $bl, $br) = @_;
	    eval q( &wborder( &stdscr, $ls, $rs, $ts, $bs, $tl, $tr, $bl, $br));
    }' unless defined(&border);
    eval 'sub hline {
        local($ch, $n) = @_;
	    eval q( &whline( &stdscr, $ch, $n));
    }' unless defined(&hline);
    eval 'sub vline {
        local($ch, $n) = @_;
	    eval q( &wvline( &stdscr, $ch, $n));
    }' unless defined(&vline);
    eval 'sub winsstr {
        local($w, $s) = @_;
	    eval q( &winsnstr($w, $s, 0));
    }' unless defined(&winsstr);
    eval 'sub winstr {
        local($w, $s) = @_;
	    eval q( &winnstr($w, $s, -1));
    }' unless defined(&winstr);
    eval 'sub redrawwin {
        local($w) = @_;
	    eval q( &wredrawln($w, 0,  ($w->{_maxy})+1));
    }' unless defined(&redrawwin);
    eval 'sub waddstr {
        local($win,$str) = @_;
	    eval q( &waddnstr($win,$str,-1));
    }' unless defined(&waddstr);
    eval 'sub waddchstr {
        local($win,$str) = @_;
	    eval q( &waddchnstr($win,$str,-1));
    }' unless defined(&waddchstr);
    eval 'sub bkgdset {
        local($ch) = @_;
	    eval q( &wbkgdset( &stdscr,$ch));
    }' unless defined(&bkgdset);
    eval 'sub bkgd {
        local($ch) = @_;
	    eval q( &wbkgd( &stdscr,$ch));
    }' unless defined(&bkgd);
    eval 'sub inch () {
        eval q( &winch( &stdscr));
    }' unless defined(&inch);
    eval 'sub standout () {
        eval q( &wstandout( &stdscr));
    }' unless defined(&standout);
    eval 'sub standend () {
        eval q( &wstandend( &stdscr));
    }' unless defined(&standend);
    eval 'sub attron {
        local($at) = @_;
	    eval q( &wattron( &stdscr,$at));
    }' unless defined(&attron);
    eval 'sub attroff {
        local($at) = @_;
	    eval q( &wattroff( &stdscr,$at));
    }' unless defined(&attroff);
    eval 'sub attrset {
        local($at) = @_;
	    eval q( &wattrset( &stdscr,$at));
    }' unless defined(&attrset);
    eval 'sub addch {
        local($ch) = @_;
	    eval q( &waddch( &stdscr,$ch));
    }' unless defined(&addch);
    eval 'sub echochar {
        local($c) = @_;
	    eval q( &wechochar( &stdscr, $c));
    }' unless defined(&echochar);
    eval 'sub getch () {
        eval q( &wgetch( &stdscr));
    }' unless defined(&getch);
    eval 'sub addstr {
        local($str) = @_;
	    eval q( &waddnstr( &stdscr,$str,-1));
    }' unless defined(&addstr);
    eval 'sub getstr {
        local($str) = @_;
	    eval q( &wgetstr( &stdscr,$str));
    }' unless defined(&getstr);
    eval 'sub move {
        local($y, $x) = @_;
	    eval q( &wmove( &stdscr,$y,$x));
    }' unless defined(&move);
    eval 'sub clear () {
        eval q( &wclear( &stdscr));
    }' unless defined(&clear);
    eval 'sub erase () {
        eval q( &werase( &stdscr));
    }' unless defined(&erase);
    eval 'sub clrtobot () {
        eval q( &wclrtobot( &stdscr));
    }' unless defined(&clrtobot);
    eval 'sub clrtoeol () {
        eval q( &wclrtoeol( &stdscr));
    }' unless defined(&clrtoeol);
    eval 'sub insertln () {
        eval q( &winsdelln( &stdscr, 1));
    }' unless defined(&insertln);
    eval 'sub winsertln {
        local($w) = @_;
	    eval q( &winsdelln($w, 1));
    }' unless defined(&winsertln);
    eval 'sub deleteln () {
        eval q( &winsdelln( &stdscr, -1));
    }' unless defined(&deleteln);
    eval 'sub wdeleteln {
        local($w) = @_;
	    eval q( &winsdelln($w, -1));
    }' unless defined(&wdeleteln);
    eval 'sub refresh () {
        eval q( &wrefresh( &stdscr));
    }' unless defined(&refresh);
    eval 'sub innstr {
        local($s,$n) = @_;
	    eval q( &winnstr( &stdscr,$s,$n));
    }' unless defined(&innstr);
    eval 'sub insch {
        local($c) = @_;
	    eval q( &winsch( &stdscr,$c));
    }' unless defined(&insch);
    eval 'sub delch () {
        eval q( &wdelch( &stdscr));
    }' unless defined(&delch);
    eval 'sub setscrreg {
        local($t,$b) = @_;
	    eval q( &wsetscrreg( &stdscr,$t,$b));
    }' unless defined(&setscrreg);
    eval 'sub scrl {
        local($n) = @_;
	    eval q( &wscrl( &stdscr,$n));
    }' unless defined(&scrl);
    eval 'sub timeout {
        local($delay) = @_;
	    eval q( &wtimeout( &stdscr, $delay));
    }' unless defined(&timeout);
    eval 'sub addnstr {
        local($str,$n) = @_;
	    eval q( &waddnstr( &stdscr,$str,$n));
    }' unless defined(&addnstr);
    eval 'sub addchstr {
        local($str) = @_;
	    eval q( &waddchstr( &stdscr,$str));
    }' unless defined(&addchstr);
    eval 'sub addchnstr {
        local($str,$n) = @_;
	    eval q( &waddchnstr( &stdscr,$str, $n));
    }' unless defined(&addchnstr);
    eval 'sub insdelln {
        local($n) = @_;
	    eval q( &winsdelln( &stdscr, $n));
    }' unless defined(&insdelln);
    eval 'sub insstr {
        local($s) = @_;
	    eval q( &winsstr( &stdscr, $s));
    }' unless defined(&insstr);
    eval 'sub insnstr {
        local($s,$n) = @_;
	    eval q( &winsnstr( &stdscr, $s, $n));
    }' unless defined(&insnstr);
    eval 'sub mvwaddch {
        local($win,$y,$x,$ch) = @_;
	    eval q(( &wmove($win,$y,$x) ==  &ERR ?  &ERR :  &waddch($win,$ch)));
    }' unless defined(&mvwaddch);
    eval 'sub mvwgetch {
        local($win,$y,$x) = @_;
	    eval q(( &wmove($win,$y,$x) ==  &ERR ?  &ERR :  &wgetch($win)));
    }' unless defined(&mvwgetch);
    eval 'sub mvwaddchnstr {
        local($win,$y,$x,$str,$n) = @_;
	    eval q(( &wmove($win,$y,$x) ==  &ERR ?  &ERR :  &waddchnstr($win,$str,$n)));
    }' unless defined(&mvwaddchnstr);
    eval 'sub mvwaddchstr {
        local($win,$y,$x,$str) = @_;
	    eval q(( &wmove($win,$y,$x) ==  &ERR ?  &ERR :  &waddchnstr($win,$str,-1)));
    }' unless defined(&mvwaddchstr);
    eval 'sub mvwaddnstr {
        local($win,$y,$x,$str,$n) = @_;
	    eval q(( &wmove($win,$y,$x) ==  &ERR ?  &ERR :  &waddnstr($win,$str,$n)));
    }' unless defined(&mvwaddnstr);
    eval 'sub mvwaddstr {
        local($win,$y,$x,$str) = @_;
	    eval q(( &wmove($win,$y,$x) ==  &ERR ?  &ERR :  &waddnstr($win,$str,-1)));
    }' unless defined(&mvwaddstr);
    eval 'sub mvwgetstr {
        local($win,$y,$x,$str) = @_;
	    eval q(( &wmove($win,$y,$x) ==  &ERR ?  &ERR :  &wgetstr($win,$str)));
    }' unless defined(&mvwgetstr);
    eval 'sub mvwinch {
        local($win,$y,$x) = @_;
	    eval q(( &wmove($win,$y,$x) ==  &ERR ?  &ERR :  &winch($win)));
    }' unless defined(&mvwinch);
    eval 'sub mvwdelch {
        local($win,$y,$x) = @_;
	    eval q(( &wmove($win,$y,$x) ==  &ERR ?  &ERR :  &wdelch($win)));
    }' unless defined(&mvwdelch);
    eval 'sub mvwinnstr {
        local($win,$y,$x,$s,$n) = @_;
	    eval q(( &wmove($win,$y,$x) ==  &ERR ?  &ERR :  &winnstr($win,$s,$n)));
    }' unless defined(&mvwinnstr);
    eval 'sub mvwinsch {
        local($win,$y,$x,$c) = @_;
	    eval q(( &wmove($win,$y,$x) ==  &ERR ?  &ERR :  &winsch($win,$c)));
    }' unless defined(&mvwinsch);
    eval 'sub mvaddch {
        local($y,$x,$ch) = @_;
	    eval q( &mvwaddch( &stdscr,$y,$x,$ch));
    }' unless defined(&mvaddch);
    eval 'sub mvgetch {
        local($y,$x) = @_;
	    eval q( &mvwgetch( &stdscr,$y,$x));
    }' unless defined(&mvgetch);
    eval 'sub mvaddnstr {
        local($y,$x,$str,$n) = @_;
	    eval q( &mvwaddnstr( &stdscr,$y,$x,$str,$n));
    }' unless defined(&mvaddnstr);
    eval 'sub mvaddstr {
        local($y,$x,$str) = @_;
	    eval q( &mvwaddstr( &stdscr,$y,$x,$str));
    }' unless defined(&mvaddstr);
    eval 'sub mvgetstr {
        local($y,$x,$str) = @_;
	    eval q( &mvwgetstr( &stdscr,$y,$x,$str));
    }' unless defined(&mvgetstr);
    eval 'sub mvinch {
        local($y,$x) = @_;
	    eval q( &mvwinch( &stdscr,$y,$x));
    }' unless defined(&mvinch);
    eval 'sub mvdelch {
        local($y,$x) = @_;
	    eval q( &mvwdelch( &stdscr,$y,$x));
    }' unless defined(&mvdelch);
    eval 'sub mvinnstr {
        local($y,$x,$s,$n) = @_;
	    eval q( &mvwinnstr( &stdscr,$y,$x,$s,$n));
    }' unless defined(&mvinnstr);
    eval 'sub mvinsch {
        local($y,$x,$c) = @_;
	    eval q( &mvwinsch( &stdscr,$y,$x,$c));
    }' unless defined(&mvinsch);
    eval 'sub mvwinsstr {
        local($w, $y, $x, $s) = @_;
	    eval q(( &wmove($w,$y,$x) ==  &ERR ?  &ERR :  &winsstr($w,$s)));
    }' unless defined(&mvwinsstr);
    eval 'sub mvwinsnstr {
        local($w, $y, $x, $s, $n) = @_;
	    eval q(( &wmove($w,$y,$x) ==  &ERR ?  &ERR :  &winsnstr($w,$s,$n)));
    }' unless defined(&mvwinsnstr);
    eval 'sub mvinsstr {
        local($y,$x,$s) = @_;
	    eval q( &mvwinsstr( &stdscr,$y,$x,$s));
    }' unless defined(&mvinsstr);
    eval 'sub mvinsnstr {
        local($y,$x,$s,$n) = @_;
	    eval q( &mvwinsnstr( &stdscr,$y,$x,$s,$n));
    }' unless defined(&mvinsnstr);
    eval 'sub attr_get () {
        eval q( &wattr_get( &stdscr));
    }' unless defined(&attr_get);
    eval 'sub getbkgd {
        local($win) = @_;
	    eval q((($win)-> &_bkgd));
    }' unless defined(&getbkgd);
    eval 'sub vid_attr {
        local($a) = @_;
	    eval q( &vidattr($a));
    }' unless defined(&vid_attr);
    eval 'sub wattr_get {
        local($win) = @_;
	    eval q((($win)-> &_attrs));
    }' unless defined(&wattr_get);
    eval 'sub KEY_MIN () {0401;}' unless defined(&KEY_MIN);
    eval 'sub KEY_BREAK () {0401;}' unless defined(&KEY_BREAK);
    eval 'sub KEY_DOWN () {0402;}' unless defined(&KEY_DOWN);
    eval 'sub KEY_UP () {0403;}' unless defined(&KEY_UP);
    eval 'sub KEY_LEFT () {0404;}' unless defined(&KEY_LEFT);
    eval 'sub KEY_RIGHT () {0405;}' unless defined(&KEY_RIGHT);
    eval 'sub KEY_HOME () {0406;}' unless defined(&KEY_HOME);
    eval 'sub KEY_BACKSPACE () {0407;}' unless defined(&KEY_BACKSPACE);
    eval 'sub KEY_F0 () {0410;}' unless defined(&KEY_F0);
    eval 'sub KEY_F {
        local($n) = @_;
	    eval q(( &KEY_F0+($n)));
    }' unless defined(&KEY_F);
    eval 'sub KEY_DL () {0510;}' unless defined(&KEY_DL);
    eval 'sub KEY_IL () {0511;}' unless defined(&KEY_IL);
    eval 'sub KEY_DC () {0512;}' unless defined(&KEY_DC);
    eval 'sub KEY_IC () {0513;}' unless defined(&KEY_IC);
    eval 'sub KEY_EIC () {0514;}' unless defined(&KEY_EIC);
    eval 'sub KEY_CLEAR () {0515;}' unless defined(&KEY_CLEAR);
    eval 'sub KEY_EOS () {0516;}' unless defined(&KEY_EOS);
    eval 'sub KEY_EOL () {0517;}' unless defined(&KEY_EOL);
    eval 'sub KEY_SF () {0520;}' unless defined(&KEY_SF);
    eval 'sub KEY_SR () {0521;}' unless defined(&KEY_SR);
    eval 'sub KEY_NPAGE () {0522;}' unless defined(&KEY_NPAGE);
    eval 'sub KEY_PPAGE () {0523;}' unless defined(&KEY_PPAGE);
    eval 'sub KEY_STAB () {0524;}' unless defined(&KEY_STAB);
    eval 'sub KEY_CTAB () {0525;}' unless defined(&KEY_CTAB);
    eval 'sub KEY_CATAB () {0526;}' unless defined(&KEY_CATAB);
    eval 'sub KEY_ENTER () {0527;}' unless defined(&KEY_ENTER);
    eval 'sub KEY_SRESET () {0530;}' unless defined(&KEY_SRESET);
    eval 'sub KEY_RESET () {0531;}' unless defined(&KEY_RESET);
    eval 'sub KEY_PRINT () {0532;}' unless defined(&KEY_PRINT);
    eval 'sub KEY_LL () {0533;}' unless defined(&KEY_LL);
    eval 'sub KEY_A1 () {0534;}' unless defined(&KEY_A1);
    eval 'sub KEY_A3 () {0535;}' unless defined(&KEY_A3);
    eval 'sub KEY_B2 () {0536;}' unless defined(&KEY_B2);
    eval 'sub KEY_C1 () {0537;}' unless defined(&KEY_C1);
    eval 'sub KEY_C3 () {0540;}' unless defined(&KEY_C3);
    eval 'sub KEY_BTAB () {0541;}' unless defined(&KEY_BTAB);
    eval 'sub KEY_BEG () {0542;}' unless defined(&KEY_BEG);
    eval 'sub KEY_CANCEL () {0543;}' unless defined(&KEY_CANCEL);
    eval 'sub KEY_CLOSE () {0544;}' unless defined(&KEY_CLOSE);
    eval 'sub KEY_COMMAND () {0545;}' unless defined(&KEY_COMMAND);
    eval 'sub KEY_COPY () {0546;}' unless defined(&KEY_COPY);
    eval 'sub KEY_CREATE () {0547;}' unless defined(&KEY_CREATE);
    eval 'sub KEY_END () {0550;}' unless defined(&KEY_END);
    eval 'sub KEY_EXIT () {0551;}' unless defined(&KEY_EXIT);
    eval 'sub KEY_FIND () {0552;}' unless defined(&KEY_FIND);
    eval 'sub KEY_HELP () {0553;}' unless defined(&KEY_HELP);
    eval 'sub KEY_MARK () {0554;}' unless defined(&KEY_MARK);
    eval 'sub KEY_MESSAGE () {0555;}' unless defined(&KEY_MESSAGE);
    eval 'sub KEY_MOVE () {0556;}' unless defined(&KEY_MOVE);
    eval 'sub KEY_NEXT () {0557;}' unless defined(&KEY_NEXT);
    eval 'sub KEY_OPEN () {0560;}' unless defined(&KEY_OPEN);
    eval 'sub KEY_OPTIONS () {0561;}' unless defined(&KEY_OPTIONS);
    eval 'sub KEY_PREVIOUS () {0562;}' unless defined(&KEY_PREVIOUS);
    eval 'sub KEY_REDO () {0563;}' unless defined(&KEY_REDO);
    eval 'sub KEY_REFERENCE () {0564;}' unless defined(&KEY_REFERENCE);
    eval 'sub KEY_REFRESH () {0565;}' unless defined(&KEY_REFRESH);
    eval 'sub KEY_REPLACE () {0566;}' unless defined(&KEY_REPLACE);
    eval 'sub KEY_RESTART () {0567;}' unless defined(&KEY_RESTART);
    eval 'sub KEY_RESUME () {0570;}' unless defined(&KEY_RESUME);
    eval 'sub KEY_SAVE () {0571;}' unless defined(&KEY_SAVE);
    eval 'sub KEY_SBEG () {0572;}' unless defined(&KEY_SBEG);
    eval 'sub KEY_SCANCEL () {0573;}' unless defined(&KEY_SCANCEL);
    eval 'sub KEY_SCOMMAND () {0574;}' unless defined(&KEY_SCOMMAND);
    eval 'sub KEY_SCOPY () {0575;}' unless defined(&KEY_SCOPY);
    eval 'sub KEY_SCREATE () {0576;}' unless defined(&KEY_SCREATE);
    eval 'sub KEY_SDC () {0577;}' unless defined(&KEY_SDC);
    eval 'sub KEY_SDL () {0600;}' unless defined(&KEY_SDL);
    eval 'sub KEY_SELECT () {0601;}' unless defined(&KEY_SELECT);
    eval 'sub KEY_SEND () {0602;}' unless defined(&KEY_SEND);
    eval 'sub KEY_SEOL () {0603;}' unless defined(&KEY_SEOL);
    eval 'sub KEY_SEXIT () {0604;}' unless defined(&KEY_SEXIT);
    eval 'sub KEY_SFIND () {0605;}' unless defined(&KEY_SFIND);
    eval 'sub KEY_SHELP () {0606;}' unless defined(&KEY_SHELP);
    eval 'sub KEY_SHOME () {0607;}' unless defined(&KEY_SHOME);
    eval 'sub KEY_SIC () {0610;}' unless defined(&KEY_SIC);
    eval 'sub KEY_SLEFT () {0611;}' unless defined(&KEY_SLEFT);
    eval 'sub KEY_SMESSAGE () {0612;}' unless defined(&KEY_SMESSAGE);
    eval 'sub KEY_SMOVE () {0613;}' unless defined(&KEY_SMOVE);
    eval 'sub KEY_SNEXT () {0614;}' unless defined(&KEY_SNEXT);
    eval 'sub KEY_SOPTIONS () {0615;}' unless defined(&KEY_SOPTIONS);
    eval 'sub KEY_SPREVIOUS () {0616;}' unless defined(&KEY_SPREVIOUS);
    eval 'sub KEY_SPRINT () {0617;}' unless defined(&KEY_SPRINT);
    eval 'sub KEY_SREDO () {0620;}' unless defined(&KEY_SREDO);
    eval 'sub KEY_SREPLACE () {0621;}' unless defined(&KEY_SREPLACE);
    eval 'sub KEY_SRIGHT () {0622;}' unless defined(&KEY_SRIGHT);
    eval 'sub KEY_SRSUME () {0623;}' unless defined(&KEY_SRSUME);
    eval 'sub KEY_SSAVE () {0624;}' unless defined(&KEY_SSAVE);
    eval 'sub KEY_SSUSPEND () {0625;}' unless defined(&KEY_SSUSPEND);
    eval 'sub KEY_SUNDO () {0626;}' unless defined(&KEY_SUNDO);
    eval 'sub KEY_SUSPEND () {0627;}' unless defined(&KEY_SUSPEND);
    eval 'sub KEY_UNDO () {0630;}' unless defined(&KEY_UNDO);
    eval 'sub KEY_MAX () {0777;}' unless defined(&KEY_MAX);
}
1;
