require '_h2ph_pre.ph';

unless(defined(&_NET_IF_H_)) {
    eval 'sub _NET_IF_H_ () {1;}' unless defined(&_NET_IF_H_);
    unless(defined(&KERNEL)) {
	require 'sys/time.ph';
    }
    eval 'sub IFF_UP () {0x1;}' unless defined(&IFF_UP);
    eval 'sub IFF_BROADCAST () {0x2;}' unless defined(&IFF_BROADCAST);
    eval 'sub IFF_DEBUG () {0x4;}' unless defined(&IFF_DEBUG);
    eval 'sub IFF_LOOPBACK () {0x8;}' unless defined(&IFF_LOOPBACK);
    eval 'sub IFF_POINTOPOINT () {0x10;}' unless defined(&IFF_POINTOPOINT);
    eval 'sub IFF_RUNNING () {0x40;}' unless defined(&IFF_RUNNING);
    eval 'sub IFF_NOARP () {0x80;}' unless defined(&IFF_NOARP);
    eval 'sub IFF_PROMISC () {0x100;}' unless defined(&IFF_PROMISC);
    eval 'sub IFF_ALLMULTI () {0x200;}' unless defined(&IFF_ALLMULTI);
    eval 'sub IFF_OACTIVE () {0x400;}' unless defined(&IFF_OACTIVE);
    eval 'sub IFF_SIMPLEX () {0x800;}' unless defined(&IFF_SIMPLEX);
    eval 'sub IFF_LINK0 () {0x1000;}' unless defined(&IFF_LINK0);
    eval 'sub IFF_LINK1 () {0x2000;}' unless defined(&IFF_LINK1);
    eval 'sub IFF_LINK2 () {0x4000;}' unless defined(&IFF_LINK2);
    eval 'sub IFF_ALTPHYS () { &IFF_LINK2;}' unless defined(&IFF_ALTPHYS);
    eval 'sub IFF_MULTICAST () {0x8000;}' unless defined(&IFF_MULTICAST);
    eval 'sub IFF_CANTCHANGE () {( &IFF_BROADCAST| &IFF_POINTOPOINT| &IFF_RUNNING| &IFF_OACTIVE|  &IFF_SIMPLEX| &IFF_MULTICAST| &IFF_ALLMULTI);}' unless defined(&IFF_CANTCHANGE);
    eval 'sub IFQ_MAXLEN () {50;}' unless defined(&IFQ_MAXLEN);
    eval 'sub IFNET_SLOWHZ () {1;}' unless defined(&IFNET_SLOWHZ);
    eval 'sub IFNAMSIZ () {16;}' unless defined(&IFNAMSIZ);
    eval 'sub ifr_addr () { ($ifr_ifru->{ifru_addr});}' unless defined(&ifr_addr);
    eval 'sub ifr_dstaddr () { ($ifr_ifru->{ifru_dstaddr});}' unless defined(&ifr_dstaddr);
    eval 'sub ifr_broadaddr () { ($ifr_ifru->{ifru_broadaddr});}' unless defined(&ifr_broadaddr);
    eval 'sub ifr_flags () { ($ifr_ifru->{ifru_flags});}' unless defined(&ifr_flags);
    eval 'sub ifr_metric () { ($ifr_ifru->{ifru_metric});}' unless defined(&ifr_metric);
    eval 'sub ifr_mtu () { ($ifr_ifru->{ifru_mtu});}' unless defined(&ifr_mtu);
    eval 'sub ifr_phys () { ($ifr_ifru->{ifru_phys});}' unless defined(&ifr_phys);
    eval 'sub ifr_media () { ($ifr_ifru->{ifru_media});}' unless defined(&ifr_media);
    eval 'sub ifr_data () { ($ifr_ifru->{ifru_data});}' unless defined(&ifr_data);
    eval 'sub _SIZEOF_ADDR_IFREQ {
        local($ifr) = @_;
	    eval q((($ifr). ($ifr_addr->{sa_len}) > $sizeof{\'struct sockaddr\'} ? ($sizeof{\'struct ifreq\'} - $sizeof{\'struct sockaddr\'} + ($ifr). ($ifr_addr->{sa_len})) : $sizeof{\'struct ifreq\'}));
    }' unless defined(&_SIZEOF_ADDR_IFREQ);
    eval 'sub ifc_buf () { ($ifc_ifcu->{ifcu_buf});}' unless defined(&ifc_buf);
    eval 'sub ifc_req () { ($ifc_ifcu->{ifcu_req});}' unless defined(&ifc_req);
    if(defined(&KERNEL)) {
	if(defined(&MALLOC_DECLARE)) {
	}
    }
    if(defined(&KERNEL)) {
	require 'net/if_var.ph';
    }
}
1;
