require '_h2ph_pre.ph';

unless(defined(&_NETINET_TCP_H_)) {
    eval 'sub _NETINET_TCP_H_ () {1;}' unless defined(&_NETINET_TCP_H_);
    if((defined(&BYTE_ORDER) ? &BYTE_ORDER : 0) == (defined(&LITTLE_ENDIAN) ? &LITTLE_ENDIAN : 0)) {
    }
    if((defined(&BYTE_ORDER) ? &BYTE_ORDER : 0) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : 0)) {
    }
    eval 'sub TH_FIN () {0x01;}' unless defined(&TH_FIN);
    eval 'sub TH_SYN () {0x02;}' unless defined(&TH_SYN);
    eval 'sub TH_RST () {0x04;}' unless defined(&TH_RST);
    eval 'sub TH_PUSH () {0x08;}' unless defined(&TH_PUSH);
    eval 'sub TH_ACK () {0x10;}' unless defined(&TH_ACK);
    eval 'sub TH_URG () {0x20;}' unless defined(&TH_URG);
    eval 'sub TH_FLAGS () {( &TH_FIN| &TH_SYN| &TH_RST| &TH_ACK| &TH_URG);}' unless defined(&TH_FLAGS);
    eval 'sub TCPOPT_EOL () {0;}' unless defined(&TCPOPT_EOL);
    eval 'sub TCPOPT_NOP () {1;}' unless defined(&TCPOPT_NOP);
    eval 'sub TCPOPT_MAXSEG () {2;}' unless defined(&TCPOPT_MAXSEG);
    eval 'sub TCPOLEN_MAXSEG () {4;}' unless defined(&TCPOLEN_MAXSEG);
    eval 'sub TCPOPT_WINDOW () {3;}' unless defined(&TCPOPT_WINDOW);
    eval 'sub TCPOLEN_WINDOW () {3;}' unless defined(&TCPOLEN_WINDOW);
    eval 'sub TCPOPT_SACK_PERMITTED () {4;}' unless defined(&TCPOPT_SACK_PERMITTED);
    eval 'sub TCPOLEN_SACK_PERMITTED () {2;}' unless defined(&TCPOLEN_SACK_PERMITTED);
    eval 'sub TCPOPT_SACK () {5;}' unless defined(&TCPOPT_SACK);
    eval 'sub TCPOPT_TIMESTAMP () {8;}' unless defined(&TCPOPT_TIMESTAMP);
    eval 'sub TCPOLEN_TIMESTAMP () {10;}' unless defined(&TCPOLEN_TIMESTAMP);
    eval 'sub TCPOLEN_TSTAMP_APPA () {( &TCPOLEN_TIMESTAMP+2);}' unless defined(&TCPOLEN_TSTAMP_APPA);
    eval 'sub TCPOPT_TSTAMP_HDR () {( &TCPOPT_NOP<<24| &TCPOPT_NOP<<16| &TCPOPT_TIMESTAMP<<8| &TCPOLEN_TIMESTAMP);}' unless defined(&TCPOPT_TSTAMP_HDR);
    eval 'sub TCPOPT_CC () {11;}' unless defined(&TCPOPT_CC);
    eval 'sub TCPOPT_CCNEW () {12;}' unless defined(&TCPOPT_CCNEW);
    eval 'sub TCPOPT_CCECHO () {13;}' unless defined(&TCPOPT_CCECHO);
    eval 'sub TCPOLEN_CC () {6;}' unless defined(&TCPOLEN_CC);
    eval 'sub TCPOLEN_CC_APPA () {( &TCPOLEN_CC+2);}' unless defined(&TCPOLEN_CC_APPA);
    eval 'sub TCPOPT_CC_HDR {
        local($ccopt) = @_;
	    eval q(( &TCPOPT_NOP<<24| &TCPOPT_NOP<<16|($ccopt)<<8| &TCPOLEN_CC));
    }' unless defined(&TCPOPT_CC_HDR);
    eval 'sub TCP_MSS () {512;}' unless defined(&TCP_MSS);
    eval 'sub TCP_MAXWIN () {65535;}' unless defined(&TCP_MAXWIN);
    eval 'sub TTCP_CLIENT_SND_WND () {4096;}' unless defined(&TTCP_CLIENT_SND_WND);
    eval 'sub TCP_MAX_WINSHIFT () {14;}' unless defined(&TCP_MAX_WINSHIFT);
    eval 'sub TCP_MAXHLEN () {(0xf<<2);}' unless defined(&TCP_MAXHLEN);
    eval 'sub TCP_MAXOLEN () {( &TCP_MAXHLEN - $sizeof{\'struct tcphdr\'});}' unless defined(&TCP_MAXOLEN);
    eval 'sub TCP_NODELAY () {0x01;}' unless defined(&TCP_NODELAY);
    eval 'sub TCP_MAXSEG () {0x02;}' unless defined(&TCP_MAXSEG);
    eval 'sub TCP_NOPUSH () {0x04;}' unless defined(&TCP_NOPUSH);
    eval 'sub TCP_NOOPT () {0x08;}' unless defined(&TCP_NOOPT);
}
1;
