require '_h2ph_pre.ph';

unless(defined(&PAM_MALLOC_H)) {
    eval 'sub PAM_MALLOC_H () {1;}' unless defined(&PAM_MALLOC_H);
    eval 'sub malloc {
        local($s) = @_;
	    eval q( &pam_malloc($s, &__FILE__, &__FUNCTION__, &__LINE__));
    }' unless defined(&malloc);
    eval 'sub calloc {
        local($n,$s) = @_;
	    eval q( &pam_calloc($n,$s, &__FILE__, &__FUNCTION__, &__LINE__));
    }' unless defined(&calloc);
    eval 'sub free {
        local($x) = @_;
	    eval q( &pam_free($x, &__FILE__, &__FUNCTION__, &__LINE__));
    }' unless defined(&free);
    eval 'sub realloc {
        local($x,$s) = @_;
	    eval q( &pam_realloc($x,$s, &__FILE__, &__FUNCTION__, &__LINE__));
    }' unless defined(&realloc);
    eval 'sub exit {
        local($i) = @_;
	    eval q( &pam_exit($i, &__FILE__, &__FUNCTION__, &__LINE__));
    }' unless defined(&exit);
    require 'sys/types.ph';
    eval 'sub PAM_MALLOC_LEAKED () {01;}' unless defined(&PAM_MALLOC_LEAKED);
    eval 'sub PAM_MALLOC_REQUEST () {02;}' unless defined(&PAM_MALLOC_REQUEST);
    eval 'sub PAM_MALLOC_FREE () {04;}' unless defined(&PAM_MALLOC_FREE);
    eval 'sub PAM_MALLOC_EXCH () {( &PAM_MALLOC_FREED| &PAM_MALLOC_EXCH);}' unless defined(&PAM_MALLOC_EXCH);
    eval 'sub PAM_MALLOC_RESIZE () {010;}' unless defined(&PAM_MALLOC_RESIZE);
    eval 'sub PAM_MALLOC_FAIL () {020;}' unless defined(&PAM_MALLOC_FAIL);
    eval 'sub PAM_MALLOC_NULL () {040;}' unless defined(&PAM_MALLOC_NULL);
    eval 'sub PAM_MALLOC_VERIFY () {0100;}' unless defined(&PAM_MALLOC_VERIFY);
    eval 'sub PAM_MALLOC_FUNC () {0200;}' unless defined(&PAM_MALLOC_FUNC);
    eval 'sub PAM_MALLOC_PAUSE () {0400;}' unless defined(&PAM_MALLOC_PAUSE);
    eval 'sub PAM_MALLOC_STOP () {01000;}' unless defined(&PAM_MALLOC_STOP);
    eval 'sub PAM_MALLOC_ALL () {0777;}' unless defined(&PAM_MALLOC_ALL);
    eval 'sub PAM_MALLOC_DEFAULT () {( &PAM_MALLOC_LEAKED| &PAM_MALLOC_PAUSE| &PAM_MALLOC_FAIL);}' unless defined(&PAM_MALLOC_DEFAULT);
    require 'stdio.ph';
}
1;
