require '_h2ph_pre.ph';

unless(defined(&_SECURITY_PAM_MODULES_H)) {
    eval 'sub _SECURITY_PAM_MODULES_H () {1;}' unless defined(&_SECURITY_PAM_MODULES_H);
    if(!defined( &PIC)  && !defined( &PAM_STATIC)) {
	eval 'sub PAM_STATIC () {1;}' unless defined(&PAM_STATIC);
    }
    unless(defined(&PAM_STATIC)) {
	eval 'sub PAM_DYNAMIC () {1;}' unless defined(&PAM_DYNAMIC);
    }
    if(defined(&PAM_STATIC)) {
	require 'linker_set.ph';
    }
    require 'security/_pam_types.ph';
    eval 'sub PAM_AUTHTOK () {6;}' unless defined(&PAM_AUTHTOK);
    eval 'sub PAM_OLDAUTHTOK () {7;}' unless defined(&PAM_OLDAUTHTOK);
    if(defined(&PAM_STATIC)) {
	eval 'sub PAM_EXTERN () { &static;}' unless defined(&PAM_EXTERN);
	if(defined(&PAM_SM_AUTH)) {
	    eval 'sub PAM_SM_AUTH_ENTRY () { &pam_sm_authenticate;}' unless defined(&PAM_SM_AUTH_ENTRY);
	    eval 'sub PAM_SM_SETCRED_ENTRY () { &pam_sm_setcred;}' unless defined(&PAM_SM_SETCRED_ENTRY);
	} else {
	    eval 'sub PAM_SM_AUTH_ENTRY () { &NULL;}' unless defined(&PAM_SM_AUTH_ENTRY);
	    eval 'sub PAM_SM_SETCRED_ENTRY () { &NULL;}' unless defined(&PAM_SM_SETCRED_ENTRY);
	}
	if(defined(&PAM_SM_ACCOUNT)) {
	    eval 'sub PAM_SM_ACCOUNT_ENTRY () { &pam_sm_acct_mgmt;}' unless defined(&PAM_SM_ACCOUNT_ENTRY);
	} else {
	    eval 'sub PAM_SM_ACCOUNT_ENTRY () { &NULL;}' unless defined(&PAM_SM_ACCOUNT_ENTRY);
	}
	if(defined(&PAM_SM_SESSION)) {
	    eval 'sub PAM_SM_OPEN_SESSION_ENTRY () { &pam_sm_open_session;}' unless defined(&PAM_SM_OPEN_SESSION_ENTRY);
	    eval 'sub PAM_SM_CLOSE_SESSION_ENTRY () { &pam_sm_close_session;}' unless defined(&PAM_SM_CLOSE_SESSION_ENTRY);
	} else {
	    eval 'sub PAM_SM_OPEN_SESSION_ENTRY () { &NULL;}' unless defined(&PAM_SM_OPEN_SESSION_ENTRY);
	    eval 'sub PAM_SM_CLOSE_SESSION_ENTRY () { &NULL;}' unless defined(&PAM_SM_CLOSE_SESSION_ENTRY);
	}
	if(defined(&PAM_SM_PASSWORD)) {
	    eval 'sub PAM_SM_PASSWORD_ENTRY () { &pam_sm_chauthtok;}' unless defined(&PAM_SM_PASSWORD_ENTRY);
	} else {
	    eval 'sub PAM_SM_PASSWORD_ENTRY () { &NULL;}' unless defined(&PAM_SM_PASSWORD_ENTRY);
	}
	eval 'sub PAM_MODULE_ENTRY {
	    local($name) = @_;
    	    eval q( &static \'struct pam_module\'  &_pam_modstruct = { $name,  &PAM_SM_AUTH_ENTRY,  &PAM_SM_SETCRED_ENTRY,  &PAM_SM_ACCOUNT_ENTRY,  &PAM_SM_OPEN_SESSION_ENTRY,  &PAM_SM_CLOSE_SESSION_ENTRY,  &PAM_SM_PASSWORD_ENTRY };  &DATA_SET( &_pam_static_modules,  &_pam_modstruct));
	}' unless defined(&PAM_MODULE_ENTRY);
    } else {
	eval 'sub PAM_EXTERN () { &extern;}' unless defined(&PAM_EXTERN);
	eval 'sub PAM_MODULE_ENTRY {
	    local($name) = @_;
    	    eval q();
	}' unless defined(&PAM_MODULE_ENTRY);
    }
    if((defined( &PAM_STATIC)  && defined( &PAM_SM_AUTH)) || !defined( &PAM_STATIC)) {
    }
    if((defined( &PAM_STATIC)  && defined( &PAM_SM_ACCOUNT)) || !defined( &PAM_STATIC)) {
    }
    if((defined( &PAM_STATIC)  && defined( &PAM_SM_SESSION)) || !defined( &PAM_STATIC)) {
    }
    if((defined( &PAM_STATIC)  && defined( &PAM_SM_PASSWORD)) || !defined( &PAM_STATIC)) {
    }
    eval 'sub PAM_PRELIM_CHECK () {0x4000;}' unless defined(&PAM_PRELIM_CHECK);
    eval 'sub PAM_UPDATE_AUTHTOK () {0x2000;}' unless defined(&PAM_UPDATE_AUTHTOK);
    eval 'sub PAM_DATA_REPLACE () {0x20000000;}' unless defined(&PAM_DATA_REPLACE);
    require 'security/_pam_compat.ph';
}
1;
