require '_h2ph_pre.ph';

unless(defined(&_SYS_FTAPE_H_)) {
    eval 'sub _SYS_FTAPE_H_ () {1;}' unless defined(&_SYS_FTAPE_H_);
    require 'sys/ioccom.ph';
    eval 'sub QCV_BLKSIZE () {1024;}' unless defined(&QCV_BLKSIZE);
    eval 'sub QCV_SEGSIZE () {32768;}' unless defined(&QCV_SEGSIZE);
    eval 'sub QCV_BLKSEG () {32;}' unless defined(&QCV_BLKSEG);
    eval 'sub QCV_ECCSIZE () {3072;}' unless defined(&QCV_ECCSIZE);
    eval 'sub QCV_ECCBLKS () {3;}' unless defined(&QCV_ECCBLKS);
    eval 'sub QCV_NFMT () {3;}' unless defined(&QCV_NFMT);
    eval 'sub QCV_NLEN () {5;}' unless defined(&QCV_NLEN);
    eval 'sub QCV_HDRMAGIC () {0xaa55aa55;}' unless defined(&QCV_HDRMAGIC);
    eval 'sub QCV_FSMAGIC () {0x33cc33cc;}' unless defined(&QCV_FSMAGIC);
    eval 'sub UCHAR () {\'unsigned char\';}' unless defined(&UCHAR);
    eval 'sub USHORT () {\'unsigned short\';}' unless defined(&USHORT);
    eval 'sub ULONG () {\'unsigned long\';}' unless defined(&ULONG);
    eval 'sub QIOREAD () { &_IOWR(ord(\'q\'), 1,  &QIC_Segment);}' unless defined(&QIOREAD);
    eval 'sub QIOWRITE () { &_IOW(ord(\'q\'), 2,  &QIC_Segment);}' unless defined(&QIOWRITE);
    eval 'sub QIOREWIND () { &_IO(ord(\'q\'), 3);}' unless defined(&QIOREWIND);
    eval 'sub QIOBOT () { &_IO(ord(\'q\'), 4);}' unless defined(&QIOBOT);
    eval 'sub QIOEOT () { &_IO(ord(\'q\'), 5);}' unless defined(&QIOEOT);
    eval 'sub QIOTRACK () { &_IOW(ord(\'q\'), 6, \'int\');}' unless defined(&QIOTRACK);
    eval 'sub QIOSEEKLP () { &_IO(ord(\'q\'), 7);}' unless defined(&QIOSEEKLP);
    eval 'sub QIOFORWARD () { &_IO(ord(\'q\'), 8);}' unless defined(&QIOFORWARD);
    eval 'sub QIOSTOP () { &_IO(ord(\'q\'), 9);}' unless defined(&QIOSTOP);
    eval 'sub QIOPRIMARY () { &_IO(ord(\'q\'), 10);}' unless defined(&QIOPRIMARY);
    eval 'sub QIOFORMAT () { &_IO(ord(\'q\'), 11);}' unless defined(&QIOFORMAT);
    eval 'sub QIOVERIFY () { &_IO(ord(\'q\'), 12);}' unless defined(&QIOVERIFY);
    eval 'sub QIOWRREF () { &_IO(ord(\'q\'), 13);}' unless defined(&QIOWRREF);
    eval 'sub QIOSTATUS () { &_IOR(ord(\'q\'), 14, \'int\');}' unless defined(&QIOSTATUS);
    eval 'sub QIOCONFIG () { &_IOR(ord(\'q\'), 15, \'int\');}' unless defined(&QIOCONFIG);
    eval 'sub QIOGEOM () { &_IOR(ord(\'q\'), 16,  &QIC_Geom);}' unless defined(&QIOGEOM);
    eval 'sub QIOHWINFO () { &_IOR(ord(\'q\'), 17,  &QIC_HWInfo);}' unless defined(&QIOHWINFO);
    eval 'sub QIOSENDHDR () { &_IOW(ord(\'q\'), 18,  &QIC_Segment);}' unless defined(&QIOSENDHDR);
    eval 'sub QIORECVHDR () { &_IOWR(ord(\'q\'), 19,  &QIC_Segment);}' unless defined(&QIORECVHDR);
    eval 'sub QS_READY () {0x01;}' unless defined(&QS_READY);
    eval 'sub QS_ERROR () {0x02;}' unless defined(&QS_ERROR);
    eval 'sub QS_CART () {0x04;}' unless defined(&QS_CART);
    eval 'sub QS_RDONLY () {0x08;}' unless defined(&QS_RDONLY);
    eval 'sub QS_NEWCART () {0x10;}' unless defined(&QS_NEWCART);
    eval 'sub QS_FMTOK () {0x20;}' unless defined(&QS_FMTOK);
    eval 'sub QS_BOT () {0x40;}' unless defined(&QS_BOT);
    eval 'sub QS_EOT () {0x80;}' unless defined(&QS_EOT);
    eval 'sub QCF_RTMASK () {0x18;}' unless defined(&QCF_RTMASK);
    eval 'sub QCF_RT250 () {0x00;}' unless defined(&QCF_RT250);
    eval 'sub QCF_RT2 () {0x01;}' unless defined(&QCF_RT2);
    eval 'sub QCF_RT500 () {0x02;}' unless defined(&QCF_RT500);
    eval 'sub QCF_RT1 () {0x03;}' unless defined(&QCF_RT1);
    eval 'sub QCF_EXTRA () {0x40;}' unless defined(&QCF_EXTRA);
    eval 'sub QCF_QIC80 () {0x80;}' unless defined(&QCF_QIC80);
    eval 'sub QTS_FMMASK () {0x0f;}' unless defined(&QTS_FMMASK);
    eval 'sub QTS_LNMASK () {0xf0;}' unless defined(&QTS_LNMASK);
    eval 'sub QTS_QIC40 () {0x01;}' unless defined(&QTS_QIC40);
    eval 'sub QTS_QIC80 () {0x02;}' unless defined(&QTS_QIC80);
    eval 'sub QTS_QIC500 () {0x03;}' unless defined(&QTS_QIC500);
    eval 'sub QTS_LEN1 () {0x10;}' unless defined(&QTS_LEN1);
    eval 'sub QTS_LEN2 () {0x20;}' unless defined(&QTS_LEN2);
    eval 'sub QTS_LEN3 () {0x30;}' unless defined(&QTS_LEN3);
    eval 'sub QTS_LEN4 () {0x40;}' unless defined(&QTS_LEN4);
    eval 'sub QTS_LEN5 () {0x50;}' unless defined(&QTS_LEN5);
}
1;
