require '_h2ph_pre.ph';

unless(defined(&_SYS_LKM_H_)) {
    eval 'sub _SYS_LKM_H_ () {1;}' unless defined(&_SYS_LKM_H_);
    eval("sub LM_SYSCALL () { 0; }") unless defined(&LM_SYSCALL);
    eval("sub LM_VFS () { 1; }") unless defined(&LM_VFS);
    eval("sub LM_DEV () { 2; }") unless defined(&LM_DEV);
    eval("sub LM_STRMOD () { 3; }") unless defined(&LM_STRMOD);
    eval("sub LM_EXEC () { 4; }") unless defined(&LM_EXEC);
    eval("sub LM_MISC () { 5; }") unless defined(&LM_MISC);
    eval 'sub LKM_VERSION () {1;}' unless defined(&LKM_VERSION);
    eval 'sub MAXLKMNAME () {32;}' unless defined(&MAXLKMNAME);
    if(defined(&KERNEL)) {
	eval("sub LM_DT_BLOCK () { 0; }") unless defined(&LM_DT_BLOCK);
	eval("sub LM_DT_CHAR () { 1; }") unless defined(&LM_DT_CHAR);
	eval 'sub LKM_E_LOAD () {1;}' unless defined(&LKM_E_LOAD);
	eval 'sub LKM_E_UNLOAD () {2;}' unless defined(&LKM_E_UNLOAD);
	eval 'sub LKM_E_STAT () {3;}' unless defined(&LKM_E_STAT);
	eval 'sub LKM_ANON () {(-1);}' unless defined(&LKM_ANON);
	eval 'sub MOD_PRIVATE {
	    local($name) = @_;
    	    eval q($name   &_mod_struct);
	}' unless defined(&MOD_PRIVATE);
	eval 'sub MOD_DECL {
	    local($name) = @_;
    	    eval q( &static \'int\' $name   &_load  &__P((\'struct lkm_table\' * &lkmtp, \'int\'  &cmd));  &static \'int\' $name   &_unload  &__P((\'struct lkm_table\' * &lkmtp, \'int\'  &cmd)); \'int\' $name   &_mod  &__P((\'struct lkm_table\' * &lkmtp, \'int\'  &cmd, \'int\'  &ver)));
	}' unless defined(&MOD_DECL);
	eval 'sub MOD_SYSCALL {
	    local($name,$callslot,$sysentp) = @_;
    	    eval q( &static \'struct lkm_syscall\'  &MOD_PRIVATE($name) = {  &LM_SYSCALL,  &LKM_VERSION, $name, $callslot, $sysentp });
	}' unless defined(&MOD_SYSCALL);
	eval 'sub MOD_VFS {
	    local($name,$vnodeops,$vfsconf) = @_;
    	    eval q( &static \'struct lkm_vfs\'  &MOD_PRIVATE($name) = {  &LM_VFS,  &LKM_VERSION, $name, 0, $vnodeops, $vfsconf });
	}' unless defined(&MOD_VFS);
	eval 'sub MOD_DEV {
	    local($name,$devtype,$devslot,$devp) = @_;
    	    eval q( &MOD_DECL;  &static \'struct lkm_dev\'  &MOD_PRIVATE = {  &LM_DEV,  &LKM_VERSION, $name  \\"_mod\\", $devslot, $devtype, { $devp } });
	}' unless defined(&MOD_DEV);
	eval 'sub MOD_EXEC {
	    local($name,$execslot,$execsw) = @_;
    	    eval q( &MOD_DECL($name);  &static \'struct lkm_exec\'  &MOD_PRIVATE($name) = {  &LM_EXEC,  &LKM_VERSION, $name  \\"_mod\\", $execslot, $execsw });
	}' unless defined(&MOD_EXEC);
	eval 'sub MOD_MISC {
	    local($name) = @_;
    	    eval q( &MOD_DECL($name);  &static \'struct lkm_misc\'  &MOD_PRIVATE($name) = {  &LM_MISC,  &LKM_VERSION, $name  \\"_mod\\" });
	}' unless defined(&MOD_MISC);
	eval 'sub MOD_DISPATCH {
	    local($name,$lkmtp,$cmd,$ver,$load,$unload,$stat) = @_;
    	    eval q( &if ($ver !=  &LKM_VERSION)  &return  &EINVAL;  &switch ($cmd) { \'int\'  &error;  &case  &LKM_E_LOAD:  ($lkmtp->{private}->{lkm_any}) = &  &MOD_PRIVATE($name) ;  &if ( &lkmexists($lkmtp))  &return  &EEXIST;  &if (( &error = $load($lkmtp, $cmd)))  &return  &error;  &break;  &case  &LKM_E_UNLOAD:  &if (( &error = $unload($lkmtp, $cmd)))  &return  &error;  &break;  &case  &LKM_E_STAT:  &if (( &error = $stat($lkmtp, $cmd)))  &return  &error;  &break; }  &return  &lkmdispatch($lkmtp, $cmd););
	}' unless defined(&MOD_DISPATCH);
	eval 'sub DISPATCH {
	    local($name,$lkmtp,$cmd,$ver,$load,$unload,$stat) = @_;
    	    eval q( &MOD_DISPATCH($name,$lkmtp,$cmd,$ver,$load,$unload,$stat));
	}' unless defined(&DISPATCH);
    }
    eval 'sub LMRESERV () { &_IOWR(ord(\'K\'), 0, \'struct lmc_resrv\');}' unless defined(&LMRESERV);
    eval 'sub LMLOADBUF () { &_IOW(ord(\'K\'), 1, \'struct lmc_loadbuf\');}' unless defined(&LMLOADBUF);
    eval 'sub LMUNRESRV () { &_IO(ord(\'K\'), 2);}' unless defined(&LMUNRESRV);
    eval 'sub LMREADY () { &_IOW(ord(\'K\'), 3, \'int\');}' unless defined(&LMREADY);
    eval 'sub LMLOAD () { &_IOW(ord(\'K\'), 9, \'struct lmc_load\');}' unless defined(&LMLOAD);
    eval 'sub LMUNLOAD () { &_IOWR(ord(\'K\'), 10, \'struct lmc_unload\');}' unless defined(&LMUNLOAD);
    eval 'sub LMSTAT () { &_IOWR(ord(\'K\'), 11, \'struct lmc_stat\');}' unless defined(&LMSTAT);
    eval 'sub MODIOBUF () {512;}' unless defined(&MODIOBUF);
}
1;
