require '_h2ph_pre.ph';

unless(defined(&_SYS_MBUF_H_)) {
    eval 'sub _SYS_MBUF_H_ () {1;}' unless defined(&_SYS_MBUF_H_);
    eval 'sub MLEN () {( &MSIZE - $sizeof{\'struct m_hdr\'});}' unless defined(&MLEN);
    eval 'sub MHLEN () {( &MLEN - $sizeof{\'struct pkthdr\'});}' unless defined(&MHLEN);
    eval 'sub MINCLSIZE () {( &MHLEN +  &MLEN);}' unless defined(&MINCLSIZE);
    eval 'sub M_MAXCOMPRESS () {( &MHLEN / 2);}' unless defined(&M_MAXCOMPRESS);
    eval 'sub mtod {
        local($m,$t) = @_;
	    eval q(((($m)-> &m_data)));
    }' unless defined(&mtod);
    eval 'sub dtom {
        local($x) = @_;
	    eval q(((($x) & ~( &MSIZE-1))));
    }' unless defined(&dtom);
    eval 'sub mtocl {
        local($x) = @_;
	    eval q((( -  &mbutl) >>  &MCLSHIFT));
    }' unless defined(&mtocl);
    eval 'sub cltom {
        local($x) = @_;
	    eval q((( &mbutl + (($x) <<  &MCLSHIFT))));
    }' unless defined(&cltom);
    eval 'sub m_next () { ($m_hdr->{mh_next});}' unless defined(&m_next);
    eval 'sub m_len () { ($m_hdr->{mh_len});}' unless defined(&m_len);
    eval 'sub m_data () { ($m_hdr->{mh_data});}' unless defined(&m_data);
    eval 'sub m_type () { ($m_hdr->{mh_type});}' unless defined(&m_type);
    eval 'sub m_flags () { ($m_hdr->{mh_flags});}' unless defined(&m_flags);
    eval 'sub m_nextpkt () { ($m_hdr->{mh_nextpkt});}' unless defined(&m_nextpkt);
    eval 'sub m_act () { &m_nextpkt;}' unless defined(&m_act);
    eval 'sub m_pkthdr () { ($M_dat->{MH}->{MH_pkthdr});}' unless defined(&m_pkthdr);
    eval 'sub m_ext () { ($M_dat->{MH}->{MH_dat}->{MH_ext});}' unless defined(&m_ext);
    eval 'sub m_pktdat () { ($M_dat->{MH}->{MH_dat}->{MH_databuf});}' unless defined(&m_pktdat);
    eval 'sub m_dat () { ($M_dat->{M_databuf});}' unless defined(&m_dat);
    eval 'sub M_EXT () {0x0001;}' unless defined(&M_EXT);
    eval 'sub M_PKTHDR () {0x0002;}' unless defined(&M_PKTHDR);
    eval 'sub M_EOR () {0x0004;}' unless defined(&M_EOR);
    eval 'sub M_PROTO1 () {0x0008;}' unless defined(&M_PROTO1);
    eval 'sub M_BCAST () {0x0100;}' unless defined(&M_BCAST);
    eval 'sub M_MCAST () {0x0200;}' unless defined(&M_MCAST);
    eval 'sub M_FRAG () {0x0400;}' unless defined(&M_FRAG);
    eval 'sub M_COPYFLAGS () {( &M_PKTHDR| &M_EOR| &M_PROTO1| &M_BCAST| &M_MCAST);}' unless defined(&M_COPYFLAGS);
    eval 'sub MT_FREE () {0;}' unless defined(&MT_FREE);
    eval 'sub MT_DATA () {1;}' unless defined(&MT_DATA);
    eval 'sub MT_HEADER () {2;}' unless defined(&MT_HEADER);
    eval 'sub MT_SONAME () {8;}' unless defined(&MT_SONAME);
    eval 'sub MT_FTABLE () {11;}' unless defined(&MT_FTABLE);
    eval 'sub MT_CONTROL () {14;}' unless defined(&MT_CONTROL);
    eval 'sub MT_OOBDATA () {15;}' unless defined(&MT_OOBDATA);
    eval 'sub M_DONTWAIT () {1;}' unless defined(&M_DONTWAIT);
    eval 'sub M_WAIT () {0;}' unless defined(&M_WAIT);
    eval 'sub MBUFLOCK {
        local($code) = @_;
	    eval q( &do { \'int\'  &ms =  &splimp(); { $code }  &splx( &ms); }  &while(0));
    }' unless defined(&MBUFLOCK);
    eval 'sub MGET {
        local($m, $how, $type) = @_;
	    eval q({ \'int\'  &_ms =  &splimp();  &if ( &mmbfree == 0)  &m_mballoc(1, );  &if (( =  &mmbfree) != 0) {  &mmbfree = -> &m_next;  ($mbstat->{m_mtypes[&MT_FREE]})--; -> &m_type = ;  ($mbstat->{m_mtypes[$type]})++; -> &m_next =  &NULL; -> &m_nextpkt =  &NULL; ($m)-> &m_data = ($m)-> &m_dat; ($m)-> &m_flags = 0;  &splx( &_ms); }  &else {  &splx( &_ms); ($m) =  &m_retry(($how), ($type)); } });
    }' unless defined(&MGET);
    eval 'sub MGETHDR {
        local($m, $how, $type) = @_;
	    eval q({ \'int\'  &_ms =  &splimp();  &if ( &mmbfree == 0)  &m_mballoc(1, );  &if (( =  &mmbfree) != 0) {  &mmbfree = -> &m_next;  ($mbstat->{m_mtypes[&MT_FREE]})--; -> &m_type = ;  ($mbstat->{m_mtypes[$type]})++; -> &m_next =  &NULL; -> &m_nextpkt =  &NULL; ($m)-> &m_data = ($m)-> &m_pktdat; ($m)-> &m_flags =  &M_PKTHDR;  &splx( &_ms); }  &else {  &splx( &_ms); ($m) =  &m_retryhdr(($how), ($type)); } });
    }' unless defined(&MGETHDR);
    eval 'sub MCLALLOC {
        local($p, $how) = @_;
	    eval q( &MBUFLOCK(  &if ( &mclfree == 0)  &m_clalloc(1, );  &if (( =  &mclfree) != 0) { ++ $mclrefcnt[ &mtocl];  ($mbstat->{m_clfree})--;  &mclfree = (($p))-> &mcl_next; } ));
    }' unless defined(&MCLALLOC);
    eval 'sub MCLGET {
        local($m, $how) = @_;
	    eval q({  &MCLALLOC(($m)-> ($m_ext->{ext_buf}), ($how));  &if (($m)-> ($m_ext->{ext_buf}) !=  &NULL) { ($m)-> &m_data = ($m)-> ($m_ext->{ext_buf}); ($m)-> &m_flags |=  &M_EXT; ($m)-> ($m_ext->{ext_free}) =  &NULL; ($m)-> ($m_ext->{ext_ref}) =  &NULL; ($m)-> ($m_ext->{ext_size}) =  &MCLBYTES; } });
    }' unless defined(&MCLGET);
    eval 'sub MCLFREE1 {
        local($p) = @_;
	    eval q( &do {  &if (-- $mclrefcnt[ &mtocl] == 0) { ()-> &mcl_next =  &mclfree;  &mclfree = ($p);  ($mbstat->{m_clfree})++; } }  &while (0));
    }' unless defined(&MCLFREE1);
    eval 'sub MCLFREE {
        local($p) = @_;
	    eval q( &MBUFLOCK(  &MCLFREE1($p); ));
    }' unless defined(&MCLFREE);
    eval 'sub MEXTFREE1 {
        local($m) = @_;
	    eval q( &do {  &if (($m)-> ($m_ext->{ext_free})) (*(($m)-> ($m_ext->{ext_free})))(($m)-> ($m_ext->{ext_buf}), ($m)-> ($m_ext->{ext_size}));  &else { \'char\' * &p = ($m)-> ($m_ext->{ext_buf});  &MCLFREE1( &p); } }  &while (0));
    }' unless defined(&MEXTFREE1);
    eval 'sub MEXTFREE {
        local($m) = @_;
	    eval q( &MBUFLOCK(  &MCLEXTFREE1($m); ));
    }' unless defined(&MEXTFREE);
    eval 'sub MFREE {
        local($m, $n) = @_;
	    eval q( &MBUFLOCK(  ($mbstat->{m_mtypes[&(m)}->{m_type]})--;  &if (($m)-> &m_flags &  &M_EXT) {  &MEXTFREE1($m); } ($n) = ($m)-> &m_next; ($m)-> &m_type =  &MT_FREE;  ($mbstat->{m_mtypes[&MT_FREE]})++; ($m)-> &m_next =  &mmbfree;  &mmbfree = ($m); ));
    }' unless defined(&MFREE);
    eval 'sub M_COPY_PKTHDR {
        local($to, $from) = @_;
	    eval q({ ($to)-> &m_pkthdr = ($from)-> &m_pkthdr; ($to)-> &m_flags = ($from)-> &m_flags &  &M_COPYFLAGS; ($to)-> &m_data = ($to)-> &m_pktdat; });
    }' unless defined(&M_COPY_PKTHDR);
    eval 'sub M_ALIGN {
        local($m, $len) = @_;
	    eval q({ ($m)-> &m_data += ( &MLEN - ($len)) &~ ($sizeof{\'long\'} - 1); });
    }' unless defined(&M_ALIGN);
    eval 'sub MH_ALIGN {
        local($m, $len) = @_;
	    eval q({ ($m)-> &m_data += ( &MHLEN - ($len)) &~ ($sizeof{\'long\'} - 1); });
    }' unless defined(&MH_ALIGN);
    eval 'sub M_LEADINGSPACE {
        local($m) = @_;
	    eval q((($m)-> &m_flags &  &M_EXT ? 0: ($m)-> &m_flags &  &M_PKTHDR ? ($m)-> &m_data - ($m)-> &m_pktdat : ($m)-> &m_data - ($m)-> &m_dat));
    }' unless defined(&M_LEADINGSPACE);
    eval 'sub M_TRAILINGSPACE {
        local($m) = @_;
	    eval q((($m)-> &m_flags &  &M_EXT ? ($m)-> ($m_ext->{ext_buf}) + ($m)-> ($m_ext->{ext_size}) - (($m)-> &m_data + ($m)-> &m_len) : ($m)-> $m_dat[ &MLEN] - (($m)-> &m_data + ($m)-> &m_len)));
    }' unless defined(&M_TRAILINGSPACE);
    eval 'sub M_PREPEND {
        local($m, $plen, $how) = @_;
	    eval q({  &if ( &M_LEADINGSPACE($m) >= ($plen)) { ($m)-> &m_data -= ($plen); ($m)-> &m_len += ($plen); }  &else ($m) =  &m_prepend(($m), ($plen), ($how));  &if (($m)  && ($m)-> &m_flags &  &M_PKTHDR) ($m)-> ($m_pkthdr->{len}) += ($plen); });
    }' unless defined(&M_PREPEND);
    eval 'sub MCHTYPE {
        local($m, $t) = @_;
	    eval q( &do {  &MBUFLOCK( ($mbstat->{m_mtypes[&(m)}->{m_type]})--;  ($mbstat->{m_mtypes[$t]})++;); ($m)-> &m_type = $t;}  &while(0));
    }' unless defined(&MCHTYPE);
    eval 'sub M_COPYALL () {1000000000;}' unless defined(&M_COPYALL);
    eval 'sub m_copy {
        local($m, $o, $l) = @_;
	    eval q( &m_copym(($m), ($o), ($l),  &M_DONTWAIT));
    }' unless defined(&m_copy);
    if(defined(&KERNEL)) {
    }
}
1;
