require '_h2ph_pre.ph';

unless(defined(&_CTYPE_H_)) {
    eval 'sub _CTYPE_H_ () {1;}' unless defined(&_CTYPE_H_);
    require 'runetype.ph';
    eval 'sub _A () {0x00000100;}' unless defined(&_A);
    eval 'sub _C () {0x00000200;}' unless defined(&_C);
    eval 'sub _D () {0x00000400;}' unless defined(&_D);
    eval 'sub _G () {0x00000800;}' unless defined(&_G);
    eval 'sub _L () {0x00001000;}' unless defined(&_L);
    eval 'sub _P () {0x00002000;}' unless defined(&_P);
    eval 'sub _S () {0x00004000;}' unless defined(&_S);
    eval 'sub _U () {0x00008000;}' unless defined(&_U);
    eval 'sub _X () {0x00010000;}' unless defined(&_X);
    eval 'sub _B () {0x00020000;}' unless defined(&_B);
    eval 'sub _R () {0x00040000;}' unless defined(&_R);
    eval 'sub _I () {0x00080000;}' unless defined(&_I);
    eval 'sub _T () {0x00100000;}' unless defined(&_T);
    eval 'sub _Q () {0x00200000;}' unless defined(&_Q);
    if(!defined( &_ANSI_SOURCE)  && !defined( &_POSIX_SOURCE)) {
    }
    eval 'sub __istype {
        local($c,$f) = @_;
	    eval q((!! &__maskrune(($c),($f))));
    }' unless defined(&__istype);
    eval 'sub isalnum {
        local($c) = @_;
	    eval q( &__istype(($c),  &_A| &_D));
    }' unless defined(&isalnum);
    eval 'sub isalpha {
        local($c) = @_;
	    eval q( &__istype(($c),  &_A));
    }' unless defined(&isalpha);
    eval 'sub iscntrl {
        local($c) = @_;
	    eval q( &__istype(($c),  &_C));
    }' unless defined(&iscntrl);
    eval 'sub isdigit {
        local($c) = @_;
	    eval q( &__isctype(($c),  &_D));
    }' unless defined(&isdigit);
    eval 'sub isgraph {
        local($c) = @_;
	    eval q( &__istype(($c),  &_G));
    }' unless defined(&isgraph);
    eval 'sub islower {
        local($c) = @_;
	    eval q( &__istype(($c),  &_L));
    }' unless defined(&islower);
    eval 'sub isprint {
        local($c) = @_;
	    eval q( &__istype(($c),  &_R));
    }' unless defined(&isprint);
    eval 'sub ispunct {
        local($c) = @_;
	    eval q( &__istype(($c),  &_P));
    }' unless defined(&ispunct);
    eval 'sub isspace {
        local($c) = @_;
	    eval q( &__istype(($c),  &_S));
    }' unless defined(&isspace);
    eval 'sub isupper {
        local($c) = @_;
	    eval q( &__istype(($c),  &_U));
    }' unless defined(&isupper);
    eval 'sub isxdigit {
        local($c) = @_;
	    eval q( &__isctype(($c),  &_X));
    }' unless defined(&isxdigit);
    eval 'sub tolower {
        local($c) = @_;
	    eval q( &__tolower($c));
    }' unless defined(&tolower);
    eval 'sub toupper {
        local($c) = @_;
	    eval q( &__toupper($c));
    }' unless defined(&toupper);
    if(!defined( &_ANSI_SOURCE)  && !defined( &_POSIX_SOURCE)) {
	eval 'sub isascii {
	    local($c) = @_;
    	    eval q(((($c) & ~0x7f) == 0));
	}' unless defined(&isascii);
	eval 'sub isblank {
	    local($c) = @_;
    	    eval q( &__istype(($c),  &_B));
	}' unless defined(&isblank);
	eval 'sub toascii {
	    local($c) = @_;
    	    eval q((($c) & 0x7f));
	}' unless defined(&toascii);
	eval 'sub digittoint {
	    local($c) = @_;
    	    eval q( &__maskrune(($c), 0xff));
	}' unless defined(&digittoint);
	eval 'sub ishexnumber {
	    local($c) = @_;
    	    eval q( &__istype(($c),  &_X));
	}' unless defined(&ishexnumber);
	eval 'sub isideogram {
	    local($c) = @_;
    	    eval q( &__istype(($c),  &_I));
	}' unless defined(&isideogram);
	eval 'sub isnumber {
	    local($c) = @_;
    	    eval q( &__istype(($c),  &_D));
	}' unless defined(&isnumber);
	eval 'sub isphonogram {
	    local($c) = @_;
    	    eval q( &__istype(($c),  &_Q));
	}' unless defined(&isphonogram);
	eval 'sub isrune {
	    local($c) = @_;
    	    eval q( &__istype(($c), 0xffffff00));
	}' unless defined(&isrune);
	eval 'sub isspecial {
	    local($c) = @_;
    	    eval q( &__istype(($c),  &_T));
	}' unless defined(&isspecial);
    }
    if(defined(&_EXTERNALIZE_CTYPE_INLINES_)) {
	eval 'sub _USE_CTYPE_INLINE_ () {1;}' unless defined(&_USE_CTYPE_INLINE_);
	eval 'sub static () {1;}' unless defined(&static);
	eval 'sub __inline () {1;}' unless defined(&__inline);
    }
    if(!defined( &_DONT_USE_CTYPE_INLINE_)  && (defined( &_USE_CTYPE_INLINE_) || defined( &__GNUC__) || defined( &__cplusplus))) {
    } else {
    }
}
1;
