require '_h2ph_pre.ph';

unless(defined(&_IO_STDIO_H)) {
    eval 'sub _IO_STDIO_H () {1;}' unless defined(&_IO_STDIO_H);
    require '_G_config.ph';
    eval 'sub _IO_pos_t () { &_G_fpos_t;}' unless defined(&_IO_pos_t);
    eval 'sub _IO_fpos_t () { &_G_fpos_t;}' unless defined(&_IO_fpos_t);
    eval 'sub _IO_size_t () { &_G_size_t;}' unless defined(&_IO_size_t);
    eval 'sub _IO_ssize_t () { &_G_ssize_t;}' unless defined(&_IO_ssize_t);
    eval 'sub _IO_off_t () { &_G_off_t;}' unless defined(&_IO_off_t);
    eval 'sub _IO_pid_t () { &_G_pid_t;}' unless defined(&_IO_pid_t);
    eval 'sub _IO_uid_t () { &_G_uid_t;}' unless defined(&_IO_uid_t);
    eval 'sub _IO_HAVE_SYS_WAIT () { &_G_HAVE_SYS_WAIT;}' unless defined(&_IO_HAVE_SYS_WAIT);
    eval 'sub _IO_HAVE_ST_BLKSIZE () { &_G_HAVE_ST_BLKSIZE;}' unless defined(&_IO_HAVE_ST_BLKSIZE);
    eval 'sub _IO_BUFSIZ () { &_G_BUFSIZ;}' unless defined(&_IO_BUFSIZ);
    eval 'sub _IO_va_list () { &_G_va_list;}' unless defined(&_IO_va_list);
    if(defined(&_G_NEED_STDARG_H)) {
	eval 'sub __need___va_list () {1;}' unless defined(&__need___va_list);
	require 'stdarg.ph';
	if(defined(&__GNUC_VA_LIST)) {
	    undef(&_IO_va_list) if defined(&_IO_va_list);
	    eval 'sub _IO_va_list () { &__gnuc_va_list;}' unless defined(&_IO_va_list);
	}
    }
    unless(defined(&__P)) {
	if((defined(&_G_HAVE_SYS_CDEFS) ? &_G_HAVE_SYS_CDEFS : 0)) {
	    require 'sys/cdefs.ph';
	} else {
	    if(defined(&__STDC__)) {
		eval 'sub __P {
		    local($protos) = @_;
    		    eval q($protos);
		}' unless defined(&__P);
	    } else {
		eval 'sub __P {
		    local($protos) = @_;
    		    eval q(());
		}' unless defined(&__P);
	    }
	}
    }
    unless(defined(&_PARAMS)) {
	eval 'sub _PARAMS {
	    local($protos) = @_;
    	    eval q( &__P($protos));
	}' unless defined(&_PARAMS);
    }
    unless(defined(&__STDC__)) {
	eval 'sub const () {1;}' unless defined(&const);
    }
    eval 'sub _IO_USE_DTOA () {1;}' unless defined(&_IO_USE_DTOA);
    eval 'sub _IO_UNIFIED_JUMPTABLES () {1;}' unless defined(&_IO_UNIFIED_JUMPTABLES);
    if(0) {
	if(defined(&_IO_NEED_STDARG_H)) {
	    require 'stdarg.ph';
	}
    }
    unless(defined(&EOF)) {
	eval 'sub EOF () {(-1);}' unless defined(&EOF);
    }
    unless(defined(&NULL)) {
	if(!defined( &__cplusplus) || defined( &__GNUC__)) {
	    eval 'sub NULL () {(0);}' unless defined(&NULL);
	} else {
	    eval 'sub NULL () {(0);}' unless defined(&NULL);
	}
    }
    eval 'sub _IOS_INPUT () {1;}' unless defined(&_IOS_INPUT);
    eval 'sub _IOS_OUTPUT () {2;}' unless defined(&_IOS_OUTPUT);
    eval 'sub _IOS_ATEND () {4;}' unless defined(&_IOS_ATEND);
    eval 'sub _IOS_APPEND () {8;}' unless defined(&_IOS_APPEND);
    eval 'sub _IOS_TRUNC () {16;}' unless defined(&_IOS_TRUNC);
    eval 'sub _IOS_NOCREATE () {32;}' unless defined(&_IOS_NOCREATE);
    eval 'sub _IOS_NOREPLACE () {64;}' unless defined(&_IOS_NOREPLACE);
    eval 'sub _IOS_BIN () {128;}' unless defined(&_IOS_BIN);
    eval 'sub _IO_MAGIC () {0xfbad0000;}' unless defined(&_IO_MAGIC);
    eval 'sub _OLD_STDIO_MAGIC () {0xfabc0000;}' unless defined(&_OLD_STDIO_MAGIC);
    eval 'sub _IO_MAGIC_MASK () {0xffff0000;}' unless defined(&_IO_MAGIC_MASK);
    eval 'sub _IO_USER_BUF () {1;}' unless defined(&_IO_USER_BUF);
    eval 'sub _IO_UNBUFFERED () {2;}' unless defined(&_IO_UNBUFFERED);
    eval 'sub _IO_NO_READS () {4;}' unless defined(&_IO_NO_READS);
    eval 'sub _IO_NO_WRITES () {8;}' unless defined(&_IO_NO_WRITES);
    eval 'sub _IO_EOF_SEEN () {0x10;}' unless defined(&_IO_EOF_SEEN);
    eval 'sub _IO_ERR_SEEN () {0x20;}' unless defined(&_IO_ERR_SEEN);
    eval 'sub _IO_DELETE_DONT_CLOSE () {0x40;}' unless defined(&_IO_DELETE_DONT_CLOSE);
    eval 'sub _IO_LINKED () {0x80;}' unless defined(&_IO_LINKED);
    eval 'sub _IO_IN_BACKUP () {0x100;}' unless defined(&_IO_IN_BACKUP);
    eval 'sub _IO_LINE_BUF () {0x200;}' unless defined(&_IO_LINE_BUF);
    eval 'sub _IO_TIED_PUT_GET () {0x400;}' unless defined(&_IO_TIED_PUT_GET);
    eval 'sub _IO_CURRENTLY_PUTTING () {0x800;}' unless defined(&_IO_CURRENTLY_PUTTING);
    eval 'sub _IO_IS_APPENDING () {0x1000;}' unless defined(&_IO_IS_APPENDING);
    eval 'sub _IO_IS_FILEBUF () {0x2000;}' unless defined(&_IO_IS_FILEBUF);
    eval 'sub _IO_SKIPWS () {01;}' unless defined(&_IO_SKIPWS);
    eval 'sub _IO_LEFT () {02;}' unless defined(&_IO_LEFT);
    eval 'sub _IO_RIGHT () {04;}' unless defined(&_IO_RIGHT);
    eval 'sub _IO_INTERNAL () {010;}' unless defined(&_IO_INTERNAL);
    eval 'sub _IO_DEC () {020;}' unless defined(&_IO_DEC);
    eval 'sub _IO_OCT () {040;}' unless defined(&_IO_OCT);
    eval 'sub _IO_HEX () {0100;}' unless defined(&_IO_HEX);
    eval 'sub _IO_SHOWBASE () {0200;}' unless defined(&_IO_SHOWBASE);
    eval 'sub _IO_SHOWPOINT () {0400;}' unless defined(&_IO_SHOWPOINT);
    eval 'sub _IO_UPPERCASE () {01000;}' unless defined(&_IO_UPPERCASE);
    eval 'sub _IO_SHOWPOS () {02000;}' unless defined(&_IO_SHOWPOS);
    eval 'sub _IO_SCIENTIFIC () {04000;}' unless defined(&_IO_SCIENTIFIC);
    eval 'sub _IO_FIXED () {010000;}' unless defined(&_IO_FIXED);
    eval 'sub _IO_UNITBUF () {020000;}' unless defined(&_IO_UNITBUF);
    eval 'sub _IO_STDIO () {040000;}' unless defined(&_IO_STDIO);
    eval 'sub _IO_DONT_CLOSE () {0100000;}' unless defined(&_IO_DONT_CLOSE);
    if(0) {
    }
    eval 'sub _IO_file_flags () { &_flags;}' unless defined(&_IO_file_flags);
    eval 'sub __HAVE_COLUMN () {1;}' unless defined(&__HAVE_COLUMN);
    unless(defined(&__cplusplus)) {
    }
    eval 'sub _IO_stdin () {((& &_IO_stdin_));}' unless defined(&_IO_stdin);
    eval 'sub _IO_stdout () {((& &_IO_stdout_));}' unless defined(&_IO_stdout);
    eval 'sub _IO_stderr () {((& &_IO_stderr_));}' unless defined(&_IO_stderr);
    if(defined(&__cplusplus)) {
    }
    eval 'sub _IO_getc {
        local($_fp) = @_;
	    eval q((-> &_IO_read_ptr >= -> &_IO_read_end ?  &__uflow : *($_fp)-> &_IO_read_ptr++));
    }' unless defined(&_IO_getc);
    eval 'sub _IO_peekc {
        local($_fp) = @_;
	    eval q((-> &_IO_read_ptr >= -> &_IO_read_end  &&  &__underflow ==  &EOF ?  &EOF : *($_fp)-> &_IO_read_ptr));
    }' unless defined(&_IO_peekc);
    eval 'sub _IO_putc {
        local($_ch, $_fp) = @_;
	    eval q(((-> &_IO_write_ptr >= -> &_IO_write_end) ?  &__overflow($_fp, ) : (*($_fp)-> &_IO_write_ptr++ = ($_ch))));
    }' unless defined(&_IO_putc);
    eval 'sub _IO_feof {
        local($__fp) = @_;
	    eval q(((($__fp)-> &_flags &  &_IO_EOF_SEEN) != 0));
    }' unless defined(&_IO_feof);
    eval 'sub _IO_ferror {
        local($__fp) = @_;
	    eval q(((($__fp)-> &_flags &  &_IO_ERR_SEEN) != 0));
    }' unless defined(&_IO_ferror);
    eval 'sub _IO_PENDING_OUTPUT_COUNT {
        local($_fp) = @_;
	    eval q((($_fp)-> &_IO_write_ptr - ($_fp)-> &_IO_write_base));
    }' unless defined(&_IO_PENDING_OUTPUT_COUNT);
    if(defined(&__cplusplus)) {
    }
}
1;
