require '_h2ph_pre.ph';

unless(defined(&_LIMITS_H_)) {
    eval 'sub _LIMITS_H_ () {1;}' unless defined(&_LIMITS_H_);
    require 'sys/_posix.ph';
    unless(defined(&_ANSI_SOURCE)) {
	eval 'sub _POSIX_ARG_MAX () {4096;}' unless defined(&_POSIX_ARG_MAX);
	eval 'sub _POSIX_CHILD_MAX () {6;}' unless defined(&_POSIX_CHILD_MAX);
	eval 'sub _POSIX_LINK_MAX () {8;}' unless defined(&_POSIX_LINK_MAX);
	eval 'sub _POSIX_MAX_CANON () {255;}' unless defined(&_POSIX_MAX_CANON);
	eval 'sub _POSIX_MAX_INPUT () {255;}' unless defined(&_POSIX_MAX_INPUT);
	eval 'sub _POSIX_NAME_MAX () {14;}' unless defined(&_POSIX_NAME_MAX);
	eval 'sub _POSIX_NGROUPS_MAX () {0;}' unless defined(&_POSIX_NGROUPS_MAX);
	eval 'sub _POSIX_OPEN_MAX () {16;}' unless defined(&_POSIX_OPEN_MAX);
	eval 'sub _POSIX_PATH_MAX () {255;}' unless defined(&_POSIX_PATH_MAX);
	eval 'sub _POSIX_PIPE_BUF () {512;}' unless defined(&_POSIX_PIPE_BUF);
	eval 'sub _POSIX_SSIZE_MAX () {32767;}' unless defined(&_POSIX_SSIZE_MAX);
	eval 'sub _POSIX_STREAM_MAX () {8;}' unless defined(&_POSIX_STREAM_MAX);
	eval 'sub _POSIX_TZNAME_MAX () {3;}' unless defined(&_POSIX_TZNAME_MAX);
	eval 'sub _POSIX2_BC_BASE_MAX () {99;}' unless defined(&_POSIX2_BC_BASE_MAX);
	eval 'sub _POSIX2_BC_DIM_MAX () {2048;}' unless defined(&_POSIX2_BC_DIM_MAX);
	eval 'sub _POSIX2_BC_SCALE_MAX () {99;}' unless defined(&_POSIX2_BC_SCALE_MAX);
	eval 'sub _POSIX2_BC_STRING_MAX () {1000;}' unless defined(&_POSIX2_BC_STRING_MAX);
	eval 'sub _POSIX2_EQUIV_CLASS_MAX () {2;}' unless defined(&_POSIX2_EQUIV_CLASS_MAX);
	eval 'sub _POSIX2_EXPR_NEST_MAX () {32;}' unless defined(&_POSIX2_EXPR_NEST_MAX);
	eval 'sub _POSIX2_LINE_MAX () {2048;}' unless defined(&_POSIX2_LINE_MAX);
	eval 'sub _POSIX2_RE_DUP_MAX () {255;}' unless defined(&_POSIX2_RE_DUP_MAX);
	if(defined(&_P1003_1B_VISIBLE)) {
	    eval 'sub _POSIX_AIO_LISTIO_MAX () {16;}' unless defined(&_POSIX_AIO_LISTIO_MAX);
	    eval 'sub _POSIX_AIO_MAX () {1;}' unless defined(&_POSIX_AIO_MAX);
	    eval 'sub _POSIX_DELAYTIMER_MAX () {32;}' unless defined(&_POSIX_DELAYTIMER_MAX);
	    eval 'sub _POSIX_MQ_OPEN_MAX () {8;}' unless defined(&_POSIX_MQ_OPEN_MAX);
	    eval 'sub _POSIX_MQ_PRIO_MAX () {32;}' unless defined(&_POSIX_MQ_PRIO_MAX);
	    eval 'sub _POSIX_RTSIG_MAX () {0;}' unless defined(&_POSIX_RTSIG_MAX);
	    eval 'sub _POSIX_SEM_NSEMS_MAX () {256;}' unless defined(&_POSIX_SEM_NSEMS_MAX);
	    eval 'sub _POSIX_SEM_VALUE_MAX () {32767;}' unless defined(&_POSIX_SEM_VALUE_MAX);
	    eval 'sub _POSIX_SIGQUEUE_MAX () {32;}' unless defined(&_POSIX_SIGQUEUE_MAX);
	    eval 'sub _POSIX_TIMER_MAX () {32;}' unless defined(&_POSIX_TIMER_MAX);
	}
    }
    if(!defined( &_ANSI_SOURCE)  && !defined( &_POSIX_SOURCE) || defined( &_XOPEN_SOURCE)) {
	eval 'sub PASS_MAX () {128;}' unless defined(&PASS_MAX);
	eval 'sub NL_ARGMAX () {99;}' unless defined(&NL_ARGMAX);
	eval 'sub NL_LANGMAX () {31;}' unless defined(&NL_LANGMAX);
	eval 'sub NL_MSGMAX () {32767;}' unless defined(&NL_MSGMAX);
	eval 'sub NL_NMAX () {1;}' unless defined(&NL_NMAX);
	eval 'sub NL_SETMAX () {255;}' unless defined(&NL_SETMAX);
	eval 'sub NL_TEXTMAX () {2048;}' unless defined(&NL_TEXTMAX);
    }
    require 'machine/limits.ph';
    if(!defined( &_ANSI_SOURCE)) {
	require 'sys/syslimits.ph';
    }
}
1;
