require '_h2ph_pre.ph';

unless(defined(&_MACHINE_APM_BIOS_H_)) {
    eval 'sub _MACHINE_APM_BIOS_H_ () {1;}' unless defined(&_MACHINE_APM_BIOS_H_);
    unless(defined(&KERNEL)) {
	require 'sys/types.ph';
    }
    require 'sys/ioccom.ph';
    if(defined(&PC98)) {
	eval 'sub APM_BIOS () {0x9a;}' unless defined(&APM_BIOS);
	eval 'sub SYSTEM_BIOS () {0x1f;}' unless defined(&SYSTEM_BIOS);
    } else {
	eval 'sub APM_BIOS () {0x53;}' unless defined(&APM_BIOS);
	eval 'sub SYSTEM_BIOS () {0x15;}' unless defined(&SYSTEM_BIOS);
    }
    eval 'sub APM_16BIT_SUPPORT () {0x01;}' unless defined(&APM_16BIT_SUPPORT);
    eval 'sub APM_32BIT_SUPPORT () {0x02;}' unless defined(&APM_32BIT_SUPPORT);
    eval 'sub APM_CPUIDLE_SLOW () {0x04;}' unless defined(&APM_CPUIDLE_SLOW);
    eval 'sub APM_DISABLED () {0x08;}' unless defined(&APM_DISABLED);
    eval 'sub APM_DISENGAGED () {0x10;}' unless defined(&APM_DISENGAGED);
    eval 'sub APM_OURADDR () {0x00080000;}' unless defined(&APM_OURADDR);
    eval 'sub APMINI_CANTFIND () {0xffffffff;}' unless defined(&APMINI_CANTFIND);
    eval 'sub APMINI_NOT32BIT () {0xfffffffe;}' unless defined(&APMINI_NOT32BIT);
    eval 'sub APMINI_CONNECTERR () {0xfffffffd;}' unless defined(&APMINI_CONNECTERR);
    eval 'sub APM_INSTCHECK () {0x00;}' unless defined(&APM_INSTCHECK);
    eval 'sub APM_REALCONNECT () {0x01;}' unless defined(&APM_REALCONNECT);
    eval 'sub APM_PROT16CONNECT () {0x02;}' unless defined(&APM_PROT16CONNECT);
    eval 'sub APM_PROT32CONNECT () {0x03;}' unless defined(&APM_PROT32CONNECT);
    eval 'sub APM_DISCONNECT () {0x04;}' unless defined(&APM_DISCONNECT);
    eval 'sub APM_CPUIDLE () {0x05;}' unless defined(&APM_CPUIDLE);
    eval 'sub APM_CPUBUSY () {0x06;}' unless defined(&APM_CPUBUSY);
    eval 'sub APM_SETPWSTATE () {0x07;}' unless defined(&APM_SETPWSTATE);
    eval 'sub APM_ENABLEDISABLEPM () {0x08;}' unless defined(&APM_ENABLEDISABLEPM);
    eval 'sub APM_RESTOREDEFAULT () {0x09;}' unless defined(&APM_RESTOREDEFAULT);
    if(defined(&PC98)) {
	eval 'sub APM_GETPWSTATUS () {0x3a;}' unless defined(&APM_GETPWSTATUS);
    } else {
	eval 'sub APM_GETPWSTATUS () {0x0a;}' unless defined(&APM_GETPWSTATUS);
    }
    eval 'sub APM_GETPMEVENT () {0x0b;}' unless defined(&APM_GETPMEVENT);
    eval 'sub APM_GETPWSTATE () {0x0c;}' unless defined(&APM_GETPWSTATE);
    eval 'sub APM_ENABLEDISABLEDPM () {0x0d;}' unless defined(&APM_ENABLEDISABLEDPM);
    if(defined(&PC98)) {
	eval 'sub APM_DRVVERSION () {0x3e;}' unless defined(&APM_DRVVERSION);
    } else {
	eval 'sub APM_DRVVERSION () {0x0e;}' unless defined(&APM_DRVVERSION);
    }
    eval 'sub APM_ENGAGEDISENGAGEPM () {0x0f;}' unless defined(&APM_ENGAGEDISENGAGEPM);
    eval 'sub APM_GETCAPABILITIES () {0x10;}' unless defined(&APM_GETCAPABILITIES);
    eval 'sub APM_RESUMETIMER () {0x11;}' unless defined(&APM_RESUMETIMER);
    eval 'sub APM_RESUMEONRING () {0x12;}' unless defined(&APM_RESUMEONRING);
    eval 'sub APM_TIMERREQUESTS () {0x13;}' unless defined(&APM_TIMERREQUESTS);
    eval 'sub APM_OEMFUNC () {0x80;}' unless defined(&APM_OEMFUNC);
    eval 'sub APME_OK () {0x00;}' unless defined(&APME_OK);
    eval 'sub APME_PMDISABLED () {0x01;}' unless defined(&APME_PMDISABLED);
    eval 'sub APME_REALESTABLISHED () {0x02;}' unless defined(&APME_REALESTABLISHED);
    eval 'sub APME_NOTCONNECTED () {0x03;}' unless defined(&APME_NOTCONNECTED);
    eval 'sub APME_PROT16ESTABLISHED () {0x05;}' unless defined(&APME_PROT16ESTABLISHED);
    eval 'sub APME_PROT16NOTSUPPORTED () {0x06;}' unless defined(&APME_PROT16NOTSUPPORTED);
    eval 'sub APME_PROT32ESTABLISHED () {0x07;}' unless defined(&APME_PROT32ESTABLISHED);
    eval 'sub APME_PROT32NOTDUPPORTED () {0x08;}' unless defined(&APME_PROT32NOTDUPPORTED);
    eval 'sub APME_UNKNOWNDEVICEID () {0x09;}' unless defined(&APME_UNKNOWNDEVICEID);
    eval 'sub APME_OUTOFRANGE () {0x0a;}' unless defined(&APME_OUTOFRANGE);
    eval 'sub APME_NOTENGAGED () {0x0b;}' unless defined(&APME_NOTENGAGED);
    eval 'sub APME_CANTENTERSTATE () {0x60;}' unless defined(&APME_CANTENTERSTATE);
    eval 'sub APME_NOPMEVENT () {0x80;}' unless defined(&APME_NOPMEVENT);
    eval 'sub APME_NOAPMPRESENT () {0x86;}' unless defined(&APME_NOAPMPRESENT);
    eval 'sub PMDV_APMBIOS () {0x0000;}' unless defined(&PMDV_APMBIOS);
    eval 'sub PMDV_ALLDEV () {0x0001;}' unless defined(&PMDV_ALLDEV);
    eval 'sub PMDV_DISP0 () {0x0100;}' unless defined(&PMDV_DISP0);
    eval 'sub PMDV_DISP1 () {0x0101;}' unless defined(&PMDV_DISP1);
    eval 'sub PMDV_2NDSTORAGE0 () {0x0200;}' unless defined(&PMDV_2NDSTORAGE0);
    eval 'sub PMDV_2NDSTORAGE1 () {0x0201;}' unless defined(&PMDV_2NDSTORAGE1);
    eval 'sub PMDV_2NDSTORAGE2 () {0x0202;}' unless defined(&PMDV_2NDSTORAGE2);
    eval 'sub PMDV_2NDSTORAGE3 () {0x0203;}' unless defined(&PMDV_2NDSTORAGE3);
    eval 'sub PMDV_PARALLEL0 () {0x0300;}' unless defined(&PMDV_PARALLEL0);
    eval 'sub PMDV_PARALLEL1 () {0x0301;}' unless defined(&PMDV_PARALLEL1);
    eval 'sub PMDV_SERIAL0 () {0x0400;}' unless defined(&PMDV_SERIAL0);
    eval 'sub PMDV_SERIAL1 () {0x0401;}' unless defined(&PMDV_SERIAL1);
    eval 'sub PMDV_SERIAL2 () {0x0402;}' unless defined(&PMDV_SERIAL2);
    eval 'sub PMDV_SERIAL3 () {0x0403;}' unless defined(&PMDV_SERIAL3);
    eval 'sub PMDV_SERIAL4 () {0x0404;}' unless defined(&PMDV_SERIAL4);
    eval 'sub PMDV_SERIAL5 () {0x0405;}' unless defined(&PMDV_SERIAL5);
    eval 'sub PMDV_SERIAL6 () {0x0406;}' unless defined(&PMDV_SERIAL6);
    eval 'sub PMDV_SERIAL7 () {0x0407;}' unless defined(&PMDV_SERIAL7);
    eval 'sub PMDV_NET0 () {0x0500;}' unless defined(&PMDV_NET0);
    eval 'sub PMDV_NET1 () {0x0501;}' unless defined(&PMDV_NET1);
    eval 'sub PMDV_NET2 () {0x0502;}' unless defined(&PMDV_NET2);
    eval 'sub PMDV_NET3 () {0x0503;}' unless defined(&PMDV_NET3);
    eval 'sub PMDV_PCMCIA0 () {0x0600;}' unless defined(&PMDV_PCMCIA0);
    eval 'sub PMDV_PCMCIA1 () {0x0601;}' unless defined(&PMDV_PCMCIA1);
    eval 'sub PMDV_PCMCIA2 () {0x0602;}' unless defined(&PMDV_PCMCIA2);
    eval 'sub PMDV_PCMCIA3 () {0x0603;}' unless defined(&PMDV_PCMCIA3);
    eval 'sub PMST_APMENABLED () {0x0000;}' unless defined(&PMST_APMENABLED);
    eval 'sub PMST_STANDBY () {0x0001;}' unless defined(&PMST_STANDBY);
    eval 'sub PMST_SUSPEND () {0x0002;}' unless defined(&PMST_SUSPEND);
    eval 'sub PMST_OFF () {0x0003;}' unless defined(&PMST_OFF);
    eval 'sub PMST_LASTREQNOTIFY () {0x0004;}' unless defined(&PMST_LASTREQNOTIFY);
    eval 'sub PMST_LASTREQREJECT () {0x0005;}' unless defined(&PMST_LASTREQREJECT);
    if(!defined( &ASSEMBLER)  && !defined( &INITIALIZER)) {
	eval 'sub APM_HOOK_NONE () {(-1);}' unless defined(&APM_HOOK_NONE);
	eval 'sub APM_HOOK_SUSPEND () {0;}' unless defined(&APM_HOOK_SUSPEND);
	eval 'sub APM_HOOK_RESUME () {1;}' unless defined(&APM_HOOK_RESUME);
	eval 'sub NAPM_HOOK () {2;}' unless defined(&NAPM_HOOK);
	if(defined(&KERNEL)) {
	}
    }
    eval 'sub APM_MIN_ORDER () {0x00;}' unless defined(&APM_MIN_ORDER);
    eval 'sub APM_MID_ORDER () {0x80;}' unless defined(&APM_MID_ORDER);
    eval 'sub APM_MAX_ORDER () {0xff;}' unless defined(&APM_MAX_ORDER);
    eval 'sub PMEV_NOEVENT () {0x0000;}' unless defined(&PMEV_NOEVENT);
    eval 'sub PMEV_STANDBYREQ () {0x0001;}' unless defined(&PMEV_STANDBYREQ);
    eval 'sub PMEV_SUSPENDREQ () {0x0002;}' unless defined(&PMEV_SUSPENDREQ);
    eval 'sub PMEV_NORMRESUME () {0x0003;}' unless defined(&PMEV_NORMRESUME);
    eval 'sub PMEV_CRITRESUME () {0x0004;}' unless defined(&PMEV_CRITRESUME);
    eval 'sub PMEV_BATTERYLOW () {0x0005;}' unless defined(&PMEV_BATTERYLOW);
    eval 'sub PMEV_POWERSTATECHANGE () {0x0006;}' unless defined(&PMEV_POWERSTATECHANGE);
    eval 'sub PMEV_UPDATETIME () {0x0007;}' unless defined(&PMEV_UPDATETIME);
    eval 'sub PMEV_CRITSUSPEND () {0x0008;}' unless defined(&PMEV_CRITSUSPEND);
    eval 'sub PMEV_USERSTANDBYREQ () {0x0009;}' unless defined(&PMEV_USERSTANDBYREQ);
    eval 'sub PMEV_USERSUSPENDREQ () {0x000a;}' unless defined(&PMEV_USERSUSPENDREQ);
    eval 'sub PMEV_STANDBYRESUME () {0x000b;}' unless defined(&PMEV_STANDBYRESUME);
    eval 'sub PMEV_CAPABILITIESCHANGE () {0x000c;}' unless defined(&PMEV_CAPABILITIESCHANGE);
    eval 'sub PMEV_DEFAULT () {0xffffffff;}' unless defined(&PMEV_DEFAULT);
    if(!defined( &ASSEMBLER)  && !defined( &INITIALIZER)) {
	eval 'sub APMIO_SUSPEND () { &_IO(ord(\'P\'), 1);}' unless defined(&APMIO_SUSPEND);
	eval 'sub APMIO_GETINFO_OLD () { &_IOR(ord(\'P\'), 2, \'struct apm_info_old\');}' unless defined(&APMIO_GETINFO_OLD);
	eval 'sub APMIO_ENABLE () { &_IO(ord(\'P\'), 5);}' unless defined(&APMIO_ENABLE);
	eval 'sub APMIO_DISABLE () { &_IO(ord(\'P\'), 6);}' unless defined(&APMIO_DISABLE);
	eval 'sub APMIO_HALTCPU () { &_IO(ord(\'P\'), 7);}' unless defined(&APMIO_HALTCPU);
	eval 'sub APMIO_NOTHALTCPU () { &_IO(ord(\'P\'), 8);}' unless defined(&APMIO_NOTHALTCPU);
	eval 'sub APMIO_DISPLAY () { &_IOW(ord(\'P\'), 9, \'int\');}' unless defined(&APMIO_DISPLAY);
	eval 'sub APMIO_BIOS () { &_IOWR(ord(\'P\'), 10, \'struct apm_bios_arg\');}' unless defined(&APMIO_BIOS);
	eval 'sub APMIO_GETINFO () { &_IOR(ord(\'P\'), 11, \'struct apm_info\');}' unless defined(&APMIO_GETINFO);
	eval 'sub APMIO_STANDBY () { &_IO(ord(\'P\'), 12);}' unless defined(&APMIO_STANDBY);
	eval 'sub APMIO_NEXTEVENT () { &_IOR(ord(\'A\'), 100, \'struct apm_event_info\');}' unless defined(&APMIO_NEXTEVENT);
	eval 'sub APMIO_REJECTLASTREQ () { &_IO(ord(\'P\'), 101);}' unless defined(&APMIO_REJECTLASTREQ);
    }
}
1;
