require '_h2ph_pre.ph';

unless(defined(&_I4B_CAUSE_H_)) {
    eval 'sub _I4B_CAUSE_H_ () {1;}' unless defined(&_I4B_CAUSE_H_);
    eval 'sub CAUSE_VAL () {0x000000ff;}' unless defined(&CAUSE_VAL);
    eval 'sub CAUSE_TYPE () {0x0000ff00;}' unless defined(&CAUSE_TYPE);
    eval 'sub CAUSET_Q850 () {0;}' unless defined(&CAUSET_Q850);
    eval 'sub CAUSET_I4B () {1;}' unless defined(&CAUSET_I4B);
    eval 'sub GET_CAUSE_VAL {
        local($cause) = @_;
	    eval q((($cause) & 0xff));
    }' unless defined(&GET_CAUSE_VAL);
    eval 'sub SET_CAUSE_VAL {
        local($dest, $val) = @_;
	    eval q((($dest) = (($dest & 0xffffff00) | ($val & 0x000000ff))));
    }' unless defined(&SET_CAUSE_VAL);
    eval 'sub GET_CAUSE_TYPE {
        local($cause) = @_;
	    eval q(((($cause) >> 8) & 0xff));
    }' unless defined(&GET_CAUSE_TYPE);
    eval 'sub SET_CAUSE_TYPE {
        local($dest, $type) = @_;
	    eval q((($dest) = (($dest & 0xffff00ff) | (($type << 8) & 0x0000ff00))));
    }' unless defined(&SET_CAUSE_TYPE);
    eval 'sub SET_CAUSE_TV {
        local($dest, $type, $val) = @_;
	    eval q((($dest) = (($val & 0x000000ff) | (($type << 8) & 0x0000ff00))));
    }' unless defined(&SET_CAUSE_TV);
    eval 'sub CAUSE_I4B_NORMAL () {0;}' unless defined(&CAUSE_I4B_NORMAL);
    eval 'sub CAUSE_I4B_BUSY () {1;}' unless defined(&CAUSE_I4B_BUSY);
    eval 'sub CAUSE_I4B_NOCHAN () {2;}' unless defined(&CAUSE_I4B_NOCHAN);
    eval 'sub CAUSE_I4B_INCOMP () {3;}' unless defined(&CAUSE_I4B_INCOMP);
    eval 'sub CAUSE_I4B_REJECT () {4;}' unless defined(&CAUSE_I4B_REJECT);
    eval 'sub CAUSE_I4B_OOO () {5;}' unless defined(&CAUSE_I4B_OOO);
    eval 'sub CAUSE_I4B_TMPFAIL () {6;}' unless defined(&CAUSE_I4B_TMPFAIL);
    eval 'sub CAUSE_I4B_L1ERROR () {7;}' unless defined(&CAUSE_I4B_L1ERROR);
    eval 'sub CAUSE_I4B_MAX () {8;}' unless defined(&CAUSE_I4B_MAX);
    eval 'sub CAUSE_Q850_SHUTDN () {0x00;}' unless defined(&CAUSE_Q850_SHUTDN);
    eval 'sub CAUSE_Q850_NUNALLC () {0x01;}' unless defined(&CAUSE_Q850_NUNALLC);
    eval 'sub CAUSE_Q850_NRTTN () {0x02;}' unless defined(&CAUSE_Q850_NRTTN);
    eval 'sub CAUSE_Q850_NRTDST () {0x03;}' unless defined(&CAUSE_Q850_NRTDST);
    eval 'sub CAUSE_Q850_SSINFTN () {0x04;}' unless defined(&CAUSE_Q850_SSINFTN);
    eval 'sub CAUSE_Q850_MDIALTP () {0x05;}' unless defined(&CAUSE_Q850_MDIALTP);
    eval 'sub CAUSE_Q850_CHUNACC () {0x06;}' unless defined(&CAUSE_Q850_CHUNACC);
    eval 'sub CAUSE_Q850_CALLAWD () {0x07;}' unless defined(&CAUSE_Q850_CALLAWD);
    eval 'sub CAUSE_Q850_PREEMPT () {0x08;}' unless defined(&CAUSE_Q850_PREEMPT);
    eval 'sub CAUSE_Q850_PREECRR () {0x09;}' unless defined(&CAUSE_Q850_PREECRR);
    eval 'sub CAUSE_Q850_NCCLR () {0x10;}' unless defined(&CAUSE_Q850_NCCLR);
    eval 'sub CAUSE_Q850_USRBSY () {0x11;}' unless defined(&CAUSE_Q850_USRBSY);
    eval 'sub CAUSE_Q850_NOUSRRSP () {0x12;}' unless defined(&CAUSE_Q850_NOUSRRSP);
    eval 'sub CAUSE_Q850_NOANSWR () {0x13;}' unless defined(&CAUSE_Q850_NOANSWR);
    eval 'sub CAUSE_Q850_SUBSABS () {0x14;}' unless defined(&CAUSE_Q850_SUBSABS);
    eval 'sub CAUSE_Q850_CALLREJ () {0x15;}' unless defined(&CAUSE_Q850_CALLREJ);
    eval 'sub CAUSE_Q850_NUCHNG () {0x16;}' unless defined(&CAUSE_Q850_NUCHNG);
    eval 'sub CAUSE_Q850_NONSELUC () {0x1a;}' unless defined(&CAUSE_Q850_NONSELUC);
    eval 'sub CAUSE_Q850_DSTOOORDR () {0x1b;}' unless defined(&CAUSE_Q850_DSTOOORDR);
    eval 'sub CAUSE_Q850_INVNUFMT () {0x1c;}' unless defined(&CAUSE_Q850_INVNUFMT);
    eval 'sub CAUSE_Q850_FACREJ () {0x1d;}' unless defined(&CAUSE_Q850_FACREJ);
    eval 'sub CAUSE_Q850_STENQRSP () {0x1e;}' unless defined(&CAUSE_Q850_STENQRSP);
    eval 'sub CAUSE_Q850_NORMUNSP () {0x1f;}' unless defined(&CAUSE_Q850_NORMUNSP);
    eval 'sub CAUSE_Q850_NOCAVAIL () {0x22;}' unless defined(&CAUSE_Q850_NOCAVAIL);
    eval 'sub CAUSE_Q850_NETOOORDR () {0x26;}' unless defined(&CAUSE_Q850_NETOOORDR);
    eval 'sub CAUSE_Q850_PFMCDOOSERV () {0x27;}' unless defined(&CAUSE_Q850_PFMCDOOSERV);
    eval 'sub CAUSE_Q850_PFMCOPER () {0x28;}' unless defined(&CAUSE_Q850_PFMCOPER);
    eval 'sub CAUSE_Q850_TMPFAIL () {0x29;}' unless defined(&CAUSE_Q850_TMPFAIL);
    eval 'sub CAUSE_Q850_SWEQCONG () {0x2a;}' unless defined(&CAUSE_Q850_SWEQCONG);
    eval 'sub CAUSE_Q850_ACCINFDIS () {0x2b;}' unless defined(&CAUSE_Q850_ACCINFDIS);
    eval 'sub CAUSE_Q850_REQCNOTAV () {0x2c;}' unless defined(&CAUSE_Q850_REQCNOTAV);
    eval 'sub CAUSE_Q850_PRECALBLK () {0x2e;}' unless defined(&CAUSE_Q850_PRECALBLK);
    eval 'sub CAUSE_Q850_RESUNAVAIL () {0x2f;}' unless defined(&CAUSE_Q850_RESUNAVAIL);
    eval 'sub CAUSE_Q850_QOSUNAVAIL () {0x31;}' unless defined(&CAUSE_Q850_QOSUNAVAIL);
    eval 'sub CAUSE_Q850_REQSERVNS () {0x32;}' unless defined(&CAUSE_Q850_REQSERVNS);
    eval 'sub CAUSE_Q850_OCBARRCUG () {0x35;}' unless defined(&CAUSE_Q850_OCBARRCUG);
    eval 'sub CAUSE_Q850_ICBARRCUG () {0x36;}' unless defined(&CAUSE_Q850_ICBARRCUG);
    eval 'sub CAUSE_Q850_BCAPNAUTH () {0x39;}' unless defined(&CAUSE_Q850_BCAPNAUTH);
    eval 'sub CAUSE_Q850_BCAPNAVAIL () {0x3a;}' unless defined(&CAUSE_Q850_BCAPNAVAIL);
    eval 'sub CAUSE_Q850_INCSTOACISC () {0x3e;}' unless defined(&CAUSE_Q850_INCSTOACISC);
    eval 'sub CAUSE_Q850_SOONOTAVAIL () {0x3f;}' unless defined(&CAUSE_Q850_SOONOTAVAIL);
    eval 'sub CAUSE_Q850_BCAPNOTIMPL () {0x41;}' unless defined(&CAUSE_Q850_BCAPNOTIMPL);
    eval 'sub CAUSE_Q850_CHTYPNIMPL () {0x42;}' unless defined(&CAUSE_Q850_CHTYPNIMPL);
    eval 'sub CAUSE_Q850_REQFACNIMPL () {0x45;}' unless defined(&CAUSE_Q850_REQFACNIMPL);
    eval 'sub CAUSE_Q850_ORDINBCAVL () {0x46;}' unless defined(&CAUSE_Q850_ORDINBCAVL);
    eval 'sub CAUSE_Q850_SOONOTIMPL () {0x4f;}' unless defined(&CAUSE_Q850_SOONOTIMPL);
    eval 'sub CAUSE_Q850_INVCLRFVAL () {0x51;}' unless defined(&CAUSE_Q850_INVCLRFVAL);
    eval 'sub CAUSE_Q850_IDCHDNOEX () {0x52;}' unless defined(&CAUSE_Q850_IDCHDNOEX);
    eval 'sub CAUSE_Q850_SUSCAEXIN () {0x53;}' unless defined(&CAUSE_Q850_SUSCAEXIN);
    eval 'sub CAUSE_Q850_CLIDINUSE () {0x54;}' unless defined(&CAUSE_Q850_CLIDINUSE);
    eval 'sub CAUSE_Q850_NOCLSUSP () {0x55;}' unless defined(&CAUSE_Q850_NOCLSUSP);
    eval 'sub CAUSE_Q850_CLIDCLRD () {0x56;}' unless defined(&CAUSE_Q850_CLIDCLRD);
    eval 'sub CAUSE_Q850_UNOTMEMCUG () {0x57;}' unless defined(&CAUSE_Q850_UNOTMEMCUG);
    eval 'sub CAUSE_Q850_INCDEST () {0x58;}' unless defined(&CAUSE_Q850_INCDEST);
    eval 'sub CAUSE_Q850_NONEXCUG () {0x5a;}' unless defined(&CAUSE_Q850_NONEXCUG);
    eval 'sub CAUSE_Q850_INVNTWSEL () {0x5b;}' unless defined(&CAUSE_Q850_INVNTWSEL);
    eval 'sub CAUSE_Q850_INVMSG () {0x5f;}' unless defined(&CAUSE_Q850_INVMSG);
    eval 'sub CAUSE_Q850_MIEMISS () {0x60;}' unless defined(&CAUSE_Q850_MIEMISS);
    eval 'sub CAUSE_Q850_MSGTNI () {0x61;}' unless defined(&CAUSE_Q850_MSGTNI);
    eval 'sub CAUSE_Q850_MSGNCMPT () {0x62;}' unless defined(&CAUSE_Q850_MSGNCMPT);
    eval 'sub CAUSE_Q850_IENENI () {0x63;}' unless defined(&CAUSE_Q850_IENENI);
    eval 'sub CAUSE_Q850_INVIEC () {0x64;}' unless defined(&CAUSE_Q850_INVIEC);
    eval 'sub CAUSE_Q850_MSGNCWCS () {0x65;}' unless defined(&CAUSE_Q850_MSGNCWCS);
    eval 'sub CAUSE_Q850_RECOTIMEXP () {0x66;}' unless defined(&CAUSE_Q850_RECOTIMEXP);
    eval 'sub CAUSE_Q850_PARMNENIPO () {0x67;}' unless defined(&CAUSE_Q850_PARMNENIPO);
    eval 'sub CAUSE_Q850_MSGUNRDPRM () {0x6e;}' unless defined(&CAUSE_Q850_MSGUNRDPRM);
    eval 'sub CAUSE_Q850_PROTERR () {0x6f;}' unless defined(&CAUSE_Q850_PROTERR);
    eval 'sub CAUSE_Q850_INTWRKU () {0x7f;}' unless defined(&CAUSE_Q850_INTWRKU);
    eval 'sub CAUSE_Q850_MAX () {128;}' unless defined(&CAUSE_Q850_MAX);
}
1;
