require '_h2ph_pre.ph';

unless(defined(&_I4B_IOCTL_H_)) {
    eval 'sub _I4B_IOCTL_H_ () {1;}' unless defined(&_I4B_IOCTL_H_);
    if(defined( &__FreeBSD__)  && (defined(&__FreeBSD__) ? &__FreeBSD__ : 0) >= 3) {
	unless(defined(&_MACHINE_TYPES_H_)) {
	    require 'machine/types.ph';
	}
    }
    eval 'sub VERSION () {0;}' unless defined(&VERSION);
    eval 'sub REL () {83;}' unless defined(&REL);
    eval 'sub STEP () {0;}' unless defined(&STEP);
    eval 'sub I4B_TIME_FORMAT () {"%d.%m.%Y %H:%M:%S";}' unless defined(&I4B_TIME_FORMAT);
    eval 'sub MAX_CONTROLLERS () {8;}' unless defined(&MAX_CONTROLLERS);
    eval 'sub CTRL_INVALID () {(-1);}' unless defined(&CTRL_INVALID);
    eval 'sub CTRL_UNKNOWN () {0;}' unless defined(&CTRL_UNKNOWN);
    eval 'sub CTRL_PASSIVE () {1;}' unless defined(&CTRL_PASSIVE);
    eval 'sub CTRL_DAIC () {2;}' unless defined(&CTRL_DAIC);
    eval 'sub CTRL_TINADD () {3;}' unless defined(&CTRL_TINADD);
    eval 'sub CTRL_AVMB1 () {4;}' unless defined(&CTRL_AVMB1);
    eval 'sub CTRL_NUMTYPES () {5;}' unless defined(&CTRL_NUMTYPES);
    eval 'sub CARD_TYPEP_INVAL () {(-1);}' unless defined(&CARD_TYPEP_INVAL);
    eval 'sub CARD_TYPEP_UNK () {0;}' unless defined(&CARD_TYPEP_UNK);
    eval 'sub CARD_TYPEP_8 () {1;}' unless defined(&CARD_TYPEP_8);
    eval 'sub CARD_TYPEP_16 () {2;}' unless defined(&CARD_TYPEP_16);
    eval 'sub CARD_TYPEP_16_3 () {3;}' unless defined(&CARD_TYPEP_16_3);
    eval 'sub CARD_TYPEP_AVMA1 () {4;}' unless defined(&CARD_TYPEP_AVMA1);
    eval 'sub CARD_TYPEP_163P () {5;}' unless defined(&CARD_TYPEP_163P);
    eval 'sub CARD_TYPEP_CS0P () {6;}' unless defined(&CARD_TYPEP_CS0P);
    eval 'sub CARD_TYPEP_USRTA () {7;}' unless defined(&CARD_TYPEP_USRTA);
    eval 'sub CARD_TYPEP_DRNNGO () {8;}' unless defined(&CARD_TYPEP_DRNNGO);
    eval 'sub CARD_TYPEP_SWS () {9;}' unless defined(&CARD_TYPEP_SWS);
    eval 'sub CARD_TYPEP_DYNALINK () {10;}' unless defined(&CARD_TYPEP_DYNALINK);
    eval 'sub CARD_TYPEP_BLMASTER () {11;}' unless defined(&CARD_TYPEP_BLMASTER);
    eval 'sub CARD_TYPEP_PCFRITZ () {12;}' unless defined(&CARD_TYPEP_PCFRITZ);
    eval 'sub CARD_TYPEP_ELSAQS1ISA () {13;}' unless defined(&CARD_TYPEP_ELSAQS1ISA);
    eval 'sub CARD_TYPEP_ELSAQS1PCI () {14;}' unless defined(&CARD_TYPEP_ELSAQS1PCI);
    eval 'sub CARD_TYPEP_SIEMENSITALK () {15;}' unless defined(&CARD_TYPEP_SIEMENSITALK);
    eval 'sub CARD_TYPEP_ELSAMLIMC () {16;}' unless defined(&CARD_TYPEP_ELSAMLIMC);
    eval 'sub CARD_TYPEP_ELSAMLMCALL () {17;}' unless defined(&CARD_TYPEP_ELSAMLMCALL);
    eval 'sub CARD_TYPEP_ITKIX1 () {18;}' unless defined(&CARD_TYPEP_ITKIX1);
    eval 'sub CARD_TYPEP_AVMA1PCI () {19;}' unless defined(&CARD_TYPEP_AVMA1PCI);
    eval 'sub CARD_TYPEP_PCC16 () {20;}' unless defined(&CARD_TYPEP_PCC16);
    eval 'sub CARD_TYPEP_AVM_PNP () {21;}' unless defined(&CARD_TYPEP_AVM_PNP);
    eval 'sub CARD_TYPEP_SIE_ISURF2 () {22;}' unless defined(&CARD_TYPEP_SIE_ISURF2);
    eval 'sub CARD_TYPEP_ASUSCOMIPAC () {23;}' unless defined(&CARD_TYPEP_ASUSCOMIPAC);
    eval 'sub CARD_TYPEP_MAX () {23;}' unless defined(&CARD_TYPEP_MAX);
    eval 'sub CARD_TYPEA_DAIC_UNK () {0;}' unless defined(&CARD_TYPEA_DAIC_UNK);
    eval 'sub CARD_TYPEA_DAIC_S () {1;}' unless defined(&CARD_TYPEA_DAIC_S);
    eval 'sub CARD_TYPEA_DAIC_SX () {2;}' unless defined(&CARD_TYPEA_DAIC_SX);
    eval 'sub CARD_TYPEA_DAIC_SCOM () {3;}' unless defined(&CARD_TYPEA_DAIC_SCOM);
    eval 'sub CARD_TYPEA_DAIC_QUAD () {4;}' unless defined(&CARD_TYPEA_DAIC_QUAD);
    eval 'sub TELNO_MAX () {41;}' unless defined(&TELNO_MAX);
    eval 'sub DISPLAY_MAX () {91;}' unless defined(&DISPLAY_MAX);
    eval 'sub DATETIME_MAX () {21;}' unless defined(&DATETIME_MAX);
    eval 'sub TELNO_EMPTY () {"NotAvailable";}' unless defined(&TELNO_EMPTY);
    eval 'sub BCH_MAX_DATALEN () {2048;}' unless defined(&BCH_MAX_DATALEN);
    eval 'sub BDRV_RBCH () {0;}' unless defined(&BDRV_RBCH);
    eval 'sub BDRV_TEL () {1;}' unless defined(&BDRV_TEL);
    eval 'sub BDRV_IPR () {2;}' unless defined(&BDRV_IPR);
    eval 'sub BDRV_ISPPP () {3;}' unless defined(&BDRV_ISPPP);
    eval 'sub BDRV_IBC () {4;}' unless defined(&BDRV_IBC);
    eval 'sub BPROT_NONE () {0;}' unless defined(&BPROT_NONE);
    eval 'sub BPROT_RHDLC () {1;}' unless defined(&BPROT_RHDLC);
    eval 'sub CDID_UNUSED () {0;}' unless defined(&CDID_UNUSED);
    eval 'sub CDID_MAX () {99999;}' unless defined(&CDID_MAX);
    eval 'sub SHA_FIXU () {0;}' unless defined(&SHA_FIXU);
    eval 'sub SHA_VARU () {1;}' unless defined(&SHA_VARU);
    eval 'sub MSG_CONNECT_IND () {ord(\'a\');}' unless defined(&MSG_CONNECT_IND);
    eval 'sub MSG_CONNECT_ACTIVE_IND () {ord(\'b\');}' unless defined(&MSG_CONNECT_ACTIVE_IND);
    eval 'sub MSG_DISCONNECT_IND () {ord(\'c\');}' unless defined(&MSG_DISCONNECT_IND);
    eval 'sub MSG_DIALOUT_IND () {ord(\'d\');}' unless defined(&MSG_DIALOUT_IND);
    eval 'sub MSG_IDLE_TIMEOUT_IND () {ord(\'e\');}' unless defined(&MSG_IDLE_TIMEOUT_IND);
    eval 'sub MSG_ACCT_IND () {ord(\'f\');}' unless defined(&MSG_ACCT_IND);
    eval 'sub MSG_CHARGING_IND () {ord(\'g\');}' unless defined(&MSG_CHARGING_IND);
    eval 'sub MSG_PROCEEDING_IND () {ord(\'h\');}' unless defined(&MSG_PROCEEDING_IND);
    eval 'sub MSG_ALERT_IND () {ord(\'i\');}' unless defined(&MSG_ALERT_IND);
    eval 'sub MSG_DRVRDISC_REQ () {ord(\'j\');}' unless defined(&MSG_DRVRDISC_REQ);
    eval 'sub MSG_L12STAT_IND () {ord(\'k\');}' unless defined(&MSG_L12STAT_IND);
    eval 'sub MSG_TEIASG_IND () {ord(\'l\');}' unless defined(&MSG_TEIASG_IND);
    eval 'sub MSG_PDEACT_IND () {ord(\'m\');}' unless defined(&MSG_PDEACT_IND);
    eval 'sub MSG_NEGCOMP_IND () {ord(\'n\');}' unless defined(&MSG_NEGCOMP_IND);
    eval 'sub MSG_IFSTATE_CHANGED_IND () {ord(\'o\');}' unless defined(&MSG_IFSTATE_CHANGED_IND);
    eval 'sub MSG_DIALOUTNUMBER_IND () {ord(\'p\');}' unless defined(&MSG_DIALOUTNUMBER_IND);
    eval 'sub CHAN_B1 () {0;}' unless defined(&CHAN_B1);
    eval 'sub CHAN_B2 () {1;}' unless defined(&CHAN_B2);
    eval 'sub CHAN_ANY () {(-1);}' unless defined(&CHAN_ANY);
    eval 'sub CHAN_NO () {(-2);}' unless defined(&CHAN_NO);
    eval 'sub SCR_NONE () {0;}' unless defined(&SCR_NONE);
    eval 'sub SCR_USR_NOSC () {1;}' unless defined(&SCR_USR_NOSC);
    eval 'sub SCR_USR_PASS () {2;}' unless defined(&SCR_USR_PASS);
    eval 'sub SCR_USR_FAIL () {3;}' unless defined(&SCR_USR_FAIL);
    eval 'sub SCR_NET () {4;}' unless defined(&SCR_NET);
    eval 'sub ACCT_DURING () {0;}' unless defined(&ACCT_DURING);
    eval 'sub ACCT_FINAL () {1;}' unless defined(&ACCT_FINAL);
    eval 'sub CHARGE_INVALID () {0;}' unless defined(&CHARGE_INVALID);
    eval 'sub CHARGE_AOCD () {1;}' unless defined(&CHARGE_AOCD);
    eval 'sub CHARGE_AOCE () {2;}' unless defined(&CHARGE_AOCE);
    eval 'sub CHARGE_CALC () {3;}' unless defined(&CHARGE_CALC);
    eval 'sub LAYER_ONE () {1;}' unless defined(&LAYER_ONE);
    eval 'sub LAYER_TWO () {2;}' unless defined(&LAYER_TWO);
    eval 'sub LAYER_IDLE () {0;}' unless defined(&LAYER_IDLE);
    eval 'sub LAYER_ACTIVE () {1;}' unless defined(&LAYER_ACTIVE);
    eval 'sub I4B_CDID_REQ () { &_IOWR(ord(\'4\'), 0, \'int\');}' unless defined(&I4B_CDID_REQ);
    eval 'sub ULEN_METHOD_STATIC () {0;}' unless defined(&ULEN_METHOD_STATIC);
    eval 'sub ULEN_METHOD_DYNAMIC () {1;}' unless defined(&ULEN_METHOD_DYNAMIC);
    eval 'sub I4B_CONNECT_REQ () { &_IOW(ord(\'4\'), 1,  &msg_connect_req_t);}' unless defined(&I4B_CONNECT_REQ);
    eval 'sub SETUP_RESP_DNTCRE () {0;}' unless defined(&SETUP_RESP_DNTCRE);
    eval 'sub SETUP_RESP_REJECT () {1;}' unless defined(&SETUP_RESP_REJECT);
    eval 'sub SETUP_RESP_ACCEPT () {2;}' unless defined(&SETUP_RESP_ACCEPT);
    eval 'sub I4B_CONNECT_RESP () { &_IOW(ord(\'4\'), 2,  &msg_connect_resp_t);}' unless defined(&I4B_CONNECT_RESP);
    eval 'sub I4B_DISCONNECT_REQ () { &_IOW(ord(\'4\'), 3,  &msg_discon_req_t);}' unless defined(&I4B_DISCONNECT_REQ);
    eval 'sub I4B_CTRL_INFO_REQ () { &_IOWR(ord(\'4\'), 4,  &msg_ctrl_info_req_t);}' unless defined(&I4B_CTRL_INFO_REQ);
    eval 'sub DSTAT_NONE () {0;}' unless defined(&DSTAT_NONE);
    eval 'sub DSTAT_TFAIL () {1;}' unless defined(&DSTAT_TFAIL);
    eval 'sub DSTAT_PFAIL () {2;}' unless defined(&DSTAT_PFAIL);
    eval 'sub DSTAT_INONLY () {3;}' unless defined(&DSTAT_INONLY);
    eval 'sub I4B_DIALOUT_RESP () { &_IOW(ord(\'4\'), 5,  &msg_dialout_resp_t);}' unless defined(&I4B_DIALOUT_RESP);
    eval 'sub I4B_TIMEOUT_UPD () { &_IOW(ord(\'4\'), 6,  &msg_timeout_upd_t);}' unless defined(&I4B_TIMEOUT_UPD);
    eval 'sub SOFT_ENA () {0;}' unless defined(&SOFT_ENA);
    eval 'sub SOFT_DIS () {1;}' unless defined(&SOFT_DIS);
    eval 'sub I4B_UPDOWN_IND () { &_IOW(ord(\'4\'), 7,  &msg_updown_ind_t);}' unless defined(&I4B_UPDOWN_IND);
    eval 'sub I4B_ALERT_REQ () { &_IOW(ord(\'4\'), 8,  &msg_alert_req_t);}' unless defined(&I4B_ALERT_REQ);
    eval 'sub I4B_VR_REQ () { &_IOR(ord(\'4\'), 9,  &msg_vr_req_t);}' unless defined(&I4B_VR_REQ);
    eval 'sub I4B_CTRL_DOWNLOAD () { &_IOW(ord(\'4\'), 100, \'struct isdn_download_request\');}' unless defined(&I4B_CTRL_DOWNLOAD);
    eval 'sub I4B_ACTIVE_DIAGNOSTIC () { &_IOW(ord(\'4\'), 102, \'struct isdn_diagnostic_request\');}' unless defined(&I4B_ACTIVE_DIAGNOSTIC);
}
1;
