require '_h2ph_pre.ph';

unless(defined(&_MACHINE_IPL_H_)) {
    eval 'sub _MACHINE_IPL_H_ () {1;}' unless defined(&_MACHINE_IPL_H_);
    if(defined(&APIC_IO)) {
	require 'i386/isa/apic_ipl.ph';
    } else {
	require 'i386/isa/icu_ipl.ph';
    }
    eval 'sub SWI_TTY () {( &NHWI + 0);}' unless defined(&SWI_TTY);
    eval 'sub SWI_NET () {( &NHWI + 1);}' unless defined(&SWI_NET);
    eval 'sub SWI_CAMNET () {( &NHWI + 2);}' unless defined(&SWI_CAMNET);
    eval 'sub SWI_CAMBIO () {( &NHWI + 3);}' unless defined(&SWI_CAMBIO);
    eval 'sub SWI_VM () {( &NHWI + 4);}' unless defined(&SWI_VM);
    eval 'sub SWI_CLOCK () {30;}' unless defined(&SWI_CLOCK);
    eval 'sub SWI_AST () {31;}' unless defined(&SWI_AST);
    eval 'sub NSWI () {(32-  &NHWI);}' unless defined(&NSWI);
    eval 'sub SWI_TTY_PENDING () {(1<<  &SWI_TTY);}' unless defined(&SWI_TTY_PENDING);
    eval 'sub SWI_NET_PENDING () {(1<<  &SWI_NET);}' unless defined(&SWI_NET_PENDING);
    eval 'sub SWI_CAMNET_PENDING () {(1<<  &SWI_CAMNET);}' unless defined(&SWI_CAMNET_PENDING);
    eval 'sub SWI_CAMBIO_PENDING () {(1<<  &SWI_CAMBIO);}' unless defined(&SWI_CAMBIO_PENDING);
    eval 'sub SWI_VM_PENDING () {(1<<  &SWI_VM);}' unless defined(&SWI_VM_PENDING);
    eval 'sub SWI_CLOCK_PENDING () {(1<<  &SWI_CLOCK);}' unless defined(&SWI_CLOCK_PENDING);
    eval 'sub SWI_AST_PENDING () {(1<<  &SWI_AST);}' unless defined(&SWI_AST_PENDING);
    eval 'sub SWI_TTY_MASK () {( &SWI_TTY_PENDING |  &SWI_CLOCK_MASK |  &SWI_NET_MASK);}' unless defined(&SWI_TTY_MASK);
    eval 'sub SWI_CAMNET_MASK () {( &SWI_CAMNET_PENDING |  &SWI_CLOCK_MASK);}' unless defined(&SWI_CAMNET_MASK);
    eval 'sub SWI_CAMBIO_MASK () {( &SWI_CAMBIO_PENDING |  &SWI_CLOCK_MASK);}' unless defined(&SWI_CAMBIO_MASK);
    eval 'sub SWI_NET_MASK () {( &SWI_NET_PENDING |  &SWI_CLOCK_MASK);}' unless defined(&SWI_NET_MASK);
    eval 'sub SWI_VM_MASK () {( &SWI_VM_PENDING |  &SWI_CLOCK_MASK);}' unless defined(&SWI_VM_MASK);
    eval 'sub SWI_CLOCK_MASK () {( &SWI_CLOCK_PENDING |  &SWI_AST_MASK);}' unless defined(&SWI_CLOCK_MASK);
    eval 'sub SWI_AST_MASK () { &SWI_AST_PENDING;}' unless defined(&SWI_AST_MASK);
    eval 'sub SWI_MASK () {(~ &HWI_MASK);}' unless defined(&SWI_MASK);
    unless(defined(&LOCORE)) {
	if(defined(&notyet)) {
	}
	if(defined(&SMP)) {
	}
	if(defined(&notyet)) {
	}
    }
}
1;
