require '_h2ph_pre.ph';

unless(defined(&_MACHINE_PARAM_H_)) {
    eval 'sub _MACHINE_PARAM_H_ () {1;}' unless defined(&_MACHINE_PARAM_H_);
    eval 'sub _MACHINE () { &i386;}' unless defined(&_MACHINE);
    eval 'sub MACHINE () {"i386";}' unless defined(&MACHINE);
    eval 'sub _MACHINE_ARCH () { &i386;}' unless defined(&_MACHINE_ARCH);
    eval 'sub MACHINE_ARCH () {"i386";}' unless defined(&MACHINE_ARCH);
    eval 'sub MID_MACHINE () { &MID_I386;}' unless defined(&MID_MACHINE);
    eval 'sub OBJFORMAT_NAMES () {"elf", "aout";}' unless defined(&OBJFORMAT_NAMES);
    eval 'sub OBJFORMAT_DEFAULT () {"elf";}' unless defined(&OBJFORMAT_DEFAULT);
    if(defined(&SMP)) {
	eval 'sub NCPUS () {2;}' unless defined(&NCPUS);
    } else {
	eval 'sub NCPUS () {1;}' unless defined(&NCPUS);
    }
    eval 'sub ALIGNBYTES () {($sizeof{\'int\'} - 1);}' unless defined(&ALIGNBYTES);
    eval 'sub ALIGN {
        local($p) = @_;
	    eval q(((($p) +  &ALIGNBYTES) & ~ &ALIGNBYTES));
    }' unless defined(&ALIGN);
    eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
    eval 'sub PAGE_SIZE () {(1<< &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    eval 'sub PAGE_MASK () {( &PAGE_SIZE-1);}' unless defined(&PAGE_MASK);
    eval 'sub NPTEPG () {( &PAGE_SIZE/($sizeof{ &pt_entry_t}));}' unless defined(&NPTEPG);
    eval 'sub NPDEPG () {( &PAGE_SIZE/($sizeof{ &pd_entry_t}));}' unless defined(&NPDEPG);
    eval 'sub PDRSHIFT () {22;}' unless defined(&PDRSHIFT);
    eval 'sub NBPDR () {(1<< &PDRSHIFT);}' unless defined(&NBPDR);
    eval 'sub PDRMASK () {( &NBPDR-1);}' unless defined(&PDRMASK);
    eval 'sub DEV_BSHIFT () {9;}' unless defined(&DEV_BSHIFT);
    eval 'sub DEV_BSIZE () {(1<< &DEV_BSHIFT);}' unless defined(&DEV_BSIZE);
    eval 'sub BLKDEV_IOSIZE () {2048;}' unless defined(&BLKDEV_IOSIZE);
    eval 'sub DFLTPHYS () {(64* 1024);}' unless defined(&DFLTPHYS);
    eval 'sub MAXPHYS () {(128* 1024);}' unless defined(&MAXPHYS);
    eval 'sub IOPAGES () {2;}' unless defined(&IOPAGES);
    eval 'sub UPAGES () {2;}' unless defined(&UPAGES);
    eval 'sub UPAGES_HOLE () {2;}' unless defined(&UPAGES_HOLE);
    unless(defined(&MSIZE)) {
	eval 'sub MSIZE () {128;}' unless defined(&MSIZE);
    }
    unless(defined(&MCLSHIFT)) {
	eval 'sub MCLSHIFT () {11;}' unless defined(&MCLSHIFT);
    }
    eval 'sub MCLBYTES () {(1<<  &MCLSHIFT);}' unless defined(&MCLBYTES);
    eval 'sub MCLOFSET () {( &MCLBYTES - 1);}' unless defined(&MCLOFSET);
    eval 'sub ctob {
        local($x) = @_;
	    eval q((($x)<< &PAGE_SHIFT));
    }' unless defined(&ctob);
    eval 'sub btoc {
        local($x) = @_;
	    eval q(((($x)+ &PAGE_MASK)>> &PAGE_SHIFT));
    }' unless defined(&btoc);
    eval 'sub btodb {
        local($bytes) = @_;
	    eval q(( &sizeof >  &sizeof ? ( >>  &DEV_BSHIFT) : (($bytes) >>  &DEV_BSHIFT)));
    }' unless defined(&btodb);
    eval 'sub dbtob {
        local($db) = @_;
	    eval q((($db) <<  &DEV_BSHIFT));
    }' unless defined(&dbtob);
    eval 'sub trunc_page {
        local($x) = @_;
	    eval q((($x) & ~ &PAGE_MASK));
    }' unless defined(&trunc_page);
    eval 'sub round_page {
        local($x) = @_;
	    eval q(((($x) +  &PAGE_MASK) & ~ &PAGE_MASK));
    }' unless defined(&round_page);
    eval 'sub trunc_4mpage {
        local($x) = @_;
	    eval q((($x) & ~ &PDRMASK));
    }' unless defined(&trunc_4mpage);
    eval 'sub round_4mpage {
        local($x) = @_;
	    eval q((((($x)) +  &PDRMASK) & ~ &PDRMASK));
    }' unless defined(&round_4mpage);
    eval 'sub atop {
        local($x) = @_;
	    eval q((($x) >>  &PAGE_SHIFT));
    }' unless defined(&atop);
    eval 'sub ptoa {
        local($x) = @_;
	    eval q((($x) <<  &PAGE_SHIFT));
    }' unless defined(&ptoa);
    eval 'sub i386_btop {
        local($x) = @_;
	    eval q((($x) >>  &PAGE_SHIFT));
    }' unless defined(&i386_btop);
    eval 'sub i386_ptob {
        local($x) = @_;
	    eval q((($x) <<  &PAGE_SHIFT));
    }' unless defined(&i386_ptob);
}
1;
