require '_h2ph_pre.ph';

unless(defined(&_MACHINE_PCVT_IOCTL_H_)) {
    eval 'sub _MACHINE_PCVT_IOCTL_H_ () {1;}' unless defined(&_MACHINE_PCVT_IOCTL_H_);
    eval 'sub PCVTIDNAME () {"pcvt-b24";}' unless defined(&PCVTIDNAME);
    eval 'sub PCVTIDMAJOR () {3;}' unless defined(&PCVTIDMAJOR);
    eval 'sub PCVTIDMINOR () {20;}' unless defined(&PCVTIDMINOR);
    if(!defined( &KERNEL)  && !defined( &_KERNEL)) {
	require 'sys/types.ph';
    }
    require 'sys/ioccom.ph';
    eval 'sub KBDRESET () { &_IO(ord(\'K\'), 1);}' unless defined(&KBDRESET);
    eval 'sub KBDGTPMAT () { &_IOR(ord(\'K\'), 2, \'int\');}' unless defined(&KBDGTPMAT);
    eval 'sub KBDSTPMAT () { &_IOW(ord(\'K\'), 3, \'int\');}' unless defined(&KBDSTPMAT);
    eval 'sub KBD_TPD250 () {0x00;}' unless defined(&KBD_TPD250);
    eval 'sub KBD_TPD500 () {0x20;}' unless defined(&KBD_TPD500);
    eval 'sub KBD_TPD750 () {0x40;}' unless defined(&KBD_TPD750);
    eval 'sub KBD_TPD1000 () {0x60;}' unless defined(&KBD_TPD1000);
    eval 'sub KBD_TPM300 () {0x00;}' unless defined(&KBD_TPM300);
    eval 'sub KBD_TPM267 () {0x01;}' unless defined(&KBD_TPM267);
    eval 'sub KBD_TPM240 () {0x02;}' unless defined(&KBD_TPM240);
    eval 'sub KBD_TPM218 () {0x03;}' unless defined(&KBD_TPM218);
    eval 'sub KBD_TPM200 () {0x04;}' unless defined(&KBD_TPM200);
    eval 'sub KBD_TPM185 () {0x05;}' unless defined(&KBD_TPM185);
    eval 'sub KBD_TPM171 () {0x06;}' unless defined(&KBD_TPM171);
    eval 'sub KBD_TPM160 () {0x07;}' unless defined(&KBD_TPM160);
    eval 'sub KBD_TPM150 () {0x08;}' unless defined(&KBD_TPM150);
    eval 'sub KBD_TPM133 () {0x09;}' unless defined(&KBD_TPM133);
    eval 'sub KBD_TPM120 () {0x0a;}' unless defined(&KBD_TPM120);
    eval 'sub KBD_TPM109 () {0x0b;}' unless defined(&KBD_TPM109);
    eval 'sub KBD_TPM100 () {0x0c;}' unless defined(&KBD_TPM100);
    eval 'sub KBD_TPM92 () {0x0d;}' unless defined(&KBD_TPM92);
    eval 'sub KBD_TPM86 () {0x0e;}' unless defined(&KBD_TPM86);
    eval 'sub KBD_TPM80 () {0x0f;}' unless defined(&KBD_TPM80);
    eval 'sub KBD_TPM75 () {0x10;}' unless defined(&KBD_TPM75);
    eval 'sub KBD_TPM67 () {0x11;}' unless defined(&KBD_TPM67);
    eval 'sub KBD_TPM60 () {0x12;}' unless defined(&KBD_TPM60);
    eval 'sub KBD_TPM55 () {0x13;}' unless defined(&KBD_TPM55);
    eval 'sub KBD_TPM50 () {0x14;}' unless defined(&KBD_TPM50);
    eval 'sub KBD_TPM46 () {0x15;}' unless defined(&KBD_TPM46);
    eval 'sub KBD_TPM43 () {0x16;}' unless defined(&KBD_TPM43);
    eval 'sub KBD_TPM40 () {0x17;}' unless defined(&KBD_TPM40);
    eval 'sub KBD_TPM37 () {0x18;}' unless defined(&KBD_TPM37);
    eval 'sub KBD_TPM33 () {0x19;}' unless defined(&KBD_TPM33);
    eval 'sub KBD_TPM30 () {0x1a;}' unless defined(&KBD_TPM30);
    eval 'sub KBD_TPM27 () {0x1b;}' unless defined(&KBD_TPM27);
    eval 'sub KBD_TPM25 () {0x1c;}' unless defined(&KBD_TPM25);
    eval 'sub KBD_TPM23 () {0x1d;}' unless defined(&KBD_TPM23);
    eval 'sub KBD_TPM21 () {0x1e;}' unless defined(&KBD_TPM21);
    eval 'sub KBD_TPM20 () {0x1f;}' unless defined(&KBD_TPM20);
    eval 'sub KBDGREPSW () { &_IOR(ord(\'K\'), 4, \'int\');}' unless defined(&KBDGREPSW);
    eval 'sub KBDSREPSW () { &_IOW(ord(\'K\'), 5, \'int\');}' unless defined(&KBDSREPSW);
    eval 'sub KBD_REPEATOFF () {0;}' unless defined(&KBD_REPEATOFF);
    eval 'sub KBD_REPEATON () {1;}' unless defined(&KBD_REPEATON);
    eval 'sub KBDGLEDS () { &_IOR(ord(\'K\'), 6, \'int\');}' unless defined(&KBDGLEDS);
    eval 'sub KBDSLEDS () { &_IOW(ord(\'K\'), 7, \'int\');}' unless defined(&KBDSLEDS);
    eval 'sub KBD_SCROLLLOCK () {0x0001;}' unless defined(&KBD_SCROLLLOCK);
    eval 'sub KBD_NUMLOCK () {0x0002;}' unless defined(&KBD_NUMLOCK);
    eval 'sub KBD_CAPSLOCK () {0x0004;}' unless defined(&KBD_CAPSLOCK);
    eval 'sub KBDGLOCK () { &_IOR(ord(\'K\'), 8, \'int\');}' unless defined(&KBDGLOCK);
    eval 'sub KBDSLOCK () { &_IOW(ord(\'K\'), 9, \'int\');}' unless defined(&KBDSLOCK);
    eval 'sub KBDMAXOVLKEYSIZE () {15;}' unless defined(&KBDMAXOVLKEYSIZE);
    eval 'sub KBDMAXKEYS () {128;}' unless defined(&KBDMAXKEYS);
    eval 'sub KBD_NONE () {0;}' unless defined(&KBD_NONE);
    eval 'sub KBD_SHIFT () {1;}' unless defined(&KBD_SHIFT);
    eval 'sub KBD_META () {2;}' unless defined(&KBD_META);
    eval 'sub KBD_NUM () {3;}' unless defined(&KBD_NUM);
    eval 'sub KBD_CTL () {4;}' unless defined(&KBD_CTL);
    eval 'sub KBD_CAPS () {5;}' unless defined(&KBD_CAPS);
    eval 'sub KBD_ASCII () {6;}' unless defined(&KBD_ASCII);
    eval 'sub KBD_SCROLL () {7;}' unless defined(&KBD_SCROLL);
    eval 'sub KBD_FUNC () {8;}' unless defined(&KBD_FUNC);
    eval 'sub KBD_KP () {9;}' unless defined(&KBD_KP);
    eval 'sub KBD_BREAK () {10;}' unless defined(&KBD_BREAK);
    eval 'sub KBD_ALTGR () {11;}' unless defined(&KBD_ALTGR);
    eval 'sub KBD_SHFTLOCK () {12;}' unless defined(&KBD_SHFTLOCK);
    eval 'sub KBD_CURSOR () {13;}' unless defined(&KBD_CURSOR);
    eval 'sub KBD_RETURN () {14;}' unless defined(&KBD_RETURN);
    eval 'sub KBD_SUBT_STR () {0;}' unless defined(&KBD_SUBT_STR);
    eval 'sub KBD_SUBT_FNC () {1;}' unless defined(&KBD_SUBT_FNC);
    eval 'sub KBD_OVERLOAD () {0x8000;}' unless defined(&KBD_OVERLOAD);
    eval 'sub KBD_MASK () {(~ &KBD_OVERLOAD);}' unless defined(&KBD_MASK);
    eval 'sub KBDGCKEY () { &_IOWR(ord(\'K\'),16, \'struct kbd_ovlkey\');}' unless defined(&KBDGCKEY);
    eval 'sub KBDSCKEY () { &_IOW(ord(\'K\'),17, \'struct kbd_ovlkey\');}' unless defined(&KBDSCKEY);
    eval 'sub KBDGOKEY () { &_IOWR(ord(\'K\'),18, \'struct kbd_ovlkey\');}' unless defined(&KBDGOKEY);
    eval 'sub KBDRMKEY () { &_IOW(ord(\'K\'),19, \'int\');}' unless defined(&KBDRMKEY);
    eval 'sub KBDDEFAULT () { &_IO(ord(\'K\'),20);}' unless defined(&KBDDEFAULT);
    eval 'sub KBDMOUSEGET () { &_IOR(ord(\'K\'), 25, \'struct mousedefs\');}' unless defined(&KBDMOUSEGET);
    eval 'sub KBDMOUSESET () { &_IOW(ord(\'K\'), 26, \'struct mousedefs\');}' unless defined(&KBDMOUSESET);
    eval 'sub UNKNOWN_ADAPTOR () {0;}' unless defined(&UNKNOWN_ADAPTOR);
    eval 'sub MDA_ADAPTOR () {1;}' unless defined(&MDA_ADAPTOR);
    eval 'sub CGA_ADAPTOR () {2;}' unless defined(&CGA_ADAPTOR);
    eval 'sub EGA_ADAPTOR () {3;}' unless defined(&EGA_ADAPTOR);
    eval 'sub VGA_ADAPTOR () {4;}' unless defined(&VGA_ADAPTOR);
    eval 'sub MONITOR_MONO () {0;}' unless defined(&MONITOR_MONO);
    eval 'sub MONITOR_COLOR () {1;}' unless defined(&MONITOR_COLOR);
    eval 'sub VGA_F_NONE () {0;}' unless defined(&VGA_F_NONE);
    eval 'sub VGA_UNKNOWN () {0;}' unless defined(&VGA_UNKNOWN);
    eval 'sub VGA_F_TSENG () {1;}' unless defined(&VGA_F_TSENG);
    eval 'sub VGA_ET4000 () {1;}' unless defined(&VGA_ET4000);
    eval 'sub VGA_ET3000 () {2;}' unless defined(&VGA_ET3000);
    eval 'sub VGA_F_WD () {2;}' unless defined(&VGA_F_WD);
    eval 'sub VGA_PVGA () {3;}' unless defined(&VGA_PVGA);
    eval 'sub VGA_WD90C00 () {4;}' unless defined(&VGA_WD90C00);
    eval 'sub VGA_WD90C10 () {5;}' unless defined(&VGA_WD90C10);
    eval 'sub VGA_WD90C11 () {6;}' unless defined(&VGA_WD90C11);
    eval 'sub VGA_F_V7 () {3;}' unless defined(&VGA_F_V7);
    eval 'sub VGA_V7VEGA () {7;}' unless defined(&VGA_V7VEGA);
    eval 'sub VGA_V7FWVR () {8;}' unless defined(&VGA_V7FWVR);
    eval 'sub VGA_V7V5 () {9;}' unless defined(&VGA_V7V5);
    eval 'sub VGA_V71024I () {10;}' unless defined(&VGA_V71024I);
    eval 'sub VGA_V7UNKNOWN () {11;}' unless defined(&VGA_V7UNKNOWN);
    eval 'sub VGA_F_TRI () {4;}' unless defined(&VGA_F_TRI);
    eval 'sub VGA_TR8800BR () {12;}' unless defined(&VGA_TR8800BR);
    eval 'sub VGA_TR8800CS () {13;}' unless defined(&VGA_TR8800CS);
    eval 'sub VGA_TR8900B () {14;}' unless defined(&VGA_TR8900B);
    eval 'sub VGA_TR8900C () {15;}' unless defined(&VGA_TR8900C);
    eval 'sub VGA_TR8900CL () {16;}' unless defined(&VGA_TR8900CL);
    eval 'sub VGA_TR9000 () {17;}' unless defined(&VGA_TR9000);
    eval 'sub VGA_TR9100 () {18;}' unless defined(&VGA_TR9100);
    eval 'sub VGA_TR9200 () {19;}' unless defined(&VGA_TR9200);
    eval 'sub VGA_TRUNKNOWN () {20;}' unless defined(&VGA_TRUNKNOWN);
    eval 'sub VGA_F_S3 () {5;}' unless defined(&VGA_F_S3);
    eval 'sub VGA_S3_911 () {21;}' unless defined(&VGA_S3_911);
    eval 'sub VGA_S3_924 () {22;}' unless defined(&VGA_S3_924);
    eval 'sub VGA_S3_80x () {23;}' unless defined(&VGA_S3_80x);
    eval 'sub VGA_S3_928 () {24;}' unless defined(&VGA_S3_928);
    eval 'sub VGA_S3_UNKNOWN () {25;}' unless defined(&VGA_S3_UNKNOWN);
    eval 'sub VGA_F_CIR () {6;}' unless defined(&VGA_F_CIR);
    eval 'sub VGA_CL_GD5402 () {26;}' unless defined(&VGA_CL_GD5402);
    eval 'sub VGA_CL_GD5402r1 () {27;}' unless defined(&VGA_CL_GD5402r1);
    eval 'sub VGA_CL_GD5420 () {28;}' unless defined(&VGA_CL_GD5420);
    eval 'sub VGA_CL_GD5420r1 () {29;}' unless defined(&VGA_CL_GD5420r1);
    eval 'sub VGA_CL_GD5422 () {30;}' unless defined(&VGA_CL_GD5422);
    eval 'sub VGA_CL_GD5424 () {31;}' unless defined(&VGA_CL_GD5424);
    eval 'sub VGA_CL_GD5426 () {32;}' unless defined(&VGA_CL_GD5426);
    eval 'sub VGA_CL_GD5428 () {33;}' unless defined(&VGA_CL_GD5428);
    eval 'sub SIZ_25ROWS () {0;}' unless defined(&SIZ_25ROWS);
    eval 'sub SIZ_28ROWS () {1;}' unless defined(&SIZ_28ROWS);
    eval 'sub SIZ_35ROWS () {2;}' unless defined(&SIZ_35ROWS);
    eval 'sub SIZ_40ROWS () {3;}' unless defined(&SIZ_40ROWS);
    eval 'sub SIZ_43ROWS () {4;}' unless defined(&SIZ_43ROWS);
    eval 'sub SIZ_50ROWS () {5;}' unless defined(&SIZ_50ROWS);
    eval 'sub FNT_8x16 () {0;}' unless defined(&FNT_8x16);
    eval 'sub FNT_8x14 () {1;}' unless defined(&FNT_8x14);
    eval 'sub FNT_8x10 () {2;}' unless defined(&FNT_8x10);
    eval 'sub FNT_8x8 () {3;}' unless defined(&FNT_8x8);
    eval 'sub CH_SET0 () {0;}' unless defined(&CH_SET0);
    eval 'sub CH_SET1 () {1;}' unless defined(&CH_SET1);
    eval 'sub CH_SET2 () {2;}' unless defined(&CH_SET2);
    eval 'sub CH_SET3 () {3;}' unless defined(&CH_SET3);
    eval 'sub CH_SETMAX_EGA () {3;}' unless defined(&CH_SETMAX_EGA);
    eval 'sub CH_SET4 () {4;}' unless defined(&CH_SET4);
    eval 'sub CH_SET5 () {5;}' unless defined(&CH_SET5);
    eval 'sub CH_SET6 () {6;}' unless defined(&CH_SET6);
    eval 'sub CH_SET7 () {7;}' unless defined(&CH_SET7);
    eval 'sub CH_SETMAX_VGA () {7;}' unless defined(&CH_SETMAX_VGA);
    eval 'sub M_HPVT () {0;}' unless defined(&M_HPVT);
    eval 'sub M_PUREVT () {1;}' unless defined(&M_PUREVT);
    eval 'sub VGACURSOR () { &_IOW(ord(\'V\'),100, \'struct cursorshape\');}' unless defined(&VGACURSOR);
    eval 'sub VGALOADCHAR () { &_IOW(ord(\'V\'),101, \'struct vgaloadchar\');}' unless defined(&VGALOADCHAR);
    eval 'sub VGASETFONTATTR () { &_IOW(ord(\'V\'),102, \'struct vgafontattr\');}' unless defined(&VGASETFONTATTR);
    eval 'sub VGAGETFONTATTR () { &_IOWR(ord(\'V\'),103, \'struct vgafontattr\');}' unless defined(&VGAGETFONTATTR);
    eval 'sub VGASETSCREEN () { &_IOW(ord(\'V\'),104, \'struct screeninfo\');}' unless defined(&VGASETSCREEN);
    eval 'sub VGAGETSCREEN () { &_IOWR(ord(\'V\'),105, \'struct screeninfo\');}' unless defined(&VGAGETSCREEN);
    eval 'sub VGAREADPEL () { &_IOWR(ord(\'V\'), 110, \'struct vgapel\');}' unless defined(&VGAREADPEL);
    eval 'sub VGAWRITEPEL () { &_IOW(ord(\'V\'), 111, \'struct vgapel\');}' unless defined(&VGAWRITEPEL);
    eval 'sub VGASCREENSAVER () { &_IOW(ord(\'V\'), 112, \'int\');}' unless defined(&VGASCREENSAVER);
    eval 'sub VGAPCVTID () { &_IOWR(ord(\'V\'),113, \'struct pcvtid\');}' unless defined(&VGAPCVTID);
    eval 'sub PCVTIDNAMELN () {16;}' unless defined(&PCVTIDNAMELN);
    eval 'sub VGAPCVTINFO () { &_IOWR(ord(\'V\'),114, \'struct pcvtinfo\');}' unless defined(&VGAPCVTINFO);
    eval 'sub CONF_UNKNOWNOPSYS () {0;}' unless defined(&CONF_UNKNOWNOPSYS);
    eval 'sub CONF_386BSD () {1;}' unless defined(&CONF_386BSD);
    eval 'sub CONF_NETBSD () {2;}' unless defined(&CONF_NETBSD);
    eval 'sub CONF_FREEBSD () {3;}' unless defined(&CONF_FREEBSD);
    eval 'sub CONF_VT220KEYB () {0x00000001;}' unless defined(&CONF_VT220KEYB);
    eval 'sub CONF_SCREENSAVER () {0x00000002;}' unless defined(&CONF_SCREENSAVER);
    eval 'sub CONF_PRETTYSCRNS () {0x00000004;}' unless defined(&CONF_PRETTYSCRNS);
    eval 'sub CONF_CTRL_ALT_DEL () {0x00000008;}' unless defined(&CONF_CTRL_ALT_DEL);
    eval 'sub CONF_USEKBDSEC () {0x00000010;}' unless defined(&CONF_USEKBDSEC);
    eval 'sub CONF_24LINESDEF () {0x00000020;}' unless defined(&CONF_24LINESDEF);
    eval 'sub CONF_EMU_MOUSE () {0x00000040;}' unless defined(&CONF_EMU_MOUSE);
    eval 'sub CONF_SHOWKEYS () {0x00000080;}' unless defined(&CONF_SHOWKEYS);
    eval 'sub CONF_KEYBDID () {0x00000100;}' unless defined(&CONF_KEYBDID);
    eval 'sub CONF_SIGWINCH () {0x00000200;}' unless defined(&CONF_SIGWINCH);
    eval 'sub CONF_NULLCHARS () {0x00000400;}' unless defined(&CONF_NULLCHARS);
    eval 'sub CONF_BACKUP_FONTS () {0x00000800;}' unless defined(&CONF_BACKUP_FONTS);
    eval 'sub CONF_SW0CNOUTP () {0x00001000;}' unless defined(&CONF_SW0CNOUTP);
    eval 'sub CONF_SETCOLOR () {0x00004000;}' unless defined(&CONF_SETCOLOR);
    eval 'sub CONF_132GENERIC () {0x00008000;}' unless defined(&CONF_132GENERIC);
    eval 'sub CONF_PALFLICKER () {0x00010000;}' unless defined(&CONF_PALFLICKER);
    eval 'sub CONF_WAITRETRACE () {0x00020000;}' unless defined(&CONF_WAITRETRACE);
    eval 'sub CONF_XSERVER () {0x00040000;}' unless defined(&CONF_XSERVER);
    eval 'sub CONF_USL_VT_COMPAT () {0x00080000;}' unless defined(&CONF_USL_VT_COMPAT);
    eval 'sub CONF_PORTIO_DELAY () {0x00100000;}' unless defined(&CONF_PORTIO_DELAY);
    eval 'sub CONF_INHIBIT_NUMLOCK () {0x00200000;}' unless defined(&CONF_INHIBIT_NUMLOCK);
    eval 'sub CONF_META_ESC () {0x00400000;}' unless defined(&CONF_META_ESC);
    eval 'sub CONF_NOFASTSCROLL () {0x00800000;}' unless defined(&CONF_NOFASTSCROLL);
    eval 'sub CONF_SLOW_INTERRUPT () {0x01000000;}' unless defined(&CONF_SLOW_INTERRUPT);
    eval 'sub CONF_KBD_FIFO () {0x02000000;}' unless defined(&CONF_KBD_FIFO);
    eval 'sub CONF_NO_LED_UPDATE () {0x04000000;}' unless defined(&CONF_NO_LED_UPDATE);
    eval 'sub VGASETCOLMS () { &_IOW(ord(\'V\'), 115, \'int\');}' unless defined(&VGASETCOLMS);
    eval 'sub CONSOLE_X_MODE_ON () { &_IO(ord(\'t\'), 121);}' unless defined(&CONSOLE_X_MODE_ON);
    eval 'sub CONSOLE_X_MODE_OFF () { &_IO(ord(\'t\'), 122);}' unless defined(&CONSOLE_X_MODE_OFF);
    eval 'sub CONSOLE_X_BELL () { &_IOW(ord(\'t\'), 123, \'int\'[2]);}' unless defined(&CONSOLE_X_BELL);
    eval 'sub KDSKBMODE () { &_IO(ord(\'K\'), 7);}' unless defined(&KDSKBMODE);
    eval 'sub K_RAW () {0;}' unless defined(&K_RAW);
    eval 'sub K_XLATE () {1;}' unless defined(&K_XLATE);
    eval 'sub KDMKTONE () { &_IO(ord(\'K\'), 8);}' unless defined(&KDMKTONE);
    eval 'sub KDSETMODE () { &_IO(ord(\'K\'), 10);}' unless defined(&KDSETMODE);
    eval 'sub KD_TEXT () {0;}' unless defined(&KD_TEXT);
    eval 'sub KD_GRAPHICS () {1;}' unless defined(&KD_GRAPHICS);
    eval 'sub KDENABIO () { &_IO(ord(\'K\'), 60);}' unless defined(&KDENABIO);
    eval 'sub KDDISABIO () { &_IO(ord(\'K\'), 61);}' unless defined(&KDDISABIO);
    eval 'sub KDGETLED () { &_IOR(ord(\'K\'), 65, \'int\');}' unless defined(&KDGETLED);
    eval 'sub KDSETLED () { &_IO(ord(\'K\'), 66);}' unless defined(&KDSETLED);
    eval 'sub LED_CAP () {1;}' unless defined(&LED_CAP);
    eval 'sub LED_NUM () {2;}' unless defined(&LED_NUM);
    eval 'sub LED_SCR () {4;}' unless defined(&LED_SCR);
    eval 'sub KDSETRAD () { &_IO(ord(\'K\'), 67);}' unless defined(&KDSETRAD);
    eval 'sub GIO_KEYMAP () { &_IOR(ord(\'k\'), 6,  &keymap_t);}' unless defined(&GIO_KEYMAP);
    eval 'sub VT_OPENQRY () { &_IOR(ord(\'v\'), 1, \'int\');}' unless defined(&VT_OPENQRY);
    eval 'sub VT_SETMODE () { &_IOW(ord(\'v\'), 2,  &vtmode_t);}' unless defined(&VT_SETMODE);
    eval 'sub VT_GETMODE () { &_IOR(ord(\'v\'), 3,  &vtmode_t);}' unless defined(&VT_GETMODE);
    eval 'sub VT_RELDISP () { &_IO(ord(\'v\'), 4);}' unless defined(&VT_RELDISP);
    eval 'sub VT_FALSE () {0;}' unless defined(&VT_FALSE);
    eval 'sub VT_TRUE () {1;}' unless defined(&VT_TRUE);
    eval 'sub VT_ACKACQ () {2;}' unless defined(&VT_ACKACQ);
    eval 'sub VT_ACTIVATE () { &_IO(ord(\'v\'), 5);}' unless defined(&VT_ACTIVATE);
    eval 'sub VT_WAITACTIVE () { &_IO(ord(\'v\'), 6);}' unless defined(&VT_WAITACTIVE);
    eval 'sub VT_GETACTIVE () { &_IOR(ord(\'v\'), 7, \'int\');}' unless defined(&VT_GETACTIVE);
    unless(defined(&_VT_MODE_DECLARED)) {
	eval 'sub _VT_MODE_DECLARED () {1;}' unless defined(&_VT_MODE_DECLARED);
	eval 'sub VT_AUTO () {0;}' unless defined(&VT_AUTO);
	eval 'sub VT_PROCESS () {1;}' unless defined(&VT_PROCESS);
    }
    eval 'sub NUM_KEYS () {256;}' unless defined(&NUM_KEYS);
    eval 'sub NUM_STATES () {8;}' unless defined(&NUM_STATES);
    unless(defined(&_KEYMAP_DECLARED)) {
	eval 'sub _KEYMAP_DECLARED () {1;}' unless defined(&_KEYMAP_DECLARED);
    }
}
1;
