require '_h2ph_pre.ph';

unless(defined(&_NETATM_ATM_STACK_H)) {
    eval 'sub _NETATM_ATM_STACK_H () {1;}' unless defined(&_NETATM_ATM_STACK_H);
    if(defined(&ATM_KERNEL)) {
	eval 'sub SDF_TERM () {0x01;}' unless defined(&SDF_TERM);
	eval 'sub STACK_CNT () {8;}' unless defined(&STACK_CNT);
	eval 'sub HEADIN {
	    local($cvp, $hi, $si) = @_;
    	    eval q({ \'short t\' = ($cvp)-> ($cvc_attr->{headin}) - ($si);  &t = ( &t >= ($hi)) ?  &t : ($hi); ($cvp)-> ($cvc_attr->{headin}) =  &roundup( &t, $sizeof{\'long\'}); });
	}' unless defined(&HEADIN);
	eval 'sub HEADOUT {
	    local($cvp, $ho, $ao) = @_;
    	    eval q({ \'short t\' = ($cvp)-> ($cvc_attr->{headout}) + ($ao);  &t = ( &t >= ($ho)) ?  &t : ($ho); ($cvp)-> ($cvc_attr->{headout}) =  &roundup( &t, $sizeof{\'long\'}); });
	}' unless defined(&HEADOUT);
	eval 'sub STKCMD {
	    local($s, $d, $v) = @_;
    	    eval q(((($s) << 16) | ($d) | ($v)));
	}' unless defined(&STKCMD);
	eval 'sub STKCMD_DOWN () {0;}' unless defined(&STKCMD_DOWN);
	eval 'sub STKCMD_UP () {0x00008000;}' unless defined(&STKCMD_UP);
	eval 'sub STKCMD_SAP_MASK () {0xffff0000;}' unless defined(&STKCMD_SAP_MASK);
	eval 'sub STKCMD_VAL_MASK () {0x00007fff;}' unless defined(&STKCMD_VAL_MASK);
	eval 'sub CCV_INIT () {1;}' unless defined(&CCV_INIT);
	eval 'sub CCV_TERM () {2;}' unless defined(&CCV_TERM);
	eval 'sub ATM_INIT () { &STKCMD( &SAP_ATM,  &STKCMD_DOWN,  &CCV_INIT);}' unless defined(&ATM_INIT);
	eval 'sub ATM_TERM () { &STKCMD( &SAP_ATM,  &STKCMD_DOWN,  &CCV_TERM);}' unless defined(&ATM_TERM);
	eval 'sub ATM_DATA_REQ () { &STKCMD( &SAP_ATM,  &STKCMD_DOWN, 16);}' unless defined(&ATM_DATA_REQ);
	eval 'sub ATM_DATA_IND () { &STKCMD( &SAP_ATM,  &STKCMD_UP, 17);}' unless defined(&ATM_DATA_IND);
	eval 'sub SAR_INIT () { &STKCMD( &SAP_SAR,  &STKCMD_DOWN,  &CCV_INIT);}' unless defined(&SAR_INIT);
	eval 'sub SAR_TERM () { &STKCMD( &SAP_SAR,  &STKCMD_DOWN,  &CCV_TERM);}' unless defined(&SAR_TERM);
	eval 'sub SAR_UNITDATA_INV () { &STKCMD( &SAP_SAR,  &STKCMD_DOWN, 16);}' unless defined(&SAR_UNITDATA_INV);
	eval 'sub SAR_UNITDATA_SIG () { &STKCMD( &SAP_SAR,  &STKCMD_UP, 17);}' unless defined(&SAR_UNITDATA_SIG);
	eval 'sub SAR_UABORT_INV () { &STKCMD( &SAP_SAR,  &STKCMD_DOWN, 18);}' unless defined(&SAR_UABORT_INV);
	eval 'sub SAR_UABORT_SIG () { &STKCMD( &SAP_SAR,  &STKCMD_UP, 19);}' unless defined(&SAR_UABORT_SIG);
	eval 'sub SAR_PABORT_SIG () { &STKCMD( &SAP_SAR,  &STKCMD_UP, 20);}' unless defined(&SAR_PABORT_SIG);
	eval 'sub CPCS_INIT () { &STKCMD( &SAP_CPCS,  &STKCMD_DOWN,  &CCV_INIT);}' unless defined(&CPCS_INIT);
	eval 'sub CPCS_TERM () { &STKCMD( &SAP_CPCS,  &STKCMD_DOWN,  &CCV_TERM);}' unless defined(&CPCS_TERM);
	eval 'sub CPCS_UNITDATA_INV () { &STKCMD( &SAP_CPCS,  &STKCMD_DOWN, 16);}' unless defined(&CPCS_UNITDATA_INV);
	eval 'sub CPCS_UNITDATA_SIG () { &STKCMD( &SAP_CPCS,  &STKCMD_UP, 17);}' unless defined(&CPCS_UNITDATA_SIG);
	eval 'sub CPCS_UABORT_INV () { &STKCMD( &SAP_CPCS,  &STKCMD_DOWN, 18);}' unless defined(&CPCS_UABORT_INV);
	eval 'sub CPCS_UABORT_SIG () { &STKCMD( &SAP_CPCS,  &STKCMD_UP, 19);}' unless defined(&CPCS_UABORT_SIG);
	eval 'sub CPCS_PABORT_SIG () { &STKCMD( &SAP_CPCS,  &STKCMD_UP, 20);}' unless defined(&CPCS_PABORT_SIG);
	eval 'sub SSCOP_INIT () { &STKCMD( &SAP_SSCOP,  &STKCMD_DOWN,  &CCV_INIT);}' unless defined(&SSCOP_INIT);
	eval 'sub SSCOP_TERM () { &STKCMD( &SAP_SSCOP,  &STKCMD_DOWN,  &CCV_TERM);}' unless defined(&SSCOP_TERM);
	eval 'sub SSCOP_ESTABLISH_REQ () { &STKCMD( &SAP_SSCOP,  &STKCMD_DOWN, 16);}' unless defined(&SSCOP_ESTABLISH_REQ);
	eval 'sub SSCOP_ESTABLISH_IND () { &STKCMD( &SAP_SSCOP,  &STKCMD_UP, 17);}' unless defined(&SSCOP_ESTABLISH_IND);
	eval 'sub SSCOP_ESTABLISH_RSP () { &STKCMD( &SAP_SSCOP,  &STKCMD_DOWN, 18);}' unless defined(&SSCOP_ESTABLISH_RSP);
	eval 'sub SSCOP_ESTABLISH_CNF () { &STKCMD( &SAP_SSCOP,  &STKCMD_UP, 19);}' unless defined(&SSCOP_ESTABLISH_CNF);
	eval 'sub SSCOP_RELEASE_REQ () { &STKCMD( &SAP_SSCOP,  &STKCMD_DOWN, 20);}' unless defined(&SSCOP_RELEASE_REQ);
	eval 'sub SSCOP_RELEASE_IND () { &STKCMD( &SAP_SSCOP,  &STKCMD_UP, 21);}' unless defined(&SSCOP_RELEASE_IND);
	eval 'sub SSCOP_RELEASE_CNF () { &STKCMD( &SAP_SSCOP,  &STKCMD_UP, 22);}' unless defined(&SSCOP_RELEASE_CNF);
	eval 'sub SSCOP_DATA_REQ () { &STKCMD( &SAP_SSCOP,  &STKCMD_DOWN, 23);}' unless defined(&SSCOP_DATA_REQ);
	eval 'sub SSCOP_DATA_IND () { &STKCMD( &SAP_SSCOP,  &STKCMD_UP, 24);}' unless defined(&SSCOP_DATA_IND);
	eval 'sub SSCOP_RESYNC_REQ () { &STKCMD( &SAP_SSCOP,  &STKCMD_DOWN, 25);}' unless defined(&SSCOP_RESYNC_REQ);
	eval 'sub SSCOP_RESYNC_IND () { &STKCMD( &SAP_SSCOP,  &STKCMD_UP, 26);}' unless defined(&SSCOP_RESYNC_IND);
	eval 'sub SSCOP_RESYNC_RSP () { &STKCMD( &SAP_SSCOP,  &STKCMD_DOWN, 27);}' unless defined(&SSCOP_RESYNC_RSP);
	eval 'sub SSCOP_RESYNC_CNF () { &STKCMD( &SAP_SSCOP,  &STKCMD_UP, 28);}' unless defined(&SSCOP_RESYNC_CNF);
	eval 'sub SSCOP_RECOVER_IND () { &STKCMD( &SAP_SSCOP,  &STKCMD_UP, 29);}' unless defined(&SSCOP_RECOVER_IND);
	eval 'sub SSCOP_RECOVER_RSP () { &STKCMD( &SAP_SSCOP,  &STKCMD_DOWN, 30);}' unless defined(&SSCOP_RECOVER_RSP);
	eval 'sub SSCOP_UNITDATA_REQ () { &STKCMD( &SAP_SSCOP,  &STKCMD_DOWN, 31);}' unless defined(&SSCOP_UNITDATA_REQ);
	eval 'sub SSCOP_UNITDATA_IND () { &STKCMD( &SAP_SSCOP,  &STKCMD_UP, 32);}' unless defined(&SSCOP_UNITDATA_IND);
	eval 'sub SSCOP_RETRIEVE_REQ () { &STKCMD( &SAP_SSCOP,  &STKCMD_DOWN, 33);}' unless defined(&SSCOP_RETRIEVE_REQ);
	eval 'sub SSCOP_RETRIEVE_IND () { &STKCMD( &SAP_SSCOP,  &STKCMD_UP, 34);}' unless defined(&SSCOP_RETRIEVE_IND);
	eval 'sub SSCOP_RETRIEVECMP_IND () { &STKCMD( &SAP_SSCOP,  &STKCMD_UP, 35);}' unless defined(&SSCOP_RETRIEVECMP_IND);
	eval 'sub SSCF_UNI_INIT () { &STKCMD( &SAP_SSCF_UNI,  &STKCMD_DOWN,  &CCV_INIT);}' unless defined(&SSCF_UNI_INIT);
	eval 'sub SSCF_UNI_TERM () { &STKCMD( &SAP_SSCF_UNI,  &STKCMD_DOWN,  &CCV_TERM);}' unless defined(&SSCF_UNI_TERM);
	eval 'sub SSCF_UNI_ESTABLISH_REQ () { &STKCMD( &SAP_SSCF_UNI,  &STKCMD_DOWN, 16);}' unless defined(&SSCF_UNI_ESTABLISH_REQ);
	eval 'sub SSCF_UNI_ESTABLISH_IND () { &STKCMD( &SAP_SSCF_UNI,  &STKCMD_UP, 17);}' unless defined(&SSCF_UNI_ESTABLISH_IND);
	eval 'sub SSCF_UNI_ESTABLISH_CNF () { &STKCMD( &SAP_SSCF_UNI,  &STKCMD_UP, 18);}' unless defined(&SSCF_UNI_ESTABLISH_CNF);
	eval 'sub SSCF_UNI_RELEASE_REQ () { &STKCMD( &SAP_SSCF_UNI,  &STKCMD_DOWN, 19);}' unless defined(&SSCF_UNI_RELEASE_REQ);
	eval 'sub SSCF_UNI_RELEASE_IND () { &STKCMD( &SAP_SSCF_UNI,  &STKCMD_UP, 20);}' unless defined(&SSCF_UNI_RELEASE_IND);
	eval 'sub SSCF_UNI_RELEASE_CNF () { &STKCMD( &SAP_SSCF_UNI,  &STKCMD_UP, 21);}' unless defined(&SSCF_UNI_RELEASE_CNF);
	eval 'sub SSCF_UNI_DATA_REQ () { &STKCMD( &SAP_SSCF_UNI,  &STKCMD_DOWN, 22);}' unless defined(&SSCF_UNI_DATA_REQ);
	eval 'sub SSCF_UNI_DATA_IND () { &STKCMD( &SAP_SSCF_UNI,  &STKCMD_UP, 23);}' unless defined(&SSCF_UNI_DATA_IND);
	eval 'sub SSCF_UNI_UNITDATA_REQ () { &STKCMD( &SAP_SSCF_UNI,  &STKCMD_DOWN, 24);}' unless defined(&SSCF_UNI_UNITDATA_REQ);
	eval 'sub SSCF_UNI_UNITDATA_IND () { &STKCMD( &SAP_SSCF_UNI,  &STKCMD_UP, 25);}' unless defined(&SSCF_UNI_UNITDATA_IND);
	eval 'sub STACK_CALL {
	    local($cmd, $fn, $tok, $cvp, $a1, $a2, $ret) = @_;
    	    eval q({  &if (($cmd) &  &STKCMD_UP) {  &if (($cvp)-> &cvc_downcnt) { ($ret) =  &atm_stack_enq(($cmd), ($fn), ($tok), ($cvp), ($a1), ($a2)); }  &else { ($cvp)-> &cvc_upcnt++; (*$fn)($cmd, $tok, $a1, $a2); ($cvp)-> &cvc_upcnt--; ($ret) = 0; } }  &else {  &if (($cvp)-> &cvc_upcnt) { ($ret) =  &atm_stack_enq(($cmd), ($fn), ($tok), ($cvp), ($a1), ($a2)); }  &else { ($cvp)-> &cvc_downcnt++; (*$fn)($cmd, $tok, $a1, $a2); ($cvp)-> &cvc_downcnt--; ($ret) = 0; } } });
	}' unless defined(&STACK_CALL);
	eval 'sub STACK_DRAIN () {
	    eval q({  &if  &atm_stack_drain(); });
	}' unless defined(&STACK_DRAIN);
    }
}
1;
