require '_h2ph_pre.ph';

unless(defined(&_NETGRAPH_PPPOE_H_)) {
    eval 'sub _NETGRAPH_PPPOE_H_ () {1;}' unless defined(&_NETGRAPH_PPPOE_H_);
    eval 'sub NG_PPPOE_NODE_TYPE () {"pppoe";}' unless defined(&NG_PPPOE_NODE_TYPE);
    eval 'sub NGM_PPPOE_COOKIE () {939032003;}' unless defined(&NGM_PPPOE_COOKIE);
    eval 'sub PPPOE_NUM_SESSIONS () {16;}' unless defined(&PPPOE_NUM_SESSIONS);
    eval 'sub PPPOE_SERVICE_NAME_SIZE () {64;}' unless defined(&PPPOE_SERVICE_NAME_SIZE);
    eval 'sub NG_PPPOE_HOOK_ETHERNET () {"ethernet";}' unless defined(&NG_PPPOE_HOOK_ETHERNET);
    eval 'sub NG_PPPOE_HOOK_PADI () {"PADI";}' unless defined(&NG_PPPOE_HOOK_PADI);
    eval 'sub NG_PPPOE_HOOK_S_LEADIN () {"service";}' unless defined(&NG_PPPOE_HOOK_S_LEADIN);
    eval 'sub NG_PPPOE_HOOK_C_LEADIN () {"client";}' unless defined(&NG_PPPOE_HOOK_C_LEADIN);
    eval 'sub NG_PPPOE_HOOK_DEBUG () {"debug";}' unless defined(&NG_PPPOE_HOOK_DEBUG);
    eval("sub NGM_PPPOE_SET_FLAG () { 1; }") unless defined(&NGM_PPPOE_SET_FLAG);
    eval("sub NGM_PPPOE_CONNECT () { 2; }") unless defined(&NGM_PPPOE_CONNECT);
    eval("sub NGM_PPPOE_LISTEN () { 3; }") unless defined(&NGM_PPPOE_LISTEN);
    eval("sub NGM_PPPOE_OFFER () { 4; }") unless defined(&NGM_PPPOE_OFFER);
    eval("sub NGM_PPPOE_SUCCESS () { 5; }") unless defined(&NGM_PPPOE_SUCCESS);
    eval("sub NGM_PPPOE_FAIL () { 6; }") unless defined(&NGM_PPPOE_FAIL);
    eval("sub NGM_PPPOE_CLOSE () { 7; }") unless defined(&NGM_PPPOE_CLOSE);
    eval("sub NGM_PPPOE_GET_STATUS () { 8; }") unless defined(&NGM_PPPOE_GET_STATUS);
    eval 'sub PPPOE_TIMEOUT_LIMIT () {64;}' unless defined(&PPPOE_TIMEOUT_LIMIT);
    eval 'sub PPPOE_OFFER_TIMEOUT () {16;}' unless defined(&PPPOE_OFFER_TIMEOUT);
    eval 'sub PPPOE_INITIAL_TIMEOUT () {2;}' unless defined(&PPPOE_INITIAL_TIMEOUT);
    eval 'sub PADI_CODE () {0x09;}' unless defined(&PADI_CODE);
    eval 'sub PADO_CODE () {0x07;}' unless defined(&PADO_CODE);
    eval 'sub PADR_CODE () {0x19;}' unless defined(&PADR_CODE);
    eval 'sub PADS_CODE () {0x65;}' unless defined(&PADS_CODE);
    eval 'sub PADT_CODE () {0xa7;}' unless defined(&PADT_CODE);
    if((defined(&BYTE_ORDER) ? &BYTE_ORDER : 0) == (defined(&BIG_ENDIAN) ? &BIG_ENDIAN : 0)) {
	eval 'sub PTT_EOL () {(0x0000);}' unless defined(&PTT_EOL);
	eval 'sub PTT_SRV_NAME () {(0x0101);}' unless defined(&PTT_SRV_NAME);
	eval 'sub PTT_AC_NAME () {(0x0102);}' unless defined(&PTT_AC_NAME);
	eval 'sub PTT_HOST_UNIQ () {(0x0103);}' unless defined(&PTT_HOST_UNIQ);
	eval 'sub PTT_AC_COOKIE () {(0x0104);}' unless defined(&PTT_AC_COOKIE);
	eval 'sub PTT_VENDOR () {(0x0105);}' unless defined(&PTT_VENDOR);
	eval 'sub PTT_RELAY_SID () {(0x0106);}' unless defined(&PTT_RELAY_SID);
	eval 'sub PTT_SRV_ERR () {(0x0201);}' unless defined(&PTT_SRV_ERR);
	eval 'sub PTT_SYS_ERR () {(0x0202);}' unless defined(&PTT_SYS_ERR);
	eval 'sub PTT_GEN_ERR () {(0x0203);}' unless defined(&PTT_GEN_ERR);
	eval 'sub ETHERTYPE_PPPOE_DISC () {0x8863;}' unless defined(&ETHERTYPE_PPPOE_DISC);
	eval 'sub ETHERTYPE_PPPOE_SESS () {0x8864;}' unless defined(&ETHERTYPE_PPPOE_SESS);
    } else {
	eval 'sub PTT_EOL () {(0x0000);}' unless defined(&PTT_EOL);
	eval 'sub PTT_SRV_NAME () {(0x0101);}' unless defined(&PTT_SRV_NAME);
	eval 'sub PTT_AC_NAME () {(0x0201);}' unless defined(&PTT_AC_NAME);
	eval 'sub PTT_HOST_UNIQ () {(0x0301);}' unless defined(&PTT_HOST_UNIQ);
	eval 'sub PTT_AC_COOKIE () {(0x0401);}' unless defined(&PTT_AC_COOKIE);
	eval 'sub PTT_VENDOR () {(0x0501);}' unless defined(&PTT_VENDOR);
	eval 'sub PTT_RELAY_SID () {(0x0601);}' unless defined(&PTT_RELAY_SID);
	eval 'sub PTT_SRV_ERR () {(0x0102);}' unless defined(&PTT_SRV_ERR);
	eval 'sub PTT_SYS_ERR () {(0x0202);}' unless defined(&PTT_SYS_ERR);
	eval 'sub PTT_GEN_ERR () {(0x0302);}' unless defined(&PTT_GEN_ERR);
	eval 'sub ETHERTYPE_PPPOE_DISC () {0x6388;}' unless defined(&ETHERTYPE_PPPOE_DISC);
	eval 'sub ETHERTYPE_PPPOE_SESS () {0x6488;}' unless defined(&ETHERTYPE_PPPOE_SESS);
    }
    eval 'sub TAGI_SVC () {0;}' unless defined(&TAGI_SVC);
    eval 'sub TAGI_HUNIQ () {1;}' unless defined(&TAGI_HUNIQ);
    eval 'sub TAGO_ACNAME () {0;}' unless defined(&TAGO_ACNAME);
    eval 'sub TAGO_SVC () {1;}' unless defined(&TAGO_SVC);
    eval 'sub TAGO_COOKIE () {2;}' unless defined(&TAGO_COOKIE);
    eval 'sub TAGO_HUNIQ () {3;}' unless defined(&TAGO_HUNIQ);
    eval 'sub TAGR_SVC () {0;}' unless defined(&TAGR_SVC);
    eval 'sub TAGR_HUNIQ () {1;}' unless defined(&TAGR_HUNIQ);
    eval 'sub TAGR_COOKIE () {2;}' unless defined(&TAGR_COOKIE);
    eval 'sub TAGS_ACNAME () {0;}' unless defined(&TAGS_ACNAME);
    eval 'sub TAGS_SVC () {1;}' unless defined(&TAGS_SVC);
    eval 'sub TAGS_COOKIE () {2;}' unless defined(&TAGS_COOKIE);
    eval 'sub TAGS_HUNIQ () {3;}' unless defined(&TAGS_HUNIQ);
}
1;
