require '_h2ph_pre.ph';

unless(defined(&_IP_FW_H)) {
    eval 'sub _IP_FW_H () {1;}' unless defined(&_IP_FW_H);
    require 'sys/queue.ph';
    eval 'sub FW_IFNLEN () {10;}' unless defined(&FW_IFNLEN);
    eval 'sub IP_FW_MAX_PORTS () {10;}' unless defined(&IP_FW_MAX_PORTS);
    eval 'sub IP_FW_ICMPTYPES_MAX () {128;}' unless defined(&IP_FW_ICMPTYPES_MAX);
    eval 'sub IP_FW_ICMPTYPES_DIM () {( &IP_FW_ICMPTYPES_MAX / ($sizeof{\'unsigned\'} * 8));}' unless defined(&IP_FW_ICMPTYPES_DIM);
    eval 'sub IP_FW_GETNSRCP {
        local($rule) = @_;
	    eval q((($rule)-> &fw_nports & 0x0f));
    }' unless defined(&IP_FW_GETNSRCP);
    eval 'sub IP_FW_SETNSRCP {
        local($rule, $n) = @_;
	    eval q( &do { ($rule)-> &fw_nports &= ~0x0f; ($rule)-> &fw_nports |= ($n); }  &while (0));
    }' unless defined(&IP_FW_SETNSRCP);
    eval 'sub IP_FW_GETNDSTP {
        local($rule) = @_;
	    eval q((($rule)-> &fw_nports >> 4));
    }' unless defined(&IP_FW_GETNDSTP);
    eval 'sub IP_FW_SETNDSTP {
        local($rule, $n) = @_;
	    eval q( &do { ($rule)-> &fw_nports &= ~0xf0; ($rule)-> &fw_nports |= ($n) << 4; }  &while (0));
    }' unless defined(&IP_FW_SETNDSTP);
    eval 'sub fw_divert_port () { ($fw_un->{fu_divert_port});}' unless defined(&fw_divert_port);
    eval 'sub fw_skipto_rule () { ($fw_un->{fu_skipto_rule});}' unless defined(&fw_skipto_rule);
    eval 'sub fw_reject_code () { ($fw_un->{fu_reject_code});}' unless defined(&fw_reject_code);
    eval 'sub fw_pipe_nr () { ($fw_un->{fu_pipe_nr});}' unless defined(&fw_pipe_nr);
    eval 'sub fw_fwd_ip () { ($fw_un->{fu_fwd_ip});}' unless defined(&fw_fwd_ip);
    eval 'sub IP_FW_F_COMMAND () {0x000000ff;}' unless defined(&IP_FW_F_COMMAND);
    eval 'sub IP_FW_F_DENY () {0x00000000;}' unless defined(&IP_FW_F_DENY);
    eval 'sub IP_FW_F_REJECT () {0x00000001;}' unless defined(&IP_FW_F_REJECT);
    eval 'sub IP_FW_F_ACCEPT () {0x00000002;}' unless defined(&IP_FW_F_ACCEPT);
    eval 'sub IP_FW_F_COUNT () {0x00000003;}' unless defined(&IP_FW_F_COUNT);
    eval 'sub IP_FW_F_DIVERT () {0x00000004;}' unless defined(&IP_FW_F_DIVERT);
    eval 'sub IP_FW_F_TEE () {0x00000005;}' unless defined(&IP_FW_F_TEE);
    eval 'sub IP_FW_F_SKIPTO () {0x00000006;}' unless defined(&IP_FW_F_SKIPTO);
    eval 'sub IP_FW_F_FWD () {0x00000007;}' unless defined(&IP_FW_F_FWD);
    eval 'sub IP_FW_F_PIPE () {0x00000008;}' unless defined(&IP_FW_F_PIPE);
    eval 'sub IP_FW_F_IN () {0x00000100;}' unless defined(&IP_FW_F_IN);
    eval 'sub IP_FW_F_OUT () {0x00000200;}' unless defined(&IP_FW_F_OUT);
    eval 'sub IP_FW_F_IIFACE () {0x00000400;}' unless defined(&IP_FW_F_IIFACE);
    eval 'sub IP_FW_F_OIFACE () {0x00000800;}' unless defined(&IP_FW_F_OIFACE);
    eval 'sub IP_FW_F_PRN () {0x00001000;}' unless defined(&IP_FW_F_PRN);
    eval 'sub IP_FW_F_SRNG () {0x00002000;}' unless defined(&IP_FW_F_SRNG);
    eval 'sub IP_FW_F_DRNG () {0x00004000;}' unless defined(&IP_FW_F_DRNG);
    eval 'sub IP_FW_F_FRAG () {0x00008000;}' unless defined(&IP_FW_F_FRAG);
    eval 'sub IP_FW_F_IIFNAME () {0x00010000;}' unless defined(&IP_FW_F_IIFNAME);
    eval 'sub IP_FW_F_OIFNAME () {0x00020000;}' unless defined(&IP_FW_F_OIFNAME);
    eval 'sub IP_FW_F_INVSRC () {0x00040000;}' unless defined(&IP_FW_F_INVSRC);
    eval 'sub IP_FW_F_INVDST () {0x00080000;}' unless defined(&IP_FW_F_INVDST);
    eval 'sub IP_FW_F_ICMPBIT () {0x00100000;}' unless defined(&IP_FW_F_ICMPBIT);
    eval 'sub IP_FW_F_UID () {0x00200000;}' unless defined(&IP_FW_F_UID);
    eval 'sub IP_FW_F_GID () {0x00400000;}' unless defined(&IP_FW_F_GID);
    eval 'sub IP_FW_F_RND_MATCH () {0x00800000;}' unless defined(&IP_FW_F_RND_MATCH);
    eval 'sub IP_FW_F_MASK () {0x00ffffff;}' unless defined(&IP_FW_F_MASK);
    eval 'sub IF_FW_F_VIAHACK () {( &IP_FW_F_IN| &IP_FW_F_OUT| &IP_FW_F_IIFACE| &IP_FW_F_OIFACE);}' unless defined(&IF_FW_F_VIAHACK);
    eval 'sub IP_FW_REJECT_RST () {0x0100;}' unless defined(&IP_FW_REJECT_RST);
    eval 'sub IP_FW_IPOPT_LSRR () {0x01;}' unless defined(&IP_FW_IPOPT_LSRR);
    eval 'sub IP_FW_IPOPT_SSRR () {0x02;}' unless defined(&IP_FW_IPOPT_SSRR);
    eval 'sub IP_FW_IPOPT_RR () {0x04;}' unless defined(&IP_FW_IPOPT_RR);
    eval 'sub IP_FW_IPOPT_TS () {0x08;}' unless defined(&IP_FW_IPOPT_TS);
    eval 'sub IP_FW_TCPF_FIN () { &TH_FIN;}' unless defined(&IP_FW_TCPF_FIN);
    eval 'sub IP_FW_TCPF_SYN () { &TH_SYN;}' unless defined(&IP_FW_TCPF_SYN);
    eval 'sub IP_FW_TCPF_RST () { &TH_RST;}' unless defined(&IP_FW_TCPF_RST);
    eval 'sub IP_FW_TCPF_PSH () { &TH_PUSH;}' unless defined(&IP_FW_TCPF_PSH);
    eval 'sub IP_FW_TCPF_ACK () { &TH_ACK;}' unless defined(&IP_FW_TCPF_ACK);
    eval 'sub IP_FW_TCPF_URG () { &TH_URG;}' unless defined(&IP_FW_TCPF_URG);
    eval 'sub IP_FW_TCPF_ESTAB () {0x40;}' unless defined(&IP_FW_TCPF_ESTAB);
    if(defined(&KERNEL)) {
	eval 'sub IP_NAT_IN () {0x00000001;}' unless defined(&IP_NAT_IN);
	eval 'sub IP_NAT_OUT () {0x00000002;}' unless defined(&IP_NAT_OUT);
    }
}
1;
