require '_h2ph_pre.ph';

unless(defined(&_NETINET_TCP_VAR_H_)) {
    eval 'sub _NETINET_TCP_VAR_H_ () {1;}' unless defined(&_NETINET_TCP_VAR_H_);
    eval 'sub TF_ACKNOW () {0x00001;}' unless defined(&TF_ACKNOW);
    eval 'sub TF_DELACK () {0x00002;}' unless defined(&TF_DELACK);
    eval 'sub TF_NODELAY () {0x00004;}' unless defined(&TF_NODELAY);
    eval 'sub TF_NOOPT () {0x00008;}' unless defined(&TF_NOOPT);
    eval 'sub TF_SENTFIN () {0x00010;}' unless defined(&TF_SENTFIN);
    eval 'sub TF_REQ_SCALE () {0x00020;}' unless defined(&TF_REQ_SCALE);
    eval 'sub TF_RCVD_SCALE () {0x00040;}' unless defined(&TF_RCVD_SCALE);
    eval 'sub TF_REQ_TSTMP () {0x00080;}' unless defined(&TF_REQ_TSTMP);
    eval 'sub TF_RCVD_TSTMP () {0x00100;}' unless defined(&TF_RCVD_TSTMP);
    eval 'sub TF_SACK_PERMIT () {0x00200;}' unless defined(&TF_SACK_PERMIT);
    eval 'sub TF_NEEDSYN () {0x00400;}' unless defined(&TF_NEEDSYN);
    eval 'sub TF_NEEDFIN () {0x00800;}' unless defined(&TF_NEEDFIN);
    eval 'sub TF_NOPUSH () {0x01000;}' unless defined(&TF_NOPUSH);
    eval 'sub TF_REQ_CC () {0x02000;}' unless defined(&TF_REQ_CC);
    eval 'sub TF_RCVD_CC () {0x04000;}' unless defined(&TF_RCVD_CC);
    eval 'sub TF_SENDCCNEW () {0x08000;}' unless defined(&TF_SENDCCNEW);
    eval 'sub TF_MORETOCOME () {0x10000;}' unless defined(&TF_MORETOCOME);
    eval 'sub TCPOOB_HAVEDATA () {0x01;}' unless defined(&TCPOOB_HAVEDATA);
    eval 'sub TCPOOB_HADDATA () {0x02;}' unless defined(&TCPOOB_HADDATA);
    eval 'sub TOF_TS () {0x0001;}' unless defined(&TOF_TS);
    eval 'sub TOF_CC () {0x0002;}' unless defined(&TOF_CC);
    eval 'sub TOF_CCNEW () {0x0004;}' unless defined(&TOF_CCNEW);
    eval 'sub TOF_CCECHO () {0x0008;}' unless defined(&TOF_CCECHO);
    if(defined(&notyet)) {
	eval 'sub TAOF_DONT () {0x0001;}' unless defined(&TAOF_DONT);
	eval 'sub TAOF_OK () {0x0002;}' unless defined(&TAOF_OK);
	eval 'sub TAOF_UNDEF () {0;}' unless defined(&TAOF_UNDEF);
    }
    eval 'sub rmx_taop {
        local($r) = @_;
	    eval q((($r). &rmx_filler));
    }' unless defined(&rmx_taop);
    eval 'sub intotcpcb {
        local($ip) = @_;
	    eval q((($ip)-> &inp_ppcb));
    }' unless defined(&intotcpcb);
    eval 'sub sototcpcb {
        local($so) = @_;
	    eval q(( &intotcpcb( &sotoinpcb($so))));
    }' unless defined(&sototcpcb);
    eval 'sub TCP_RTT_SCALE () {32;}' unless defined(&TCP_RTT_SCALE);
    eval 'sub TCP_RTT_SHIFT () {5;}' unless defined(&TCP_RTT_SHIFT);
    eval 'sub TCP_RTTVAR_SCALE () {16;}' unless defined(&TCP_RTTVAR_SCALE);
    eval 'sub TCP_RTTVAR_SHIFT () {4;}' unless defined(&TCP_RTTVAR_SHIFT);
    eval 'sub TCP_DELTA_SHIFT () {2;}' unless defined(&TCP_DELTA_SHIFT);
    eval 'sub TCP_REXMTVAL {
        local($tp) = @_;
	    eval q( &max(($tp)-> &t_rttmin, ((($tp)-> &t_srtt >> ( &TCP_RTT_SHIFT -  &TCP_DELTA_SHIFT)) + ($tp)-> &t_rttvar) >>  &TCP_DELTA_SHIFT));
    }' unless defined(&TCP_REXMTVAL);
    if(defined( &_NETINET_IN_PCB_H_)  && defined( &_SYS_SOCKETVAR_H_)) {
    }
    eval 'sub TCPCTL_DO_RFC1323 () {1;}' unless defined(&TCPCTL_DO_RFC1323);
    eval 'sub TCPCTL_DO_RFC1644 () {2;}' unless defined(&TCPCTL_DO_RFC1644);
    eval 'sub TCPCTL_MSSDFLT () {3;}' unless defined(&TCPCTL_MSSDFLT);
    eval 'sub TCPCTL_STATS () {4;}' unless defined(&TCPCTL_STATS);
    eval 'sub TCPCTL_RTTDFLT () {5;}' unless defined(&TCPCTL_RTTDFLT);
    eval 'sub TCPCTL_KEEPIDLE () {6;}' unless defined(&TCPCTL_KEEPIDLE);
    eval 'sub TCPCTL_KEEPINTVL () {7;}' unless defined(&TCPCTL_KEEPINTVL);
    eval 'sub TCPCTL_SENDSPACE () {8;}' unless defined(&TCPCTL_SENDSPACE);
    eval 'sub TCPCTL_RECVSPACE () {9;}' unless defined(&TCPCTL_RECVSPACE);
    eval 'sub TCPCTL_KEEPINIT () {10;}' unless defined(&TCPCTL_KEEPINIT);
    eval 'sub TCPCTL_PCBLIST () {11;}' unless defined(&TCPCTL_PCBLIST);
    eval 'sub TCPCTL_MAXID () {12;}' unless defined(&TCPCTL_MAXID);
    eval 'sub TCPCTL_NAMES () {{ { 0, 0}, { "rfc1323",  &CTLTYPE_INT }, { "rfc1644",  &CTLTYPE_INT }, { "mssdflt",  &CTLTYPE_INT }, { "stats",  &CTLTYPE_STRUCT }, { "rttdflt",  &CTLTYPE_INT }, { "keepidle",  &CTLTYPE_INT }, { "keepintvl",  &CTLTYPE_INT }, { "sendspace",  &CTLTYPE_INT }, { "recvspace",  &CTLTYPE_INT }, { "keepinit",  &CTLTYPE_INT }, { "pcblist",  &CTLTYPE_STRUCT }, };}' unless defined(&TCPCTL_NAMES);
    if(defined(&KERNEL)) {
    }
}
1;
