require '_h2ph_pre.ph';

unless(defined(&_NETNS_NS_H_)) {
    eval 'sub _NETNS_NS_H_ () {1;}' unless defined(&_NETNS_NS_H_);
    eval 'sub NSPROTO_RI () {1;}' unless defined(&NSPROTO_RI);
    eval 'sub NSPROTO_ECHO () {2;}' unless defined(&NSPROTO_ECHO);
    eval 'sub NSPROTO_ERROR () {3;}' unless defined(&NSPROTO_ERROR);
    eval 'sub NSPROTO_PE () {4;}' unless defined(&NSPROTO_PE);
    eval 'sub NSPROTO_SPP () {5;}' unless defined(&NSPROTO_SPP);
    eval 'sub NSPROTO_RAW () {255;}' unless defined(&NSPROTO_RAW);
    eval 'sub NSPROTO_MAX () {256;}' unless defined(&NSPROTO_MAX);
    eval 'sub NSPORT_RI () {1;}' unless defined(&NSPORT_RI);
    eval 'sub NSPORT_ECHO () {2;}' unless defined(&NSPORT_ECHO);
    eval 'sub NSPORT_RE () {3;}' unless defined(&NSPORT_RE);
    eval 'sub NSPORT_RESERVED () {3000;}' unless defined(&NSPORT_RESERVED);
    eval 'sub NS_FORWARDING () {0x1;}' unless defined(&NS_FORWARDING);
    eval 'sub NS_ROUTETOIF () {0x10;}' unless defined(&NS_ROUTETOIF);
    eval 'sub NS_ALLOWBROADCAST () { &SO_BROADCAST;}' unless defined(&NS_ALLOWBROADCAST);
    eval 'sub NS_MAXHOPS () {15;}' unless defined(&NS_MAXHOPS);
    eval 'sub SO_HEADERS_ON_INPUT () {1;}' unless defined(&SO_HEADERS_ON_INPUT);
    eval 'sub SO_HEADERS_ON_OUTPUT () {2;}' unless defined(&SO_HEADERS_ON_OUTPUT);
    eval 'sub SO_DEFAULT_HEADERS () {3;}' unless defined(&SO_DEFAULT_HEADERS);
    eval 'sub SO_LAST_HEADER () {4;}' unless defined(&SO_LAST_HEADER);
    eval 'sub SO_NSIP_ROUTE () {5;}' unless defined(&SO_NSIP_ROUTE);
    eval 'sub SO_SEQNO () {6;}' unless defined(&SO_SEQNO);
    eval 'sub SO_ALL_PACKETS () {7;}' unless defined(&SO_ALL_PACKETS);
    eval 'sub SO_MTU () {8;}' unless defined(&SO_MTU);
    eval 'sub sns_port () { ($sns_addr->{x_port});}' unless defined(&sns_port);
    if(defined(&vax)) {
	eval 'sub ns_netof {
	    local($a) = @_;
    	    eval q((* & (($a). &x_net)));
	}' unless defined(&ns_netof);
    }
    eval 'sub ns_neteqnn {
        local($a,$b) = @_;
	    eval q(((($a). $s_net[0]==($b). $s_net[0])  && (($a). $s_net[1]==($b). $s_net[1])));
    }' unless defined(&ns_neteqnn);
    eval 'sub ns_neteq {
        local($a,$b) = @_;
	    eval q( &ns_neteqnn(($a). &x_net, ($b). &x_net));
    }' unless defined(&ns_neteq);
    eval 'sub satons_addr {
        local($sa) = @_;
	    eval q(((($sa))-> &sns_addr));
    }' unless defined(&satons_addr);
    eval 'sub ns_hosteqnh {
        local($s,$t) = @_;
	    eval q((($s). $s_host[0] == ($t). $s_host[0]  && ($s). $s_host[1] == ($t). $s_host[1]  && ($s). $s_host[2] == ($t). $s_host[2]));
    }' unless defined(&ns_hosteqnh);
    eval 'sub ns_hosteq {
        local($s,$t) = @_;
	    eval q(( &ns_hosteqnh(($s). &x_host,($t). &x_host)));
    }' unless defined(&ns_hosteq);
    eval 'sub ns_nullhost {
        local($x) = @_;
	    eval q(((($x). ($x_host->{s_host[0]})==0)  && (($x). ($x_host->{s_host[1]})==0)  && (($x). ($x_host->{s_host[2]})==0)));
    }' unless defined(&ns_nullhost);
    if(defined(&KERNEL)) {
    } else {
	require 'sys/cdefs.ph';
    }
}
1;
