require '_h2ph_pre.ph';

unless(defined(&PCIC_I82365)) {
    sub PCIC_I82365 () {	0;}
}
unless(defined(&PCIC_IBM)) {
    sub PCIC_IBM () {	1;}
}
unless(defined(&PCIC_VLSI)) {
    sub PCIC_VLSI () {	2;}
}
unless(defined(&PCIC_PD672X)) {
    sub PCIC_PD672X () {	3;}
}
unless(defined(&PCIC_PD6710)) {
    sub PCIC_PD6710 () {	4;}
}
unless(defined(&PCIC_CL6729)) {
    sub PCIC_CL6729 () {	5;}
}
unless(defined(&PCIC_VG365)) {
    sub PCIC_VG365 () {	6;}
}
unless(defined(&PCIC_VG465)) {
    sub PCIC_VG465 () {	7;}
}
unless(defined(&PCIC_VG468)) {
    sub PCIC_VG468 () {	8;}
}
unless(defined(&PCIC_VG469)) {
    sub PCIC_VG469 () {	9;}
}
unless(defined(&PCIC_RF5C396)) {
    sub PCIC_RF5C396 () {	10;}
}
unless(defined(&PCIC_IBM_KING)) {
    sub PCIC_IBM_KING () {	11;}
}
unless(defined(&PCIC_PC98)) {
    sub PCIC_PC98 () {	12;}
}
unless(defined(&PCIC_TI1130)) {
    sub PCIC_TI1130 () {	13;}
}
unless(defined(&PCIC_INDEX_0)) {
    sub PCIC_INDEX_0 () {	0x3e0;}
}
unless(defined(&PCIC_DATA_0)) {
    sub PCIC_DATA_0 () {	( &PCIC_INDEX_0 + 1);}
}
unless(defined(&PCIC_INDEX_1)) {
    sub PCIC_INDEX_1 () {	( &PCIC_INDEX_0 + 2);}
}
unless(defined(&PCIC_DATA_1)) {
    sub PCIC_DATA_1 () {	( &PCIC_INDEX_1 + 1);}
}
unless(defined(&PCIC_ID_REV)) {
    sub PCIC_ID_REV () {	0x00;}
}
unless(defined(&PCIC_STATUS)) {
    sub PCIC_STATUS () {	0x01;}
}
unless(defined(&PCIC_POWER)) {
    sub PCIC_POWER () {	0x02;}
}
unless(defined(&PCIC_INT_GEN)) {
    sub PCIC_INT_GEN () {	0x03;}
}
unless(defined(&PCIC_STAT_CHG)) {
    sub PCIC_STAT_CHG () {	0x04;}
}
unless(defined(&PCIC_STAT_INT)) {
    sub PCIC_STAT_INT () {	0x05;}
}
unless(defined(&PCIC_ADDRWINE)) {
    sub PCIC_ADDRWINE () {	0x06;}
}
unless(defined(&PCIC_IOCTL)) {
    sub PCIC_IOCTL () {	0x07;}
}
unless(defined(&PCIC_IO0)) {
    sub PCIC_IO0 () {	0x08;}
}
unless(defined(&PCIC_IO1)) {
    sub PCIC_IO1 () {	0x0c;}
}
unless(defined(&PCIC_MEMBASE)) {
    sub PCIC_MEMBASE () {	0x10;}
}
unless(defined(&PCIC_CDGC)) {
    sub PCIC_CDGC () {	0x16;}
}
unless(defined(&PCIC_MISC1)) {
    sub PCIC_MISC1 () {	0x16;}
}
unless(defined(&PCIC_GLO_CTRL)) {
    sub PCIC_GLO_CTRL () {	0x1e;}
}
unless(defined(&PCIC_MISC2)) {
    sub PCIC_MISC2 () {	0x1e;}
}
unless(defined(&PCIC_TIME_SETUP0)) {
    sub PCIC_TIME_SETUP0 () {	0x3a;}
}
unless(defined(&PCIC_TIME_CMD0)) {
    sub PCIC_TIME_CMD0 () {	0x3b;}
}
unless(defined(&PCIC_TIME_RECOV0)) {
    sub PCIC_TIME_RECOV0 () {	0x3c;}
}
unless(defined(&PCIC_TIME_SETUP1)) {
    sub PCIC_TIME_SETUP1 () {	0x3d;}
}
unless(defined(&PCIC_TIME_CMD1)) {
    sub PCIC_TIME_CMD1 () {	0x3e;}
}
unless(defined(&PCIC_TIME_RECOV1)) {
    sub PCIC_TIME_RECOV1 () {	0x3f;}
}
unless(defined(&PCIC_SLOT_SIZE)) {
    sub PCIC_SLOT_SIZE () {	0x40;}
}
unless(defined(&PCIC_INTEL0)) {
    sub PCIC_INTEL0 () {	0x82;}
}
unless(defined(&PCIC_INTEL1)) {
    sub PCIC_INTEL1 () {	0x83;}
}
unless(defined(&PCIC_IBM1)) {
    sub PCIC_IBM1 () {	0x88;}
}
unless(defined(&PCIC_IBM2)) {
    sub PCIC_IBM2 () {	0x89;}
}
unless(defined(&PCIC_IBM3)) {
    sub PCIC_IBM3 () {	0x8a;}
}
unless(defined(&PCIC_VPPV)) {
    sub PCIC_VPPV () {	0x80;}
}
unless(defined(&PCIC_POW)) {
    sub PCIC_POW () {	0x40;}
}
unless(defined(&PCIC_READY)) {
    sub PCIC_READY () {	0x20;}
}
unless(defined(&PCIC_MWP)) {
    sub PCIC_MWP () {	0x10;}
}
unless(defined(&PCIC_CD)) {
    sub PCIC_CD () {	0x0c;}
}
unless(defined(&PCIC_BVD)) {
    sub PCIC_BVD () {	0x03;}
}
unless(defined(&PCIC_OUTENA)) {
    sub PCIC_OUTENA () {	0x80;}
}
unless(defined(&PCIC_DISRST)) {
    sub PCIC_DISRST () {	0x40;}
}
unless(defined(&PCIC_APSENA)) {
    sub PCIC_APSENA () {	0x20;}
}
unless(defined(&PCIC_PCPWRE)) {
    sub PCIC_PCPWRE () {	0x10;}
}
unless(defined(&PCIC_VCC)) {
    sub PCIC_VCC () {	0x18;}
}
unless(defined(&PCIC_VCC_5V)) {
    sub PCIC_VCC_5V () {	0x10;}
}
unless(defined(&PCIC_VCC_3V)) {
    sub PCIC_VCC_3V () {	0x18;}
}
unless(defined(&PCIC_VCC_5V_KING)) {
    sub PCIC_VCC_5V_KING () {	0x14;}
}
unless(defined(&PCIC_VPP)) {
    sub PCIC_VPP () {	0x0c;}
}
unless(defined(&PCIC_VPP_5V)) {
    sub PCIC_VPP_5V () {	0x01;}
}
unless(defined(&PCIC_VPP_12V)) {
    sub PCIC_VPP_12V () {	0x02;}
}
unless(defined(&PCIC_CARDTYPE)) {
    sub PCIC_CARDTYPE () {	0x20;}
}
unless(defined(&PCIC_IOCARD)) {
    sub PCIC_IOCARD () {	0x20;}
}
unless(defined(&PCIC_MEMCARD)) {
    sub PCIC_MEMCARD () {	0x00;}
}
unless(defined(&PCIC_CARDRESET)) {
    sub PCIC_CARDRESET () {	0x40;}
}
unless(defined(&PCIC_INTR_ENA)) {
    sub PCIC_INTR_ENA () {	0x10;}
}
unless(defined(&PCIC_CDTCH)) {
    sub PCIC_CDTCH () {	0x08;}
}
unless(defined(&PCIC_RDYCH)) {
    sub PCIC_RDYCH () {	0x04;}
}
unless(defined(&PCIC_BATWRN)) {
    sub PCIC_BATWRN () {	0x02;}
}
unless(defined(&PCIC_BATDED)) {
    sub PCIC_BATDED () {	0x01;}
}
unless(defined(&PCIC_MEMCS16)) {
    sub PCIC_MEMCS16 () {	0x20;}
}
unless(defined(&PCIC_IO0_EN)) {
    sub PCIC_IO0_EN () {	0x40;}
}
unless(defined(&PCIC_IO1_EN)) {
    sub PCIC_IO1_EN () {	0x80;}
}
unless(defined(&PCIC_IO_16BIT)) {
    sub PCIC_IO_16BIT () {	0x01;}
}
unless(defined(&PCIC_IO_CS16)) {
    sub PCIC_IO_CS16 () {	0x02;}
}
unless(defined(&PCIC_IO_0WS)) {
    sub PCIC_IO_0WS () {	0x04;}
}
unless(defined(&PCIC_IO_WS)) {
    sub PCIC_IO_WS () {	0x08;}
}
unless(defined(&PCIC_MEMSIZE)) {
    sub PCIC_MEMSIZE () {	8;}
}
unless(defined(&PCIC_ZEROWS)) {
    sub PCIC_ZEROWS () {	0x40;}
}
unless(defined(&PCIC_DATA16)) {
    sub PCIC_DATA16 () {	0x80;}
}
unless(defined(&PCIC_MW0)) {
    sub PCIC_MW0 () {	0x40;}
}
unless(defined(&PCIC_MW1)) {
    sub PCIC_MW1 () {	0x80;}
}
unless(defined(&PCIC_REG)) {
    sub PCIC_REG () {	0x40;}
}
unless(defined(&PCIC_WP)) {
    sub PCIC_WP () {	0x80;}
}
unless(defined(&PCIC_16_DL_INH)) {
    sub PCIC_16_DL_INH () {	0x01;}
}
unless(defined(&PCIC_CNFG_RST_EN)) {
    sub PCIC_CNFG_RST_EN () {	0x02;}
}
unless(defined(&PCIC_GPI_EN)) {
    sub PCIC_GPI_EN () {	0x04;}
}
unless(defined(&PCIC_GPI_TRANS)) {
    sub PCIC_GPI_TRANS () {	0x08;}
}
unless(defined(&PCIC_CDRES_EN)) {
    sub PCIC_CDRES_EN () {	0x10;}
}
unless(defined(&PCIC_SW_CD_INT)) {
    sub PCIC_SW_CD_INT () {	0x20;}
}
unless(defined(&PCIC_SPKR_EN)) {
    sub PCIC_SPKR_EN () {	0x10;}
}
unless(defined(&PCIC_PWR_DOWN)) {
    sub PCIC_PWR_DOWN () {	0x01;}
}
unless(defined(&PCIC_LVL_MODE)) {
    sub PCIC_LVL_MODE () {	0x02;}
}
unless(defined(&PCIC_WB_CSCINT)) {
    sub PCIC_WB_CSCINT () {	0x04;}
}
unless(defined(&PCIC_IRQ0_LEVEL)) {
    sub PCIC_IRQ0_LEVEL () {	0x08;}
}
unless(defined(&PCIC_IRQ1_LEVEL)) {
    sub PCIC_IRQ1_LEVEL () {	0x10;}
}
unless(defined(&PCIC_LPDM_EN)) {
    sub PCIC_LPDM_EN () {	0x02;}
}
unless(defined(&PCIC_INT_MASK_ALLOWED)) {
    sub PCIC_INT_MASK_ALLOWED () {	0xdeb8;}
}
unless(defined(&PCIC_IO_WIN)) {
    sub PCIC_IO_WIN () {	2;}
}
unless(defined(&PCIC_MEM_WIN)) {
    sub PCIC_MEM_WIN () {	5;}
}
unless(defined(&PCIC_MAX_SLOTS)) {
    sub PCIC_MAX_SLOTS () {	8;}
}
1;
