require '_h2ph_pre.ph';

unless(defined(&_SYS_DISKSLICE_H_)) {
    eval 'sub _SYS_DISKSLICE_H_ () {1;}' unless defined(&_SYS_DISKSLICE_H_);
    unless(defined(&KERNEL)) {
	require 'sys/types.ph';
    }
    require 'sys/ioccom.ph';
    eval 'sub BASE_SLICE () {2;}' unless defined(&BASE_SLICE);
    eval 'sub COMPATIBILITY_SLICE () {0;}' unless defined(&COMPATIBILITY_SLICE);
    eval 'sub DIOCGSLICEINFO () { &_IOR(ord(\'d\'), 111, \'struct diskslices\');}' unless defined(&DIOCGSLICEINFO);
    eval 'sub DIOCSYNCSLICEINFO () { &_IOW(ord(\'d\'), 112, \'int\');}' unless defined(&DIOCSYNCSLICEINFO);
    eval 'sub MAX_SLICES () {32;}' unless defined(&MAX_SLICES);
    eval 'sub WHOLE_DISK_SLICE () {1;}' unless defined(&WHOLE_DISK_SLICE);
    if(defined(&PC98)) {
    }
    if(defined(&MAXPARTITIONS)) {
	if((defined(&MAXPARTITIONS) ? &MAXPARTITIONS : 0) != 8) {
	    die("inconsistent MAXPARTITIONS");
	}
    } else {
	eval 'sub MAXPARTITIONS () {8;}' unless defined(&MAXPARTITIONS);
    }
    if(defined(&KERNEL)) {
	eval 'sub DSO_NOLABELS () {1;}' unless defined(&DSO_NOLABELS);
	eval 'sub DSO_ONESLICE () {2;}' unless defined(&DSO_ONESLICE);
	eval 'sub dsgetbad {
	    local($dev, $ssp) = @_;
    	    eval q(( ($ssp->{dss_slices[&dkslice(dev)]}->{ds_bad})));
	}' unless defined(&dsgetbad);
	eval 'sub dsgetlabel {
	    local($dev, $ssp) = @_;
    	    eval q(( ($ssp->{dss_slices[&dkslice(dev)]}->{ds_label})));
	}' unless defined(&dsgetlabel);
    }
}
1;
