require '_h2ph_pre.ph';

unless(defined(&_SYS_MMAN_H_)) {
    eval 'sub _SYS_MMAN_H_ () {1;}' unless defined(&_SYS_MMAN_H_);
    require 'sys/_posix.ph';
    eval 'sub PROT_NONE () {0x00;}' unless defined(&PROT_NONE);
    eval 'sub PROT_READ () {0x01;}' unless defined(&PROT_READ);
    eval 'sub PROT_WRITE () {0x02;}' unless defined(&PROT_WRITE);
    eval 'sub PROT_EXEC () {0x04;}' unless defined(&PROT_EXEC);
    eval 'sub MAP_SHARED () {0x0001;}' unless defined(&MAP_SHARED);
    eval 'sub MAP_PRIVATE () {0x0002;}' unless defined(&MAP_PRIVATE);
    eval 'sub MAP_COPY () { &MAP_PRIVATE;}' unless defined(&MAP_COPY);
    eval 'sub MAP_FIXED () {0x0010;}' unless defined(&MAP_FIXED);
    eval 'sub MAP_RENAME () {0x0020;}' unless defined(&MAP_RENAME);
    eval 'sub MAP_NORESERVE () {0x0040;}' unless defined(&MAP_NORESERVE);
    eval 'sub MAP_INHERIT () {0x0080;}' unless defined(&MAP_INHERIT);
    eval 'sub MAP_NOEXTEND () {0x0100;}' unless defined(&MAP_NOEXTEND);
    eval 'sub MAP_HASSEMAPHORE () {0x0200;}' unless defined(&MAP_HASSEMAPHORE);
    eval 'sub MAP_STACK () {0x0400;}' unless defined(&MAP_STACK);
    if(defined(&_P1003_1B_VISIBLE)) {
	eval 'sub MCL_CURRENT () {0x0001;}' unless defined(&MCL_CURRENT);
	eval 'sub MCL_FUTURE () {0x0002;}' unless defined(&MCL_FUTURE);
    }
    eval 'sub MAP_FAILED () {(( &void *)-1);}' unless defined(&MAP_FAILED);
    eval 'sub MS_SYNC () {0x0000;}' unless defined(&MS_SYNC);
    eval 'sub MS_ASYNC () {0x0001;}' unless defined(&MS_ASYNC);
    eval 'sub MS_INVALIDATE () {0x0002;}' unless defined(&MS_INVALIDATE);
    eval 'sub MAP_FILE () {0x0000;}' unless defined(&MAP_FILE);
    eval 'sub MAP_ANON () {0x1000;}' unless defined(&MAP_ANON);
    eval 'sub MADV_NORMAL () {0;}' unless defined(&MADV_NORMAL);
    eval 'sub MADV_RANDOM () {1;}' unless defined(&MADV_RANDOM);
    eval 'sub MADV_SEQUENTIAL () {2;}' unless defined(&MADV_SEQUENTIAL);
    eval 'sub MADV_WILLNEED () {3;}' unless defined(&MADV_WILLNEED);
    eval 'sub MADV_DONTNEED () {4;}' unless defined(&MADV_DONTNEED);
    eval 'sub MADV_FREE () {5;}' unless defined(&MADV_FREE);
    eval 'sub MINCORE_INCORE () {0x1;}' unless defined(&MINCORE_INCORE);
    eval 'sub MINCORE_REFERENCED () {0x2;}' unless defined(&MINCORE_REFERENCED);
    eval 'sub MINCORE_MODIFIED () {0x4;}' unless defined(&MINCORE_MODIFIED);
    eval 'sub MINCORE_REFERENCED_OTHER () {0x8;}' unless defined(&MINCORE_REFERENCED_OTHER);
    eval 'sub MINCORE_MODIFIED_OTHER () {0x10;}' unless defined(&MINCORE_MODIFIED_OTHER);
    unless(defined(&KERNEL)) {
	require 'sys/cdefs.ph';
	if(defined(&_P1003_1B_VISIBLE)) {
	}
	unless(defined(&_MMAP_DECLARED)) {
	    eval 'sub _MMAP_DECLARED () {1;}' unless defined(&_MMAP_DECLARED);
	}
	unless(defined(&_POSIX_SOURCE)) {
	}
    }
}
1;
