require '_h2ph_pre.ph';

unless(defined(&_SYS_QUEUE_H_)) {
    eval 'sub _SYS_QUEUE_H_ () {1;}' unless defined(&_SYS_QUEUE_H_);
    eval 'sub SLIST_HEAD {
        local($name, $type) = @_;
	    eval q(\'struct name\' { \'struct type\' * &slh_first; });
    }' unless defined(&SLIST_HEAD);
    eval 'sub SLIST_ENTRY {
        local($type) = @_;
	    eval q(\'struct struct\' { \'struct type\' * &sle_next; });
    }' unless defined(&SLIST_ENTRY);
    eval 'sub SLIST_EMPTY {
        local($head) = @_;
	    eval q((($head)-> &slh_first ==  &NULL));
    }' unless defined(&SLIST_EMPTY);
    eval 'sub SLIST_FIRST {
        local($head) = @_;
	    eval q((($head)-> &slh_first));
    }' unless defined(&SLIST_FIRST);
    eval 'sub SLIST_FOREACH {
        local($var, $head, $field) = @_;
	    eval q( &for(($var) = ($head)-> &slh_first; ($var); ($var) = ($var)-> ($field->{sle_next})));
    }' unless defined(&SLIST_FOREACH);
    eval 'sub SLIST_INIT {
        local($head) = @_;
	    eval q({ ($head)-> &slh_first =  &NULL; });
    }' unless defined(&SLIST_INIT);
    eval 'sub SLIST_INSERT_AFTER {
        local($slistelm, $elm, $field) = @_;
	    eval q( &do { ($elm)-> ($field->{sle_next}) = ($slistelm)-> ($field->{sle_next}); ($slistelm)-> ($field->{sle_next}) = ($elm); }  &while (0));
    }' unless defined(&SLIST_INSERT_AFTER);
    eval 'sub SLIST_INSERT_HEAD {
        local($head, $elm, $field) = @_;
	    eval q( &do { ($elm)-> ($field->{sle_next}) = ($head)-> &slh_first; ($head)-> &slh_first = ($elm); }  &while (0));
    }' unless defined(&SLIST_INSERT_HEAD);
    eval 'sub SLIST_NEXT {
        local($elm, $field) = @_;
	    eval q((($elm)-> ($field->{sle_next})));
    }' unless defined(&SLIST_NEXT);
    eval 'sub SLIST_REMOVE_HEAD {
        local($head, $field) = @_;
	    eval q( &do { ($head)-> &slh_first = ($head)-> ($slh_first->{field}->{sle_next}); }  &while (0));
    }' unless defined(&SLIST_REMOVE_HEAD);
    eval 'sub SLIST_REMOVE {
        local($head, $elm, $type, $field) = @_;
	    eval q( &do {  &if (($head)-> &slh_first == ($elm)) {  &SLIST_REMOVE_HEAD(($head), $field); }  &else { \'struct type\' * &curelm = ($head)-> &slh_first;  &while(  ($curelm->{field}->{sle_next}) != ($elm) )  &curelm =  ($curelm->{field}->{sle_next});  ($curelm->{field}->{sle_next}) =  ($curelm->{field}->{sle_next}->{field}->{sle_next}); } }  &while (0));
    }' unless defined(&SLIST_REMOVE);
    eval 'sub STAILQ_HEAD {
        local($name, $type) = @_;
	    eval q(\'struct name\' { \'struct type\' * &stqh_first; \'struct type\' ** &stqh_last; });
    }' unless defined(&STAILQ_HEAD);
    eval 'sub STAILQ_HEAD_INITIALIZER {
        local($head) = @_;
	    eval q({  &NULL, ($head). &stqh_first });
    }' unless defined(&STAILQ_HEAD_INITIALIZER);
    eval 'sub STAILQ_ENTRY {
        local($type) = @_;
	    eval q(\'struct struct\' { \'struct type\' * &stqe_next; });
    }' unless defined(&STAILQ_ENTRY);
    eval 'sub STAILQ_EMPTY {
        local($head) = @_;
	    eval q((($head)-> &stqh_first ==  &NULL));
    }' unless defined(&STAILQ_EMPTY);
    eval 'sub STAILQ_INIT {
        local($head) = @_;
	    eval q( &do { ($head)-> &stqh_first =  &NULL; ($head)-> &stqh_last = ($head)-> &stqh_first; }  &while (0));
    }' unless defined(&STAILQ_INIT);
    eval 'sub STAILQ_FIRST {
        local($head) = @_;
	    eval q((($head)-> &stqh_first));
    }' unless defined(&STAILQ_FIRST);
    eval 'sub STAILQ_LAST {
        local($head) = @_;
	    eval q((*($head)-> &stqh_last));
    }' unless defined(&STAILQ_LAST);
    eval 'sub STAILQ_INSERT_HEAD {
        local($head, $elm, $field) = @_;
	    eval q( &do {  &if ((($elm)-> ($field->{stqe_next}) = ($head)-> &stqh_first) ==  &NULL) ($head)-> &stqh_last = ($elm)-> ($field->{stqe_next}); ($head)-> &stqh_first = ($elm); }  &while (0));
    }' unless defined(&STAILQ_INSERT_HEAD);
    eval 'sub STAILQ_INSERT_TAIL {
        local($head, $elm, $field) = @_;
	    eval q( &do { ($elm)-> ($field->{stqe_next}) =  &NULL; *($head)-> &stqh_last = ($elm); ($head)-> &stqh_last = ($elm)-> ($field->{stqe_next}); }  &while (0));
    }' unless defined(&STAILQ_INSERT_TAIL);
    eval 'sub STAILQ_INSERT_AFTER {
        local($head, $tqelm, $elm, $field) = @_;
	    eval q( &do {  &if ((($elm)-> ($field->{stqe_next}) = ($tqelm)-> ($field->{stqe_next})) ==  &NULL) ($head)-> &stqh_last = ($elm)-> ($field->{stqe_next}); ($tqelm)-> ($field->{stqe_next}) = ($elm); }  &while (0));
    }' unless defined(&STAILQ_INSERT_AFTER);
    eval 'sub STAILQ_NEXT {
        local($elm, $field) = @_;
	    eval q((($elm)-> ($field->{stqe_next})));
    }' unless defined(&STAILQ_NEXT);
    eval 'sub STAILQ_REMOVE_HEAD {
        local($head, $field) = @_;
	    eval q( &do {  &if ((($head)-> &stqh_first = ($head)-> ($stqh_first->{field}->{stqe_next})) ==  &NULL) ($head)-> &stqh_last = ($head)-> &stqh_first; }  &while (0));
    }' unless defined(&STAILQ_REMOVE_HEAD);
    eval 'sub STAILQ_REMOVE_HEAD_UNTIL {
        local($head, $elm, $field) = @_;
	    eval q( &do {  &if ((($head)-> &stqh_first = ($elm)-> ($field->{stqe_next})) ==  &NULL) ($head)-> &stqh_last = ($head)-> &stqh_first; }  &while (0));
    }' unless defined(&STAILQ_REMOVE_HEAD_UNTIL);
    eval 'sub STAILQ_REMOVE {
        local($head, $elm, $type, $field) = @_;
	    eval q( &do {  &if (($head)-> &stqh_first == ($elm)) {  &STAILQ_REMOVE_HEAD($head, $field); }  &else { \'struct type\' * &curelm = ($head)-> &stqh_first;  &while(  ($curelm->{field}->{stqe_next}) != ($elm) )  &curelm =  ($curelm->{field}->{stqe_next});  &if(( ($curelm->{field}->{stqe_next}) =  ($curelm->{field}->{stqe_next}->{field}->{stqe_next})) ==  &NULL) ($head)-> &stqh_last = ( &curelm)-> ($field->{stqe_next}); } }  &while (0));
    }' unless defined(&STAILQ_REMOVE);
    eval 'sub LIST_HEAD {
        local($name, $type) = @_;
	    eval q(\'struct name\' { \'struct type\' * &lh_first; });
    }' unless defined(&LIST_HEAD);
    eval 'sub LIST_HEAD_INITIALIZER {
        local($head) = @_;
	    eval q({  &NULL });
    }' unless defined(&LIST_HEAD_INITIALIZER);
    eval 'sub LIST_ENTRY {
        local($type) = @_;
	    eval q(\'struct struct\' { \'struct type\' * &le_next; \'struct type\' ** &le_prev; });
    }' unless defined(&LIST_ENTRY);
    eval 'sub LIST_EMPTY {
        local($head) = @_;
	    eval q((($head)-> &lh_first ==  &NULL));
    }' unless defined(&LIST_EMPTY);
    eval 'sub LIST_FIRST {
        local($head) = @_;
	    eval q((($head)-> &lh_first));
    }' unless defined(&LIST_FIRST);
    eval 'sub LIST_FOREACH {
        local($var, $head, $field) = @_;
	    eval q( &for(($var) = ($head)-> &lh_first; ($var); ($var) = ($var)-> ($field->{le_next})));
    }' unless defined(&LIST_FOREACH);
    eval 'sub LIST_INIT {
        local($head) = @_;
	    eval q( &do { ($head)-> &lh_first =  &NULL; }  &while (0));
    }' unless defined(&LIST_INIT);
    eval 'sub LIST_INSERT_AFTER {
        local($listelm, $elm, $field) = @_;
	    eval q( &do {  &if ((($elm)-> ($field->{le_next}) = ($listelm)-> ($field->{le_next})) !=  &NULL) ($listelm)-> ($field->{le_next}->{field}->{le_prev}) = ($elm)-> ($field->{le_next}); ($listelm)-> ($field->{le_next}) = ($elm); ($elm)-> ($field->{le_prev}) = ($listelm)-> ($field->{le_next}); }  &while (0));
    }' unless defined(&LIST_INSERT_AFTER);
    eval 'sub LIST_INSERT_BEFORE {
        local($listelm, $elm, $field) = @_;
	    eval q( &do { ($elm)-> ($field->{le_prev}) = ($listelm)-> ($field->{le_prev}); ($elm)-> ($field->{le_next}) = ($listelm); *($listelm)-> ($field->{le_prev}) = ($elm); ($listelm)-> ($field->{le_prev}) = ($elm)-> ($field->{le_next}); }  &while (0));
    }' unless defined(&LIST_INSERT_BEFORE);
    eval 'sub LIST_INSERT_HEAD {
        local($head, $elm, $field) = @_;
	    eval q( &do {  &if ((($elm)-> ($field->{le_next}) = ($head)-> &lh_first) !=  &NULL) ($head)-> ($lh_first->{field}->{le_prev}) = ($elm)-> ($field->{le_next}); ($head)-> &lh_first = ($elm); ($elm)-> ($field->{le_prev}) = ($head)-> &lh_first; }  &while (0));
    }' unless defined(&LIST_INSERT_HEAD);
    eval 'sub LIST_NEXT {
        local($elm, $field) = @_;
	    eval q((($elm)-> ($field->{le_next})));
    }' unless defined(&LIST_NEXT);
    eval 'sub LIST_REMOVE {
        local($elm, $field) = @_;
	    eval q( &do {  &if (($elm)-> ($field->{le_next}) !=  &NULL) ($elm)-> ($field->{le_next}->{field}->{le_prev}) = ($elm)-> ($field->{le_prev}); *($elm)-> ($field->{le_prev}) = ($elm)-> ($field->{le_next}); }  &while (0));
    }' unless defined(&LIST_REMOVE);
    eval 'sub TAILQ_HEAD {
        local($name, $type) = @_;
	    eval q(\'struct name\' { \'struct type\' * &tqh_first; \'struct type\' ** &tqh_last; });
    }' unless defined(&TAILQ_HEAD);
    eval 'sub TAILQ_HEAD_INITIALIZER {
        local($head) = @_;
	    eval q({  &NULL, ($head). &tqh_first });
    }' unless defined(&TAILQ_HEAD_INITIALIZER);
    eval 'sub TAILQ_ENTRY {
        local($type) = @_;
	    eval q(\'struct struct\' { \'struct type\' * &tqe_next; \'struct type\' ** &tqe_prev; });
    }' unless defined(&TAILQ_ENTRY);
    eval 'sub TAILQ_EMPTY {
        local($head) = @_;
	    eval q((($head)-> &tqh_first ==  &NULL));
    }' unless defined(&TAILQ_EMPTY);
    eval 'sub TAILQ_FOREACH {
        local($var, $head, $field) = @_;
	    eval q( &for ($var =  &TAILQ_FIRST($head); $var; $var =  &TAILQ_NEXT($var, $field)));
    }' unless defined(&TAILQ_FOREACH);
    eval 'sub TAILQ_FIRST {
        local($head) = @_;
	    eval q((($head)-> &tqh_first));
    }' unless defined(&TAILQ_FIRST);
    eval 'sub TAILQ_LAST {
        local($head, $headname) = @_;
	    eval q((*(((($head)-> &tqh_last))-> &tqh_last)));
    }' unless defined(&TAILQ_LAST);
    eval 'sub TAILQ_NEXT {
        local($elm, $field) = @_;
	    eval q((($elm)-> ($field->{tqe_next})));
    }' unless defined(&TAILQ_NEXT);
    eval 'sub TAILQ_PREV {
        local($elm, $headname, $field) = @_;
	    eval q((*(((($elm)-> ($field->{tqe_prev})))-> &tqh_last)));
    }' unless defined(&TAILQ_PREV);
    eval 'sub TAILQ_INIT {
        local($head) = @_;
	    eval q( &do { ($head)-> &tqh_first =  &NULL; ($head)-> &tqh_last = ($head)-> &tqh_first; }  &while (0));
    }' unless defined(&TAILQ_INIT);
    eval 'sub TAILQ_INSERT_HEAD {
        local($head, $elm, $field) = @_;
	    eval q( &do {  &if ((($elm)-> ($field->{tqe_next}) = ($head)-> &tqh_first) !=  &NULL) ($head)-> ($tqh_first->{field}->{tqe_prev}) = ($elm)-> ($field->{tqe_next});  &else ($head)-> &tqh_last = ($elm)-> ($field->{tqe_next}); ($head)-> &tqh_first = ($elm); ($elm)-> ($field->{tqe_prev}) = ($head)-> &tqh_first; }  &while (0));
    }' unless defined(&TAILQ_INSERT_HEAD);
    eval 'sub TAILQ_INSERT_TAIL {
        local($head, $elm, $field) = @_;
	    eval q( &do { ($elm)-> ($field->{tqe_next}) =  &NULL; ($elm)-> ($field->{tqe_prev}) = ($head)-> &tqh_last; *($head)-> &tqh_last = ($elm); ($head)-> &tqh_last = ($elm)-> ($field->{tqe_next}); }  &while (0));
    }' unless defined(&TAILQ_INSERT_TAIL);
    eval 'sub TAILQ_INSERT_AFTER {
        local($head, $listelm, $elm, $field) = @_;
	    eval q( &do {  &if ((($elm)-> ($field->{tqe_next}) = ($listelm)-> ($field->{tqe_next})) !=  &NULL) ($elm)-> ($field->{tqe_next}->{field}->{tqe_prev}) = ($elm)-> ($field->{tqe_next});  &else ($head)-> &tqh_last = ($elm)-> ($field->{tqe_next}); ($listelm)-> ($field->{tqe_next}) = ($elm); ($elm)-> ($field->{tqe_prev}) = ($listelm)-> ($field->{tqe_next}); }  &while (0));
    }' unless defined(&TAILQ_INSERT_AFTER);
    eval 'sub TAILQ_INSERT_BEFORE {
        local($listelm, $elm, $field) = @_;
	    eval q( &do { ($elm)-> ($field->{tqe_prev}) = ($listelm)-> ($field->{tqe_prev}); ($elm)-> ($field->{tqe_next}) = ($listelm); *($listelm)-> ($field->{tqe_prev}) = ($elm); ($listelm)-> ($field->{tqe_prev}) = ($elm)-> ($field->{tqe_next}); }  &while (0));
    }' unless defined(&TAILQ_INSERT_BEFORE);
    eval 'sub TAILQ_REMOVE {
        local($head, $elm, $field) = @_;
	    eval q( &do {  &if ((($elm)-> ($field->{tqe_next})) !=  &NULL) ($elm)-> ($field->{tqe_next}->{field}->{tqe_prev}) = ($elm)-> ($field->{tqe_prev});  &else ($head)-> &tqh_last = ($elm)-> ($field->{tqe_prev}); *($elm)-> ($field->{tqe_prev}) = ($elm)-> ($field->{tqe_next}); }  &while (0));
    }' unless defined(&TAILQ_REMOVE);
    eval 'sub CIRCLEQ_HEAD {
        local($name, $type) = @_;
	    eval q(\'struct name\' { \'struct type\' * &cqh_first; \'struct type\' * &cqh_last; });
    }' unless defined(&CIRCLEQ_HEAD);
    eval 'sub CIRCLEQ_ENTRY {
        local($type) = @_;
	    eval q(\'struct struct\' { \'struct type\' * &cqe_next; \'struct type\' * &cqe_prev; });
    }' unless defined(&CIRCLEQ_ENTRY);
    eval 'sub CIRCLEQ_EMPTY {
        local($head) = @_;
	    eval q((-> &cqh_first == ($head)));
    }' unless defined(&CIRCLEQ_EMPTY);
    eval 'sub CIRCLEQ_FIRST {
        local($head) = @_;
	    eval q((($head)-> &cqh_first));
    }' unless defined(&CIRCLEQ_FIRST);
    eval 'sub CIRCLEQ_FOREACH {
        local($var, $head, $field) = @_;
	    eval q( &for( = -> &cqh_first; != ($head); ($var) = ($var)-> ($field->{cqe_next})));
    }' unless defined(&CIRCLEQ_FOREACH);
    eval 'sub CIRCLEQ_INIT {
        local($head) = @_;
	    eval q( &do { -> &cqh_first = ; -> &cqh_last = ($head); }  &while (0));
    }' unless defined(&CIRCLEQ_INIT);
    eval 'sub CIRCLEQ_INSERT_AFTER {
        local($head, $listelm, $elm, $field) = @_;
	    eval q( &do { -> ($field->{cqe_next}) = -> ($field->{cqe_next}); -> ($field->{cqe_prev}) = ;  &if (-> ($field->{cqe_next}) == ($head)) ($head)-> &cqh_last = ($elm);  &else ($listelm)-> ($field->{cqe_next}->{field}->{cqe_prev}) = ($elm); ($listelm)-> ($field->{cqe_next}) = ($elm); }  &while (0));
    }' unless defined(&CIRCLEQ_INSERT_AFTER);
    eval 'sub CIRCLEQ_INSERT_BEFORE {
        local($head, $listelm, $elm, $field) = @_;
	    eval q( &do { -> ($field->{cqe_next}) = ; -> ($field->{cqe_prev}) = -> ($field->{cqe_prev});  &if (-> ($field->{cqe_prev}) == ($head)) ($head)-> &cqh_first = ($elm);  &else ($listelm)-> ($field->{cqe_prev}->{field}->{cqe_next}) = ($elm); ($listelm)-> ($field->{cqe_prev}) = ($elm); }  &while (0));
    }' unless defined(&CIRCLEQ_INSERT_BEFORE);
    eval 'sub CIRCLEQ_INSERT_HEAD {
        local($head, $elm, $field) = @_;
	    eval q( &do { -> ($field->{cqe_next}) = -> &cqh_first; -> ($field->{cqe_prev}) = ;  &if (-> &cqh_last == ($head)) ($head)-> &cqh_last = ($elm);  &else ($head)-> ($cqh_first->{field}->{cqe_prev}) = ($elm); ($head)-> &cqh_first = ($elm); }  &while (0));
    }' unless defined(&CIRCLEQ_INSERT_HEAD);
    eval 'sub CIRCLEQ_INSERT_TAIL {
        local($head, $elm, $field) = @_;
	    eval q( &do { -> ($field->{cqe_next}) = ; -> ($field->{cqe_prev}) = -> &cqh_last;  &if (-> &cqh_first == ($head)) ($head)-> &cqh_first = ($elm);  &else ($head)-> ($cqh_last->{field}->{cqe_next}) = ($elm); ($head)-> &cqh_last = ($elm); }  &while (0));
    }' unless defined(&CIRCLEQ_INSERT_TAIL);
    eval 'sub CIRCLEQ_LAST {
        local($head) = @_;
	    eval q((($head)-> &cqh_last));
    }' unless defined(&CIRCLEQ_LAST);
    eval 'sub CIRCLEQ_NEXT {
        local($elm,$field) = @_;
	    eval q((($elm)-> ($field->{cqe_next})));
    }' unless defined(&CIRCLEQ_NEXT);
    eval 'sub CIRCLEQ_PREV {
        local($elm,$field) = @_;
	    eval q((($elm)-> ($field->{cqe_prev})));
    }' unless defined(&CIRCLEQ_PREV);
    eval 'sub CIRCLEQ_REMOVE {
        local($head, $elm, $field) = @_;
	    eval q( &do {  &if (-> ($field->{cqe_next}) == ) -> &cqh_last = -> ($field->{cqe_prev});  &else -> ($field->{cqe_next}->{field}->{cqe_prev}) = -> ($field->{cqe_prev});  &if (-> ($field->{cqe_prev}) == ($head)) ($head)-> &cqh_first = ($elm)-> ($field->{cqe_next});  &else ($elm)-> ($field->{cqe_prev}->{field}->{cqe_next}) = ($elm)-> ($field->{cqe_next}); }  &while (0));
    }' unless defined(&CIRCLEQ_REMOVE);
    if(defined(&KERNEL)) {
	if(defined(&__GNUC__)) {
	} else {
	}
    }
}
1;
