require '_h2ph_pre.ph';

unless(defined(&_SYS_UNISTD_H_)) {
    eval 'sub _SYS_UNISTD_H_ () {1;}' unless defined(&_SYS_UNISTD_H_);
    require 'sys/_posix.ph';
    eval 'sub _POSIX_JOB_CONTROL () {1;}' unless defined(&_POSIX_JOB_CONTROL);
    if(defined(&_NOT_AVAILABLE)) {
	eval 'sub _POSIX_SAVED_IDS () {1;}' unless defined(&_POSIX_SAVED_IDS);
    }
    eval 'sub _POSIX2_VERSION () {199212;}' unless defined(&_POSIX2_VERSION);
    eval 'sub _POSIX_CHOWN_RESTRICTED () {1;}' unless defined(&_POSIX_CHOWN_RESTRICTED);
    eval 'sub _POSIX_NO_TRUNC () {1;}' unless defined(&_POSIX_NO_TRUNC);
    eval 'sub _POSIX_VDISABLE () {0xff;}' unless defined(&_POSIX_VDISABLE);
    eval 'sub F_OK () {0;}' unless defined(&F_OK);
    eval 'sub X_OK () {0x01;}' unless defined(&X_OK);
    eval 'sub W_OK () {0x02;}' unless defined(&W_OK);
    eval 'sub R_OK () {0x04;}' unless defined(&R_OK);
    eval 'sub SEEK_SET () {0;}' unless defined(&SEEK_SET);
    eval 'sub SEEK_CUR () {1;}' unless defined(&SEEK_CUR);
    eval 'sub SEEK_END () {2;}' unless defined(&SEEK_END);
    unless(defined(&_POSIX_SOURCE)) {
	eval 'sub L_SET () { &SEEK_SET;}' unless defined(&L_SET);
	eval 'sub L_INCR () { &SEEK_CUR;}' unless defined(&L_INCR);
	eval 'sub L_XTND () { &SEEK_END;}' unless defined(&L_XTND);
    }
    eval 'sub _PC_LINK_MAX () {1;}' unless defined(&_PC_LINK_MAX);
    eval 'sub _PC_MAX_CANON () {2;}' unless defined(&_PC_MAX_CANON);
    eval 'sub _PC_MAX_INPUT () {3;}' unless defined(&_PC_MAX_INPUT);
    eval 'sub _PC_NAME_MAX () {4;}' unless defined(&_PC_NAME_MAX);
    eval 'sub _PC_PATH_MAX () {5;}' unless defined(&_PC_PATH_MAX);
    eval 'sub _PC_PIPE_BUF () {6;}' unless defined(&_PC_PIPE_BUF);
    eval 'sub _PC_CHOWN_RESTRICTED () {7;}' unless defined(&_PC_CHOWN_RESTRICTED);
    eval 'sub _PC_NO_TRUNC () {8;}' unless defined(&_PC_NO_TRUNC);
    eval 'sub _PC_VDISABLE () {9;}' unless defined(&_PC_VDISABLE);
    eval 'sub _SC_ARG_MAX () {1;}' unless defined(&_SC_ARG_MAX);
    eval 'sub _SC_CHILD_MAX () {2;}' unless defined(&_SC_CHILD_MAX);
    eval 'sub _SC_CLK_TCK () {3;}' unless defined(&_SC_CLK_TCK);
    eval 'sub _SC_NGROUPS_MAX () {4;}' unless defined(&_SC_NGROUPS_MAX);
    eval 'sub _SC_OPEN_MAX () {5;}' unless defined(&_SC_OPEN_MAX);
    eval 'sub _SC_JOB_CONTROL () {6;}' unless defined(&_SC_JOB_CONTROL);
    eval 'sub _SC_SAVED_IDS () {7;}' unless defined(&_SC_SAVED_IDS);
    eval 'sub _SC_VERSION () {8;}' unless defined(&_SC_VERSION);
    eval 'sub _SC_BC_BASE_MAX () {9;}' unless defined(&_SC_BC_BASE_MAX);
    eval 'sub _SC_BC_DIM_MAX () {10;}' unless defined(&_SC_BC_DIM_MAX);
    eval 'sub _SC_BC_SCALE_MAX () {11;}' unless defined(&_SC_BC_SCALE_MAX);
    eval 'sub _SC_BC_STRING_MAX () {12;}' unless defined(&_SC_BC_STRING_MAX);
    eval 'sub _SC_COLL_WEIGHTS_MAX () {13;}' unless defined(&_SC_COLL_WEIGHTS_MAX);
    eval 'sub _SC_EXPR_NEST_MAX () {14;}' unless defined(&_SC_EXPR_NEST_MAX);
    eval 'sub _SC_LINE_MAX () {15;}' unless defined(&_SC_LINE_MAX);
    eval 'sub _SC_RE_DUP_MAX () {16;}' unless defined(&_SC_RE_DUP_MAX);
    eval 'sub _SC_2_VERSION () {17;}' unless defined(&_SC_2_VERSION);
    eval 'sub _SC_2_C_BIND () {18;}' unless defined(&_SC_2_C_BIND);
    eval 'sub _SC_2_C_DEV () {19;}' unless defined(&_SC_2_C_DEV);
    eval 'sub _SC_2_CHAR_TERM () {20;}' unless defined(&_SC_2_CHAR_TERM);
    eval 'sub _SC_2_FORT_DEV () {21;}' unless defined(&_SC_2_FORT_DEV);
    eval 'sub _SC_2_FORT_RUN () {22;}' unless defined(&_SC_2_FORT_RUN);
    eval 'sub _SC_2_LOCALEDEF () {23;}' unless defined(&_SC_2_LOCALEDEF);
    eval 'sub _SC_2_SW_DEV () {24;}' unless defined(&_SC_2_SW_DEV);
    eval 'sub _SC_2_UPE () {25;}' unless defined(&_SC_2_UPE);
    eval 'sub _SC_STREAM_MAX () {26;}' unless defined(&_SC_STREAM_MAX);
    eval 'sub _SC_TZNAME_MAX () {27;}' unless defined(&_SC_TZNAME_MAX);
    eval 'sub _CS_PATH () {1;}' unless defined(&_CS_PATH);
    if(defined(&_P1003_1B_VISIBLE)) {
	eval 'sub _POSIX_PRIORITY_SCHEDULING () {1;}' unless defined(&_POSIX_PRIORITY_SCHEDULING);
	if(0) {
	    eval 'sub _POSIX_ASYNCHRONOUS_IO () {1;}' unless defined(&_POSIX_ASYNCHRONOUS_IO);
	    eval 'sub _POSIX_MEMLOCK () {1;}' unless defined(&_POSIX_MEMLOCK);
	    eval 'sub _POSIX_MEMLOCK_RANGE () {1;}' unless defined(&_POSIX_MEMLOCK_RANGE);
	}
	eval 'sub _SC_ASYNCHRONOUS_IO () {28;}' unless defined(&_SC_ASYNCHRONOUS_IO);
	eval 'sub _SC_MAPPED_FILES () {29;}' unless defined(&_SC_MAPPED_FILES);
	eval 'sub _SC_MEMLOCK () {30;}' unless defined(&_SC_MEMLOCK);
	eval 'sub _SC_MEMLOCK_RANGE () {31;}' unless defined(&_SC_MEMLOCK_RANGE);
	eval 'sub _SC_MEMORY_PROTECTION () {32;}' unless defined(&_SC_MEMORY_PROTECTION);
	eval 'sub _SC_MESSAGE_PASSING () {33;}' unless defined(&_SC_MESSAGE_PASSING);
	eval 'sub _SC_PRIORITIZED_IO () {34;}' unless defined(&_SC_PRIORITIZED_IO);
	eval 'sub _SC_PRIORITY_SCHEDULING () {35;}' unless defined(&_SC_PRIORITY_SCHEDULING);
	eval 'sub _SC_REALTIME_SIGNALS () {36;}' unless defined(&_SC_REALTIME_SIGNALS);
	eval 'sub _SC_SEMAPHORES () {37;}' unless defined(&_SC_SEMAPHORES);
	eval 'sub _SC_FSYNC () {38;}' unless defined(&_SC_FSYNC);
	eval 'sub _SC_SHARED_MEMORY_OBJECTS () {39;}' unless defined(&_SC_SHARED_MEMORY_OBJECTS);
	eval 'sub _SC_SYNCHRONIZED_IO () {40;}' unless defined(&_SC_SYNCHRONIZED_IO);
	eval 'sub _SC_TIMERS () {41;}' unless defined(&_SC_TIMERS);
	eval 'sub _SC_AIO_LISTIO_MAX () {42;}' unless defined(&_SC_AIO_LISTIO_MAX);
	eval 'sub _SC_AIO_MAX () {43;}' unless defined(&_SC_AIO_MAX);
	eval 'sub _SC_AIO_PRIO_DELTA_MAX () {44;}' unless defined(&_SC_AIO_PRIO_DELTA_MAX);
	eval 'sub _SC_DELAYTIMER_MAX () {45;}' unless defined(&_SC_DELAYTIMER_MAX);
	eval 'sub _SC_MQ_OPEN_MAX () {46;}' unless defined(&_SC_MQ_OPEN_MAX);
	eval 'sub _SC_PAGESIZE () {47;}' unless defined(&_SC_PAGESIZE);
	eval 'sub _SC_RTSIG_MAX () {48;}' unless defined(&_SC_RTSIG_MAX);
	eval 'sub _SC_SEM_NSEMS_MAX () {49;}' unless defined(&_SC_SEM_NSEMS_MAX);
	eval 'sub _SC_SEM_VALUE_MAX () {50;}' unless defined(&_SC_SEM_VALUE_MAX);
	eval 'sub _SC_SIGQUEUE_MAX () {51;}' unless defined(&_SC_SIGQUEUE_MAX);
	eval 'sub _SC_TIMER_MAX () {52;}' unless defined(&_SC_TIMER_MAX);
	eval 'sub _PC_ASYNC_IO () {53;}' unless defined(&_PC_ASYNC_IO);
	eval 'sub _PC_PRIO_IO () {54;}' unless defined(&_PC_PRIO_IO);
	eval 'sub _PC_SYNC_IO () {55;}' unless defined(&_PC_SYNC_IO);
    }
    unless(defined(&_POSIX_SOURCE)) {
	eval 'sub RFNAMEG () {(1<<0);}' unless defined(&RFNAMEG);
	eval 'sub RFENVG () {(1<<1);}' unless defined(&RFENVG);
	eval 'sub RFFDG () {(1<<2);}' unless defined(&RFFDG);
	eval 'sub RFNOTEG () {(1<<3);}' unless defined(&RFNOTEG);
	eval 'sub RFPROC () {(1<<4);}' unless defined(&RFPROC);
	eval 'sub RFMEM () {(1<<5);}' unless defined(&RFMEM);
	eval 'sub RFNOWAIT () {(1<<6);}' unless defined(&RFNOWAIT);
	eval 'sub RFCNAMEG () {(1<<10);}' unless defined(&RFCNAMEG);
	eval 'sub RFCENVG () {(1<<11);}' unless defined(&RFCENVG);
	eval 'sub RFCFDG () {(1<<12);}' unless defined(&RFCFDG);
	eval 'sub RFTHREAD () {(1<<13);}' unless defined(&RFTHREAD);
	eval 'sub RFSIGSHARE () {(1<<14);}' unless defined(&RFSIGSHARE);
	eval 'sub RFLINUXTHPN () {(1<<16);}' unless defined(&RFLINUXTHPN);
	eval 'sub RFPPWAIT () {(1<<31);}' unless defined(&RFPPWAIT);
    }
}
1;
