require '_h2ph_pre.ph';

unless(defined(&_SYS_VNODE_H_)) {
    eval 'sub _SYS_VNODE_H_ () {1;}' unless defined(&_SYS_VNODE_H_);
    require 'sys/queue.ph';
    require 'sys/select.ph';
    require 'sys/uio.ph';
    require 'machine/lock.ph';
    eval("sub VNON () { 0; }") unless defined(&VNON);
    eval("sub VREG () { 1; }") unless defined(&VREG);
    eval("sub VDIR () { 2; }") unless defined(&VDIR);
    eval("sub VBLK () { 3; }") unless defined(&VBLK);
    eval("sub VCHR () { 4; }") unless defined(&VCHR);
    eval("sub VLNK () { 5; }") unless defined(&VLNK);
    eval("sub VSOCK () { 6; }") unless defined(&VSOCK);
    eval("sub VFIFO () { 7; }") unless defined(&VFIFO);
    eval("sub VBAD () { 8; }") unless defined(&VBAD);
    eval("sub VT_NON () { 0; }") unless defined(&VT_NON);
    eval("sub VT_UFS () { 1; }") unless defined(&VT_UFS);
    eval("sub VT_NFS () { 2; }") unless defined(&VT_NFS);
    eval("sub VT_MFS () { 3; }") unless defined(&VT_MFS);
    eval("sub VT_PC () { 4; }") unless defined(&VT_PC);
    eval("sub VT_LFS () { 5; }") unless defined(&VT_LFS);
    eval("sub VT_LOFS () { 6; }") unless defined(&VT_LOFS);
    eval("sub VT_FDESC () { 7; }") unless defined(&VT_FDESC);
    eval("sub VT_PORTAL () { 8; }") unless defined(&VT_PORTAL);
    eval("sub VT_NULL () { 9; }") unless defined(&VT_NULL);
    eval("sub VT_UMAP () { 10; }") unless defined(&VT_UMAP);
    eval("sub VT_KERNFS () { 11; }") unless defined(&VT_KERNFS);
    eval("sub VT_PROCFS () { 12; }") unless defined(&VT_PROCFS);
    eval("sub VT_AFS () { 13; }") unless defined(&VT_AFS);
    eval("sub VT_ISOFS () { 14; }") unless defined(&VT_ISOFS);
    eval("sub VT_UNION () { 15; }") unless defined(&VT_UNION);
    eval("sub VT_MSDOSFS () { 16; }") unless defined(&VT_MSDOSFS);
    eval("sub VT_DEVFS () { 17; }") unless defined(&VT_DEVFS);
    eval("sub VT_TFS () { 18; }") unless defined(&VT_TFS);
    eval("sub VT_VFS () { 19; }") unless defined(&VT_VFS);
    eval("sub VT_CODA () { 20; }") unless defined(&VT_CODA);
    eval("sub VT_NTFS () { 21; }") unless defined(&VT_NTFS);
    if(defined(&DEBUG_LOCKS)) {
    }
    eval 'sub v_mountedhere () { ($v_un->{vu_mountedhere});}' unless defined(&v_mountedhere);
    eval 'sub v_socket () { ($v_un->{vu_socket});}' unless defined(&v_socket);
    eval 'sub v_specinfo () { ($v_un->{vu_specinfo});}' unless defined(&v_specinfo);
    eval 'sub v_fifoinfo () { ($v_un->{vu_fifoinfo});}' unless defined(&v_fifoinfo);
    eval 'sub VN_POLLEVENT {
        local($vp, $events) = @_;
	    eval q( &do {  &if (($vp)-> ($v_pollinfo->{vpi_events}) & ($events))  &vn_pollevent(($vp), ($events)); }  &while (0));
    }' unless defined(&VN_POLLEVENT);
    eval 'sub VROOT () {0x00001;}' unless defined(&VROOT);
    eval 'sub VTEXT () {0x00002;}' unless defined(&VTEXT);
    eval 'sub VSYSTEM () {0x00004;}' unless defined(&VSYSTEM);
    eval 'sub VISTTY () {0x00008;}' unless defined(&VISTTY);
    eval 'sub VXLOCK () {0x00100;}' unless defined(&VXLOCK);
    eval 'sub VXWANT () {0x00200;}' unless defined(&VXWANT);
    eval 'sub VBWAIT () {0x00400;}' unless defined(&VBWAIT);
    eval 'sub VALIASED () {0x00800;}' unless defined(&VALIASED);
    eval 'sub VDIROP () {0x01000;}' unless defined(&VDIROP);
    eval 'sub VOBJBUF () {0x02000;}' unless defined(&VOBJBUF);
    eval 'sub VNINACT () {0x04000;}' unless defined(&VNINACT);
    eval 'sub VAGE () {0x08000;}' unless defined(&VAGE);
    eval 'sub VOLOCK () {0x10000;}' unless defined(&VOLOCK);
    eval 'sub VOWANT () {0x20000;}' unless defined(&VOWANT);
    eval 'sub VDOOMED () {0x40000;}' unless defined(&VDOOMED);
    eval 'sub VFREE () {0x80000;}' unless defined(&VFREE);
    eval 'sub VTBFREE () {0x100000;}' unless defined(&VTBFREE);
    eval 'sub VONWORKLST () {0x200000;}' unless defined(&VONWORKLST);
    eval 'sub VMOUNT () {0x400000;}' unless defined(&VMOUNT);
    eval 'sub VA_UTIMES_NULL () {0x01;}' unless defined(&VA_UTIMES_NULL);
    eval 'sub VA_EXCLUSIVE () {0x02;}' unless defined(&VA_EXCLUSIVE);
    eval 'sub IO_UNIT () {0x01;}' unless defined(&IO_UNIT);
    eval 'sub IO_APPEND () {0x02;}' unless defined(&IO_APPEND);
    eval 'sub IO_SYNC () {0x04;}' unless defined(&IO_SYNC);
    eval 'sub IO_NODELOCKED () {0x08;}' unless defined(&IO_NODELOCKED);
    eval 'sub IO_NDELAY () {0x10;}' unless defined(&IO_NDELAY);
    eval 'sub IO_VMIO () {0x20;}' unless defined(&IO_VMIO);
    eval 'sub IO_INVAL () {0x40;}' unless defined(&IO_INVAL);
    eval 'sub VSUID () {04000;}' unless defined(&VSUID);
    eval 'sub VSGID () {02000;}' unless defined(&VSGID);
    eval 'sub VSVTX () {01000;}' unless defined(&VSVTX);
    eval 'sub VREAD () {00400;}' unless defined(&VREAD);
    eval 'sub VWRITE () {00200;}' unless defined(&VWRITE);
    eval 'sub VEXEC () {00100;}' unless defined(&VEXEC);
    eval 'sub VNOVAL () {(-1);}' unless defined(&VNOVAL);
    if(defined(&KERNEL)) {
	if(defined(&MALLOC_DECLARE)) {
	}
	eval 'sub IFTOVT {
	    local($mode) = @_;
    	    eval q(( $iftovt_tab[(($mode) &  &S_IFMT) >> 12]));
	}' unless defined(&IFTOVT);
	eval 'sub VTTOIF {
	    local($indx) = @_;
    	    eval q(( $vttoif_tab[($indx)]));
	}' unless defined(&VTTOIF);
	eval 'sub MAKEIMODE {
	    local($indx, $mode) = @_;
    	    eval q(( &VTTOIF($indx) | ($mode)));
	}' unless defined(&MAKEIMODE);
	eval 'sub SKIPSYSTEM () {0x0001;}' unless defined(&SKIPSYSTEM);
	eval 'sub FORCECLOSE () {0x0002;}' unless defined(&FORCECLOSE);
	eval 'sub WRITECLOSE () {0x0004;}' unless defined(&WRITECLOSE);
	eval 'sub DOCLOSE () {0x0008;}' unless defined(&DOCLOSE);
	eval 'sub V_SAVE () {0x0001;}' unless defined(&V_SAVE);
	eval 'sub REVOKEALL () {0x0001;}' unless defined(&REVOKEALL);
	eval 'sub VREF {
	    local($vp) = @_;
    	    eval q( &vref($vp));
	}' unless defined(&VREF);
	if(defined(&DIAGNOSTIC)) {
	    eval 'sub VATTR_NULL {
	        local($vap) = @_;
    		eval q( &vattr_null($vap));
	    }' unless defined(&VATTR_NULL);
	} else {
	    eval 'sub VATTR_NULL {
	        local($vap) = @_;
    		eval q((*($vap) =  &va_null));
	    }' unless defined(&VATTR_NULL);
	}
	eval 'sub NULLVP () {( &NULL);}' unless defined(&NULLVP);
	if(defined( &VFS_LKM)  && !defined( &KLD_MODULE)) {
	    eval 'sub VNODEOP_SET {
	        local($f) = @_;
    		eval q( &DATA_SET( &MODVNOPS,$f));
	    }' unless defined(&VNODEOP_SET);
	} else {
	    eval 'sub VNODEOP_SET {
	        local($f) = @_;
    		eval q( &SYSINIT($f &init,  &SI_SUB_VFS,  &SI_ORDER_SECOND,  &vfs_add_vnodeops, $f);  &SYSUNINIT($f &uninit,  &SI_SUB_VFS,  &SI_ORDER_SECOND,  &vfs_rm_vnodeops, $f););
	    }' unless defined(&VNODEOP_SET);
	}
	eval 'sub LEASE_READ () {0x1;}' unless defined(&LEASE_READ);
	eval 'sub LEASE_WRITE () {0x2;}' unless defined(&LEASE_WRITE);
	eval 'sub VSHOULDFREE {
	    local($vp) = @_;
    	    eval q((!(($vp)-> &v_flag & ( &VFREE| &VDOOMED))  && !($vp)-> &v_holdcnt  && !($vp)-> &v_usecount  && (!($vp)-> &v_object || !(($vp)-> ($v_object->{ref_count}) || ($vp)-> ($v_object->{resident_page_count})))));
	}' unless defined(&VSHOULDFREE);
	eval 'sub VSHOULDBUSY {
	    local($vp) = @_;
    	    eval q(((($vp)-> &v_flag & ( &VFREE| &VTBFREE))  && (($vp)-> &v_holdcnt || ($vp)-> &v_usecount)));
	}' unless defined(&VSHOULDBUSY);
    }
    eval 'sub VDESC_MAX_VPS () {16;}' unless defined(&VDESC_MAX_VPS);
    eval 'sub VDESC_VP0_WILLRELE () {0x0001;}' unless defined(&VDESC_VP0_WILLRELE);
    eval 'sub VDESC_VP1_WILLRELE () {0x0002;}' unless defined(&VDESC_VP1_WILLRELE);
    eval 'sub VDESC_VP2_WILLRELE () {0x0004;}' unless defined(&VDESC_VP2_WILLRELE);
    eval 'sub VDESC_VP3_WILLRELE () {0x0008;}' unless defined(&VDESC_VP3_WILLRELE);
    eval 'sub VDESC_NOMAP_VPP () {0x0100;}' unless defined(&VDESC_NOMAP_VPP);
    eval 'sub VDESC_VPP_WILLRELE () {0x0200;}' unless defined(&VDESC_VPP_WILLRELE);
    eval 'sub VDESC_NO_OFFSET () {-1;}' unless defined(&VDESC_NO_OFFSET);
    if(defined(&KERNEL)) {
	eval 'sub VOPARG_OFFSET {
	    local($p_type,$field) = @_;
    	    eval q(( (( ((->$field))) - (  &NULL))));
	}' unless defined(&VOPARG_OFFSET);
	eval 'sub VOPARG_OFFSETOF {
	    local($s_type,$field) = @_;
    	    eval q( &VOPARG_OFFSET($s_type*,$field));
	}' unless defined(&VOPARG_OFFSETOF);
	eval 'sub VOPARG_OFFSETTO {
	    local($S_TYPE,$S_OFFSET,$STRUCT_P) = @_;
    	    eval q((((($STRUCT_P))+($S_OFFSET))));
	}' unless defined(&VOPARG_OFFSETTO);
	if(defined(&DEBUG_VFS_LOCKS)) {
	    eval 'sub IS_LOCKING_VFS {
	        local($vp) = @_;
    		eval q((($vp)-> &v_tag ==  &VT_UFS || ($vp)-> &v_tag ==  &VT_MFS || ($vp)-> &v_tag ==  &VT_NFS || ($vp)-> &v_tag ==  &VT_LFS || ($vp)-> &v_tag ==  &VT_ISOFS || ($vp)-> &v_tag ==  &VT_MSDOSFS || ($vp)-> &v_tag ==  &VT_DEVFS));
	    }' unless defined(&IS_LOCKING_VFS);
	    eval 'sub ASSERT_VOP_LOCKED {
	        local($vp, $str) = @_;
    		eval q( &if (($vp)  &&  &IS_LOCKING_VFS($vp)  && ! &VOP_ISLOCKED($vp)) {  &panic(\\"%s: %x is not locked but should be\\", $str, $vp); });
	    }' unless defined(&ASSERT_VOP_LOCKED);
	    eval 'sub ASSERT_VOP_UNLOCKED {
	        local($vp, $str) = @_;
    		eval q( &if (($vp)  &&  &IS_LOCKING_VFS($vp)  &&  &VOP_ISLOCKED($vp)) {  &panic(\\"%s: %x is locked but shouldn\'t be\\", $str, $vp); });
	    }' unless defined(&ASSERT_VOP_UNLOCKED);
	} else {
	    eval 'sub ASSERT_VOP_LOCKED {
	        local($vp, $str) = @_;
    		eval q();
	    }' unless defined(&ASSERT_VOP_LOCKED);
	    eval 'sub ASSERT_VOP_UNLOCKED {
	        local($vp, $str) = @_;
    		eval q();
	    }' unless defined(&ASSERT_VOP_UNLOCKED);
	}
	eval 'sub VOCALL {
	    local($OPSV,$OFF,$AP) = @_;
    	    eval q((( *(($OPSV)[($OFF)])) ($AP)));
	}' unless defined(&VOCALL);
	eval 'sub VCALL {
	    local($VP,$OFF,$AP) = @_;
    	    eval q( &VOCALL(($VP)-> &v_op,($OFF),($AP)));
	}' unless defined(&VCALL);
	eval 'sub VDESC {
	    local($OP) = @_;
    	    eval q((&  &__CONCAT($OP, &_desc)));
	}' unless defined(&VDESC);
	eval 'sub VOFFSET {
	    local($OP) = @_;
    	    eval q(( &VDESC($OP)-> &vdesc_offset));
	}' unless defined(&VOFFSET);
	require 'vnode_if.ph';
	if(defined(&DEBUG_LOCKS)) {
	    eval 'sub vn_lock {
	        local($vp,$flags,$p) = @_;
    		eval q( &debug_vn_lock($vp,$flags,$p, &__FILE__, &__LINE__));
	    }' unless defined(&vn_lock);
	}
    }
}
1;
