require '_h2ph_pre.ph';

if((defined(&__GNUC__) ? &__GNUC__ : 0)) {
    warn("\"this\ file\ includes\ \<values\.h\>\ which\ is\ obsoleted\,\ use\ \<limits\.h\>\ or\ \<float\.h\>\ instead\"");
}
unless(defined(&_VALUES_H_)) {
    eval 'sub _VALUES_H_ () {1;}' unless defined(&_VALUES_H_);
    eval 'sub BITSPERBYTE () {8;}' unless defined(&BITSPERBYTE);
    eval 'sub BITS {
        local($type) = @_;
	    eval q(( &BITSPERBYTE * $sizeof{$type}));
    }' unless defined(&BITS);
    eval 'sub CHARBITS () { &BITS;}' unless defined(&CHARBITS);
    eval 'sub SHORTBITS () { &BITS;}' unless defined(&SHORTBITS);
    eval 'sub INTBITS () { &BITS;}' unless defined(&INTBITS);
    eval 'sub LONGBITS () { &BITS;}' unless defined(&LONGBITS);
    eval 'sub PTRBITS () { &BITS;}' unless defined(&PTRBITS);
    eval 'sub DOUBLEBITS () { &BITS( &double);}' unless defined(&DOUBLEBITS);
    eval 'sub FLOATBITS () { &BITS( &float);}' unless defined(&FLOATBITS);
    eval 'sub MINSHORT () {((1<< ( &SHORTBITS - 1)));}' unless defined(&MINSHORT);
    eval 'sub MININT () {(1<< ( &INTBITS - 1));}' unless defined(&MININT);
    eval 'sub MINLONG () {(1 << ( &LONGBITS - 1));}' unless defined(&MINLONG);
    eval 'sub MAXSHORT () {(~ &MINSHORT);}' unless defined(&MAXSHORT);
    eval 'sub MAXINT () {(~ &MININT);}' unless defined(&MAXINT);
    eval 'sub MAXLONG () {(~ &MINLONG);}' unless defined(&MAXLONG);
    eval 'sub HIBITS () { &MINSHORT;}' unless defined(&HIBITS);
    eval 'sub HIBITL () { &MINLONG;}' unless defined(&HIBITL);
    if(defined( &sun) || defined( &hp300) || defined( &hpux) || defined( &masscomp) || defined( &sgi)) {
	if(defined(&masscomp)) {
	    eval 'sub MAXDOUBLE () {({  &double  &maxdouble_val;  &__asm ("fmove%.d #0x7fefffffffffffff,%0" : "=f" ( &maxdouble_val) : );  &maxdouble_val; });}' unless defined(&MAXDOUBLE);
	    eval 'sub MAXFLOAT () {( 3.40e+38);}' unless defined(&MAXFLOAT);
	} else {
	    eval 'sub MAXDOUBLE () {1.79769313486231470e+308;}' unless defined(&MAXDOUBLE);
	    eval 'sub MAXFLOAT () {(3.40282346638528860e+38);}' unless defined(&MAXFLOAT);
	}
	eval 'sub MINDOUBLE () {4.94065645841246544e-324;}' unless defined(&MINDOUBLE);
	eval 'sub MINFLOAT () {(1.40129846432481707e-45);}' unless defined(&MINFLOAT);
	eval 'sub _IEEE () {1;}' unless defined(&_IEEE);
	eval 'sub _DEXPLEN () {11;}' unless defined(&_DEXPLEN);
	eval 'sub _FEXPLEN () {8;}' unless defined(&_FEXPLEN);
	eval 'sub _HIDDENBIT () {1;}' unless defined(&_HIDDENBIT);
	eval 'sub DMINEXP () {(-( &DMAXEXP +  &DSIGNIF -  &_HIDDENBIT - 3));}' unless defined(&DMINEXP);
	eval 'sub FMINEXP () {(-( &FMAXEXP +  &FSIGNIF -  &_HIDDENBIT - 3));}' unless defined(&FMINEXP);
	eval 'sub DMAXEXP () {((1<<  &_DEXPLEN - 1) - 1+  &_IEEE);}' unless defined(&DMAXEXP);
	eval 'sub FMAXEXP () {((1<<  &_FEXPLEN - 1) - 1+  &_IEEE);}' unless defined(&FMAXEXP);
    }
 elsif(defined( &sony)) {
	eval 'sub MAXDOUBLE () {1.79769313486231470e+308;}' unless defined(&MAXDOUBLE);
	eval 'sub MAXFLOAT () {(3.40282346638528860e+38);}' unless defined(&MAXFLOAT);
	eval 'sub MINDOUBLE () {2.2250738585072010e-308;}' unless defined(&MINDOUBLE);
	eval 'sub MINFLOAT () {(1.17549435e-38);}' unless defined(&MINFLOAT);
	eval 'sub _IEEE () {1;}' unless defined(&_IEEE);
	eval 'sub _DEXPLEN () {11;}' unless defined(&_DEXPLEN);
	eval 'sub _FEXPLEN () {8;}' unless defined(&_FEXPLEN);
	eval 'sub _HIDDENBIT () {1;}' unless defined(&_HIDDENBIT);
	eval 'sub DMINEXP () {(-( &DMAXEXP +  &DSIGNIF -  &_HIDDENBIT - 3));}' unless defined(&DMINEXP);
	eval 'sub FMINEXP () {(-( &FMAXEXP +  &FSIGNIF -  &_HIDDENBIT - 3));}' unless defined(&FMINEXP);
	eval 'sub DMAXEXP () {((1<<  &_DEXPLEN - 1) - 1+  &_IEEE);}' unless defined(&DMAXEXP);
	eval 'sub FMAXEXP () {((1<<  &_FEXPLEN - 1) - 1+  &_IEEE);}' unless defined(&FMAXEXP);
    }
 elsif(defined( &sequent)) {
	eval 'sub MAXDOUBLE () { &_maxdouble;}' unless defined(&MAXDOUBLE);
	eval 'sub MAXFLOAT () { &_maxfloat;}' unless defined(&MAXFLOAT);
	eval 'sub MINDOUBLE () { &_mindouble;}' unless defined(&MINDOUBLE);
	eval 'sub MINFLOAT () { &_minfloat;}' unless defined(&MINFLOAT);
	eval 'sub _IEEE () {1;}' unless defined(&_IEEE);
	eval 'sub _DEXPLEN () {11;}' unless defined(&_DEXPLEN);
	eval 'sub _FEXPLEN () {8;}' unless defined(&_FEXPLEN);
	eval 'sub _HIDDENBIT () {1;}' unless defined(&_HIDDENBIT);
	eval 'sub DMINEXP () {(-( &DMAXEXP - 3));}' unless defined(&DMINEXP);
	eval 'sub FMINEXP () {(-( &FMAXEXP - 3));}' unless defined(&FMINEXP);
	eval 'sub DMAXEXP () {((1<<  &_DEXPLEN - 1) - 1+  &_IEEE);}' unless defined(&DMAXEXP);
	eval 'sub FMAXEXP () {((1<<  &_FEXPLEN - 1) - 1+  &_IEEE);}' unless defined(&FMAXEXP);
    }
 elsif(defined( &i386)) {
	eval 'sub MAXDOUBLE () {1.79769313486231570e+308;}' unless defined(&MAXDOUBLE);
	eval 'sub MAXFLOAT () {(3.40282346638528860e+38);}' unless defined(&MAXFLOAT);
	eval 'sub MINDOUBLE () {2.22507385850720140e-308;}' unless defined(&MINDOUBLE);
	eval 'sub MINFLOAT () {(1.17549435082228750e-38);}' unless defined(&MINFLOAT);
	eval 'sub _IEEE () {0;}' unless defined(&_IEEE);
	eval 'sub _DEXPLEN () {11;}' unless defined(&_DEXPLEN);
	eval 'sub _FEXPLEN () {8;}' unless defined(&_FEXPLEN);
	eval 'sub _HIDDENBIT () {1;}' unless defined(&_HIDDENBIT);
	eval 'sub DMINEXP () {(- &DMAXEXP);}' unless defined(&DMINEXP);
	eval 'sub FMINEXP () {(- &FMAXEXP);}' unless defined(&FMINEXP);
	eval 'sub DMAXEXP () {((1<<  &_DEXPLEN - 1) - 1+  &_IEEE);}' unless defined(&DMAXEXP);
	eval 'sub FMAXEXP () {((1<<  &_FEXPLEN - 1) - 1+  &_IEEE);}' unless defined(&FMAXEXP);
    }
 elsif(defined( &m88k)) {
	eval 'sub MAXDOUBLE () {1.79769313486231e+308;}' unless defined(&MAXDOUBLE);
	eval 'sub MAXFLOAT () {(3.40282346638528e+38);}' unless defined(&MAXFLOAT);
	eval 'sub MINDOUBLE () {2.22507385850720e-308;}' unless defined(&MINDOUBLE);
	eval 'sub MINFLOAT () {(1.17549435082228e-38);}' unless defined(&MINFLOAT);
	eval 'sub _IEEE () {1;}' unless defined(&_IEEE);
	eval 'sub _DEXPLEN () {11;}' unless defined(&_DEXPLEN);
	eval 'sub _FEXPLEN () {8;}' unless defined(&_FEXPLEN);
	eval 'sub _HIDDENBIT () {1;}' unless defined(&_HIDDENBIT);
	eval 'sub DMINEXP () {(1- &DMAXEXP);}' unless defined(&DMINEXP);
	eval 'sub FMINEXP () {(1- &FMAXEXP);}' unless defined(&FMINEXP);
	eval 'sub DMAXEXP () {((1<<  &_DEXPLEN - 1) - 1+  &_IEEE);}' unless defined(&DMAXEXP);
	eval 'sub FMAXEXP () {((1<<  &_FEXPLEN - 1) - 1+  &_IEEE);}' unless defined(&FMAXEXP);
    }
 elsif(defined( &convex)) {
	eval 'sub MAXDOUBLE () {8.9884656743115785e+306;}' unless defined(&MAXDOUBLE);
	eval 'sub MAXFLOAT () {( 1.70141173e+38);}' unless defined(&MAXFLOAT);
	eval 'sub MINDOUBLE () {5.5626846462680035e-308;}' unless defined(&MINDOUBLE);
	eval 'sub MINFLOAT () {( 2.93873588e-39);}' unless defined(&MINFLOAT);
	eval 'sub _IEEE () {0;}' unless defined(&_IEEE);
	eval 'sub _DEXPLEN () {11;}' unless defined(&_DEXPLEN);
	eval 'sub _FEXPLEN () {8;}' unless defined(&_FEXPLEN);
	eval 'sub _HIDDENBIT () {1;}' unless defined(&_HIDDENBIT);
	eval 'sub DMINEXP () {(- &DMAXEXP);}' unless defined(&DMINEXP);
	eval 'sub FMINEXP () {(- &FMAXEXP);}' unless defined(&FMINEXP);
	eval 'sub DMAXEXP () {((1<<  &_DEXPLEN - 1) - 1+  &_IEEE);}' unless defined(&DMAXEXP);
	eval 'sub FMAXEXP () {((1<<  &_FEXPLEN - 1) - 1+  &_IEEE);}' unless defined(&FMAXEXP);
    } else {
	eval 'sub MAXDOUBLE () {1.701411834604692293e+38;}' unless defined(&MAXDOUBLE);
	eval 'sub MINDOUBLE () {(2.938735877055718770e-39);}' unless defined(&MINDOUBLE);
	eval 'sub MAXFLOAT () {1.7014117331926443e+38;}' unless defined(&MAXFLOAT);
	eval 'sub MINFLOAT () {2.9387358770557188e-39;}' unless defined(&MINFLOAT);
	eval 'sub _IEEE () {0;}' unless defined(&_IEEE);
	eval 'sub _DEXPLEN () {8;}' unless defined(&_DEXPLEN);
	eval 'sub _FEXPLEN () {8;}' unless defined(&_FEXPLEN);
	eval 'sub _HIDDENBIT () {1;}' unless defined(&_HIDDENBIT);
	eval 'sub DMINEXP () {(- &DMAXEXP);}' unless defined(&DMINEXP);
	eval 'sub FMINEXP () {(- &FMAXEXP);}' unless defined(&FMINEXP);
	eval 'sub DMAXEXP () {((1<<  &_DEXPLEN - 1) - 1+  &_IEEE);}' unless defined(&DMAXEXP);
	eval 'sub FMAXEXP () {((1<<  &_FEXPLEN - 1) - 1+  &_IEEE);}' unless defined(&FMAXEXP);
    }
    eval 'sub DSIGNIF () {( &DOUBLEBITS -  &_DEXPLEN +  &_HIDDENBIT - 1);}' unless defined(&DSIGNIF);
    eval 'sub FSIGNIF () {( &FLOATBITS -  &_FEXPLEN +  &_HIDDENBIT - 1);}' unless defined(&FSIGNIF);
    eval 'sub DMAXPOWTWO () {((1 <<  &LONGBITS -2)*(1 <<  &DSIGNIF -  &LONGBITS +1));}' unless defined(&DMAXPOWTWO);
    eval 'sub FMAXPOWTWO () {((1 <<  &FSIGNIF - 1));}' unless defined(&FMAXPOWTWO);
}
1;
